dojo.provide("dojo.cal.iCalendar");
dojo.require("dojo.lang.common");
dojo.require("dojo.cal.textDirectory");
dojo.require("dojo.date.common");
dojo.require("dojo.date.serialize");
dojo.cal.iCalendar.fromText=function(_1){
var _2=dojo.cal.textDirectory.tokenise(_1);
var _3=[];
for(var i=0,begun=false;i<_2.length;i++){
var _5=_2[i];
if(!begun){
if(_5.name=="BEGIN"&&_5.value=="VCALENDAR"){
begun=true;
var _6=[];
}
}else{
if(_5.name=="END"&&_5.value=="VCALENDAR"){
_3.push(new dojo.cal.iCalendar.VCalendar(_6));
begun=false;
}else{
_6.push(_5);
}
}
}
return _3;
};
dojo.cal.iCalendar.Component=function(_7){
if(!this.name){
this.name="COMPONENT";
}
this.properties=[];
this.components=[];
if(_7){
for(var i=0,context="";i<_7.length;i++){
if(context==""){
if(_7[i].name=="BEGIN"){
context=_7[i].value;
var _9=[];
}else{
this.addProperty(new dojo.cal.iCalendar.Property(_7[i]));
}
}else{
if(_7[i].name=="END"&&_7[i].value==context){
if(context=="VEVENT"){
this.addComponent(new dojo.cal.iCalendar.VEvent(_9));
}else{
if(context=="VTIMEZONE"){
this.addComponent(new dojo.cal.iCalendar.VTimeZone(_9));
}else{
if(context=="VTODO"){
this.addComponent(new dojo.cal.iCalendar.VTodo(_9));
}else{
if(context=="VJOURNAL"){
this.addComponent(new dojo.cal.iCalendar.VJournal(_9));
}else{
if(context=="VFREEBUSY"){
this.addComponent(new dojo.cal.iCalendar.VFreeBusy(_9));
}else{
if(context=="STANDARD"){
this.addComponent(new dojo.cal.iCalendar.Standard(_9));
}else{
if(context=="DAYLIGHT"){
this.addComponent(new dojo.cal.iCalendar.Daylight(_9));
}else{
if(context=="VALARM"){
this.addComponent(new dojo.cal.iCalendar.VAlarm(_9));
}else{
dojo.unimplemented("dojo.cal.iCalendar."+context);
}
}
}
}
}
}
}
}
context="";
}else{
_9.push(_7[i]);
}
}
}
if(this._ValidProperties){
this.postCreate();
}
}
};
dojo.extend(dojo.cal.iCalendar.Component,{addProperty:function(_a){
this.properties.push(_a);
this[_a.name.toLowerCase()]=_a;
},addComponent:function(_b){
this.components.push(_b);
},postCreate:function(){
for(var x=0;x<this._ValidProperties.length;x++){
var _d=this._ValidProperties[x];
var _e=false;
for(var y=0;y<this.properties.length;y++){
var _10=this.properties[y];
var _11=_10.name.toLowerCase();
if(dojo.lang.isArray(_d)){
var _12=false;
for(var z=0;z<_d.length;z++){
var _14=_d[z].name.toLowerCase();
if((this[_14])&&(_14!=_11)){
_12=true;
}
}
if(!_12){
this[_11]=_10;
}
}else{
if(_11==_d.name.toLowerCase()){
_e=true;
if(_d.occurance==1){
this[_11]=_10;
}else{
_e=true;
if(!dojo.lang.isArray(this[_11])){
this[_11]=[];
}
this[_11].push(_10);
}
}
}
}
if(_d.required&&!_e){
dojo.debug("iCalendar - "+this.name+": Required Property not found: "+_d.name);
}
}
if(dojo.lang.isArray(this.rrule)){
for(var x=0;x<this.rrule.length;x++){
var _15=this.rrule[x].value;
this.rrule[x].cache=function(){
};
var _16=_15.split(";");
for(var y=0;y<_16.length;y++){
var _17=_16[y].split("=");
var key=_17[0].toLowerCase();
var val=_17[1];
if((key=="freq")||(key=="interval")||(key=="until")){
this.rrule[x][key]=val;
}else{
var _1a=val.split(",");
this.rrule[x][key]=_1a;
}
}
}
this.recurring=true;
}
},toString:function(){
return "[iCalendar.Component; "+this.name+", "+this.properties.length+" properties, "+this.components.length+" components]";
}});
dojo.cal.iCalendar.Property=function(_1b){
this.name=_1b.name;
this.group=_1b.group;
this.params=_1b.params;
this.value=_1b.value;
};
dojo.extend(dojo.cal.iCalendar.Property,{toString:function(){
return "[iCalenday.Property; "+this.name+": "+this.value+"]";
}});
var _P=function(n,oc,req){
return {name:n,required:(req)?true:false,occurance:(oc=="*"||!oc)?-1:oc};
};
dojo.cal.iCalendar.VCalendar=function(_1f){
this.name="VCALENDAR";
this.recurring=[];
this.nonRecurringEvents=function(){
};
dojo.cal.iCalendar.Component.call(this,_1f);
};
dojo.inherits(dojo.cal.iCalendar.VCalendar,dojo.cal.iCalendar.Component);
dojo.extend(dojo.cal.iCalendar.VCalendar,{addComponent:function(_20){
this.components.push(_20);
if(_20.name.toLowerCase()=="vevent"){
if(_20.rrule){
this.recurring.push(_20);
}else{
var _21=_20.getDate();
var _22=_21.getMonth()+1;
var _23=_22+"-"+_21.getDate()+"-"+_21.getFullYear();
if(!dojo.lang.isArray(this[_23])){
this.nonRecurringEvents[_23]=[];
}
this.nonRecurringEvents[_23].push(_20);
}
}
},preComputeRecurringEvents:function(_24){
var _25=function(){
};
for(var x=0;x<this.recurring.length;x++){
var _27=this.recurring[x].getDates(_24);
for(var y=0;y<_27.length;y++){
var _29=_27[y].getMonth()+1;
var _2a=_29+"-"+_27[y].getDate()+"-"+_27[y].getFullYear();
if(!dojo.lang.isArray(_25[_2a])){
_25[_2a]=[];
}
if(!dojo.lang.inArray(_25[_2a],this.recurring[x])){
_25[_2a].push(this.recurring[x]);
}
}
}
this.recurringEvents=_25;
},getEvents:function(_2b){
var _2c=[];
var _2d=[];
var _2e=[];
var _2f=_2b.getMonth()+1;
var _30=_2f+"-"+_2b.getDate()+"-"+_2b.getFullYear();
if(dojo.lang.isArray(this.nonRecurringEvents[_30])){
_2e=this.nonRecurringEvents[_30];
dojo.debug("Number of nonRecurring Events: "+_2e.length);
}
if(dojo.lang.isArray(this.recurringEvents[_30])){
_2d=this.recurringEvents[_30];
}
_2c=_2d.concat(_2e);
if(_2c.length>0){
return _2c;
}
return null;
}});
var StandardProperties=[_P("dtstart",1,true),_P("tzoffsetto",1,true),_P("tzoffsetfrom",1,true),_P("comment"),_P("rdate"),_P("rrule"),_P("tzname")];
dojo.cal.iCalendar.Standard=function(_31){
this.name="STANDARD";
this._ValidProperties=StandardProperties;
dojo.cal.iCalendar.Component.call(this,_31);
};
dojo.inherits(dojo.cal.iCalendar.Standard,dojo.cal.iCalendar.Component);
var DaylightProperties=[_P("dtstart",1,true),_P("tzoffsetto",1,true),_P("tzoffsetfrom",1,true),_P("comment"),_P("rdate"),_P("rrule"),_P("tzname")];
dojo.cal.iCalendar.Daylight=function(_32){
this.name="DAYLIGHT";
this._ValidProperties=DaylightProperties;
dojo.cal.iCalendar.Component.call(this,_32);
};
dojo.inherits(dojo.cal.iCalendar.Daylight,dojo.cal.iCalendar.Component);
var VEventProperties=[_P("class",1),_P("created",1),_P("description",1),_P("dtstart",1),_P("geo",1),_P("last-mod",1),_P("location",1),_P("organizer",1),_P("priority",1),_P("dtstamp",1),_P("seq",1),_P("status",1),_P("summary",1),_P("transp",1),_P("uid",1),_P("url",1),_P("recurid",1),[_P("dtend",1),_P("duration",1)],_P("attach"),_P("attendee"),_P("categories"),_P("comment"),_P("contact"),_P("exdate"),_P("exrule"),_P("rstatus"),_P("related"),_P("resources"),_P("rdate"),_P("rrule")];
dojo.cal.iCalendar.VEvent=function(_33){
this._ValidProperties=VEventProperties;
this.name="VEVENT";
dojo.cal.iCalendar.Component.call(this,_33);
this.recurring=false;
this.startDate=dojo.date.fromIso8601(this.dtstart.value);
};
dojo.inherits(dojo.cal.iCalendar.VEvent,dojo.cal.iCalendar.Component);
dojo.extend(dojo.cal.iCalendar.VEvent,{getDates:function(_34){
var _35=this.getDate();
var _36=[];
var _37=["su","mo","tu","we","th","fr","sa"];
var _38={"daily":1,"weekly":2,"monthly":3,"yearly":4,"byday":1,"bymonthday":1,"byweekno":2,"bymonth":3,"byyearday":4};
for(var x=0;x<this.rrule.length;x++){
var _3a=this.rrule[x];
var _3b=_3a.freq.toLowerCase();
var _3c=1;
if(_3a.interval>_3c){
_3c=_3a.interval;
}
var set=[];
var _3e=_38[_3b];
if(_3a.until){
var _3f=dojo.date.fromIso8601(_3a.until);
}else{
var _3f=_34;
}
if(_3f>_34){
_3f=_34;
}
if(_35<_3f){
var _40=function(){
};
var _41=function(){
};
_40.length=0;
_41.length=0;
switch(_3b){
case "yearly":
var _42=new Date(_35);
set.push(_42);
while(_42<_3f){
_42.setYear(_42.getFullYear()+_3c);
tmpDate=new Date(_42);
if(tmpDate<_3f){
set.push(tmpDate);
}
}
break;
case "monthly":
_42=new Date(_35);
set.push(_42);
while(_42<_3f){
_42.setMonth(_42.getMonth()+_3c);
var _43=new Date(_42);
if(_43<_3f){
set.push(_43);
}
}
break;
case "weekly":
_42=new Date(_35);
set.push(_42);
while(_42<_3f){
_42.setDate(_42.getDate()+(7*_3c));
var _43=new Date(_42);
if(_43<_3f){
set.push(_43);
}
}
break;
case "daily":
_42=new Date(_35);
set.push(_42);
while(_42<_3f){
_42.setDate(_42.getDate()+_3c);
var _43=new Date(_42);
if(_43<_3f){
set.push(_43);
}
}
break;
}
if((_3a["bymonth"])&&(_38["bymonth"]<_3e)){
for(var z=0;z<_3a["bymonth"].length;z++){
if(z==0){
for(var zz=0;zz<set.length;zz++){
set[zz].setMonth(_3a["bymonth"][z]-1);
}
}else{
var _46=[];
for(var zz=0;zz<set.length;zz++){
var _47=new Date(set[zz]);
_47.setMonth(_3a[z]);
_46.push(_47);
}
tmp=set.concat(_46);
set=tmp;
}
}
}
if(_3a["byweekno"]&&!_3a["bymonth"]){
dojo.debug("TODO: no support for byweekno yet");
}
if(_3a["byyearday"]&&!_3a["bymonth"]&&!_3a["byweekno"]){
if(_3a["byyearday"].length>1){
var _48="([+-]?)([0-9]{1,3})";
for(var z=1;x<_3a["byyearday"].length;z++){
var _49=_3a["byyearday"][z].match(_48);
if(z==1){
for(var zz=0;zz<set.length;zz++){
if(_49[1]=="-"){
dojo.date.setDayOfYear(set[zz],366-_49[2]);
}else{
dojo.date.setDayOfYear(set[zz],_49[2]);
}
}
}else{
var _46=[];
for(var zz=0;zz<set.length;zz++){
var _47=new Date(set[zz]);
if(_49[1]=="-"){
dojo.date.setDayOfYear(_47,366-_49[2]);
}else{
dojo.date.setDayOfYear(_47,_49[2]);
}
_46.push(_47);
}
tmp=set.concat(_46);
set=tmp;
}
}
}
}
if(_3a["bymonthday"]&&(_38["bymonthday"]<_3e)){
if(_3a["bymonthday"].length>0){
var _48="([+-]?)([0-9]{1,3})";
for(var z=0;z<_3a["bymonthday"].length;z++){
var _49=_3a["bymonthday"][z].match(_48);
if(z==0){
for(var zz=0;zz<set.length;zz++){
if(_49[1]=="-"){
if(_49[2]<dojo.date.getDaysInMonth(set[zz])){
set[zz].setDate(dojo.date.getDaysInMonth(set[zz])-_49[2]);
}
}else{
if(_49[2]<dojo.date.getDaysInMonth(set[zz])){
set[zz].setDate(_49[2]);
}
}
}
}else{
var _46=[];
for(var zz=0;zz<set.length;zz++){
var _47=new Date(set[zz]);
if(_49[1]=="-"){
if(_49[2]<dojo.date.getDaysInMonth(set[zz])){
_47.setDate(dojo.date.getDaysInMonth(set[zz])-_49[2]);
}
}else{
if(_49[2]<dojo.date.getDaysInMonth(set[zz])){
_47.setDate(_49[2]);
}
}
_46.push(_47);
}
tmp=set.concat(_46);
set=tmp;
}
}
}
}
if(_3a["byday"]&&(_38["byday"]<_3e)){
if(_3a["bymonth"]){
if(_3a["byday"].length>0){
var _48="([+-]?)([0-9]{0,1}?)([A-Za-z]{1,2})";
for(var z=0;z<_3a["byday"].length;z++){
var _49=_3a["byday"][z].match(_48);
var _4a=_49[2];
var day=_49[3].toLowerCase();
if(z==0){
for(var zz=0;zz<set.length;zz++){
if(_49[1]=="-"){
var _4c=0;
var _4d=dojo.date.getDaysInMonth(set[zz]);
var _4e=1;
set[zz].setDate(_4d);
if(_37[set[zz].getDay()]==day){
_4c++;
_4e=7;
}
_4e=1;
while(_4c<_4a){
set[zz].setDate(set[zz].getDate()-_4e);
if(_37[set[zz].getDay()]==day){
_4c++;
_4e=7;
}
}
}else{
if(_4a){
var _4c=0;
set[zz].setDate(1);
var _4f=1;
if(_37[set[zz].getDay()]==day){
_4c++;
_4f=7;
}
while(_4c<_4a){
set[zz].setDate(set[zz].getDate()+_4f);
if(_37[set[zz].getDay()]==day){
_4c++;
_4f=7;
}
}
}else{
var _4c=0;
var _46=[];
_4d=new Date(set[zz]);
var _50=dojo.date.getDaysInMonth(set[zz]);
_4d.setDate(_50);
set[zz].setDate(1);
if(_37[set[zz].getDay()]==day){
_4c++;
}
var _43=new Date(set[zz]);
_4f=1;
while(_43.getDate()<_4d){
if(_37[_43.getDay()]==day){
_4c++;
if(_4c==1){
set[zz]=_43;
}else{
_46.push(_43);
_43=new Date(_43);
_4f=7;
_43.setDate(_43.getDate()+_4f);
}
}else{
_43.setDate(_43.getDate()+_4f);
}
}
var t=set.concat(_46);
set=t;
}
}
}
}else{
var _46=[];
for(var zz=0;zz<set.length;zz++){
var _47=new Date(set[zz]);
if(_49[1]=="-"){
if(_49[2]<dojo.date.getDaysInMonth(set[zz])){
_47.setDate(dojo.date.getDaysInMonth(set[zz])-_49[2]);
}
}else{
if(_49[2]<dojo.date.getDaysInMonth(set[zz])){
_47.setDate(_49[2]);
}
}
_46.push(_47);
}
tmp=set.concat(_46);
set=tmp;
}
}
}
}else{
dojo.debug("TODO: byday within a yearly rule without a bymonth");
}
}
dojo.debug("TODO: Process BYrules for units larger than frequency");
var tmp=_36.concat(set);
_36=tmp;
}
}
_36.push(_35);
return _36;
},getDate:function(){
return dojo.date.fromIso8601(this.dtstart.value);
}});
var VTimeZoneProperties=[_P("tzid",1,true),_P("last-mod",1),_P("tzurl",1)];
dojo.cal.iCalendar.VTimeZone=function(_53){
this.name="VTIMEZONE";
this._ValidProperties=VTimeZoneProperties;
dojo.cal.iCalendar.Component.call(this,_53);
};
dojo.inherits(dojo.cal.iCalendar.VTimeZone,dojo.cal.iCalendar.Component);
var VTodoProperties=[_P("class",1),_P("completed",1),_P("created",1),_P("description",1),_P("dtstart",1),_P("geo",1),_P("last-mod",1),_P("location",1),_P("organizer",1),_P("percent",1),_P("priority",1),_P("dtstamp",1),_P("seq",1),_P("status",1),_P("summary",1),_P("uid",1),_P("url",1),_P("recurid",1),[_P("due",1),_P("duration",1)],_P("attach"),_P("attendee"),_P("categories"),_P("comment"),_P("contact"),_P("exdate"),_P("exrule"),_P("rstatus"),_P("related"),_P("resources"),_P("rdate"),_P("rrule")];
dojo.cal.iCalendar.VTodo=function(_54){
this.name="VTODO";
this._ValidProperties=VTodoProperties;
dojo.cal.iCalendar.Component.call(this,_54);
};
dojo.inherits(dojo.cal.iCalendar.VTodo,dojo.cal.iCalendar.Component);
var VJournalProperties=[_P("class",1),_P("created",1),_P("description",1),_P("dtstart",1),_P("last-mod",1),_P("organizer",1),_P("dtstamp",1),_P("seq",1),_P("status",1),_P("summary",1),_P("uid",1),_P("url",1),_P("recurid",1),_P("attach"),_P("attendee"),_P("categories"),_P("comment"),_P("contact"),_P("exdate"),_P("exrule"),_P("related"),_P("rstatus"),_P("rdate"),_P("rrule")];
dojo.cal.iCalendar.VJournal=function(_55){
this.name="VJOURNAL";
this._ValidProperties=VJournalProperties;
dojo.cal.iCalendar.Component.call(this,_55);
};
dojo.inherits(dojo.cal.iCalendar.VJournal,dojo.cal.iCalendar.Component);
var VFreeBusyProperties=[_P("contact"),_P("dtstart",1),_P("dtend"),_P("duration"),_P("organizer",1),_P("dtstamp",1),_P("uid",1),_P("url",1),_P("attendee"),_P("comment"),_P("freebusy"),_P("rstatus")];
dojo.cal.iCalendar.VFreeBusy=function(_56){
this.name="VFREEBUSY";
this._ValidProperties=VFreeBusyProperties;
dojo.cal.iCalendar.Component.call(this,_56);
};
dojo.inherits(dojo.cal.iCalendar.VFreeBusy,dojo.cal.iCalendar.Component);
var VAlarmProperties=[[_P("action",1,true),_P("trigger",1,true),[_P("duration",1),_P("repeat",1)],_P("attach",1)],[_P("action",1,true),_P("description",1,true),_P("trigger",1,true),[_P("duration",1),_P("repeat",1)]],[_P("action",1,true),_P("description",1,true),_P("trigger",1,true),_P("summary",1,true),_P("attendee","*",true),[_P("duration",1),_P("repeat",1)],_P("attach",1)],[_P("action",1,true),_P("attach",1,true),_P("trigger",1,true),[_P("duration",1),_P("repeat",1)],_P("description",1)]];
dojo.cal.iCalendar.VAlarm=function(_57){
this.name="VALARM";
this._ValidProperties=VAlarmProperties;
dojo.cal.iCalendar.Component.call(this,_57);
};
dojo.inherits(dojo.cal.iCalendar.VAlarm,dojo.cal.iCalendar.Component);

