dojo.provide("dojo.charting.Plot");
dojo.require("dojo.lang.common");
dojo.require("dojo.charting.Axis");
dojo.require("dojo.charting.Series");
dojo.charting.RenderPlotSeries={Singly:"single",Grouped:"grouped"};
dojo.charting.Plot=function(_1,_2,_3){
var id="dojo-charting-plot-"+dojo.charting.Plot.count++;
this.getId=function(){
return id;
};
this.setId=function(_5){
id=_5;
};
this.axisX=null;
this.axisY=null;
this.series=[];
this.dataNode=null;
this.renderType=dojo.charting.RenderPlotSeries.Singly;
if(_1){
this.setAxis(_1,"x");
}
if(_2){
this.setAxis(_2,"y");
}
if(_3){
for(var i=0;i<_3.length;i++){
this.addSeries(_3[i]);
}
}
};
dojo.charting.Plot.count=0;
dojo.extend(dojo.charting.Plot,{addSeries:function(_7,_8){
if(_7.plotter){
this.series.push(_7);
}else{
this.series.push({data:_7,plotter:_8||dojo.charting.Plotters["Default"]});
}
},setAxis:function(_9,_a){
if(_a.toLowerCase()=="x"){
this.axisX=_9;
}else{
if(_a.toLowerCase()=="y"){
this.axisY=_9;
}
}
},getRanges:function(){
var _b,xmax,ymin,ymax;
_b=ymin=Number.MAX_VALUE;
xmax=ymax=Number.MIN_VALUE;
for(var i=0;i<this.series.length;i++){
var _d=this.series[i].data.evaluate();
for(var j=0;j<_d.length;j++){
var _f=_d[j];
_b=Math.min(_f.x,_b);
ymin=Math.min(_f.y,ymin);
xmax=Math.max(_f.x,xmax);
ymax=Math.max(_f.y,ymax);
}
}
return {x:{upper:xmax,lower:_b},y:{upper:ymax,lower:ymin},toString:function(){
return "[ x:"+xmax+" - "+_b+", y:"+ymax+" - "+ymin+"]";
}};
},destroy:function(){
var _10=this.dataNode;
while(_10&&_10.childNodes&&_10.childNodes.length>0){
_10.removeChild(_10.childNodes[0]);
}
this.dataNode=null;
}});

