dojo.provide("dojo.charting.Series");
dojo.require("dojo.lang.common");
dojo.require("dojo.charting.Plotters");
dojo.charting.Series=function(_1){
var _2=_1||{length:1};
this.dataSource=_2.dataSource||null;
this.bindings={};
this.color=_2.color;
this.label=_2.label;
if(_2.bindings){
for(var p in _2.bindings){
this.addBinding(p,_2.bindings[p]);
}
}
};
dojo.extend(dojo.charting.Series,{bind:function(_4,_5){
this.dataSource=_4;
this.bindings=_5;
},addBinding:function(_6,_7){
this.bindings[_6]=_7;
},evaluate:function(_8){
var _9=[];
var a=this.dataSource.getData();
var l=a.length;
var _c=0;
var _d=l;
if(_8){
if(_8.from){
_c=Math.max(_8.from,0);
if(_8.to){
_d=Math.min(_8.to,_d);
}
}else{
if(_8.length){
if(_8.length<0){
_c=Math.max((_d+length),0);
}else{
_d=Math.min((_c+length),_d);
}
}
}
}
for(var i=_c;i<_d;i++){
var o={src:a[i],series:this};
for(var p in this.bindings){
o[p]=this.dataSource.getField(a[i],this.bindings[p]);
}
_9.push(o);
}
if(typeof (_9[0].x)!="undefined"){
_9.sort(function(a,b){
if(a.x>b.x){
return 1;
}
if(a.x<b.x){
return -1;
}
return 0;
});
}
return _9;
},trends:{createRange:function(_13,len){
var idx=_13.length-1;
var _16=(len||_13.length);
return {"index":idx,"length":_16,"start":Math.max(idx-_16,0)};
},mean:function(_17,len){
var _19=this.createRange(_17,len);
if(_19.index<0){
return 0;
}
var _1a=0;
var _1b=0;
for(var i=_19.index;i>=_19.start;i--){
_1a+=_17[i].y;
_1b++;
}
_1a/=Math.max(_1b,1);
return _1a;
},variance:function(_1d,len){
var _1f=this.createRange(_1d,len);
if(_1f.index<0){
return 0;
}
var _20=0;
var _21=0;
var _22=0;
for(var i=_1f.index;i>=_1f.start;i--){
_20+=_1d[i].y;
_21+=Math.pow(_1d[i].y,2);
_22++;
}
return (_21/_22)-Math.pow(_20/_22,2);
},standardDeviation:function(_24,len){
return Math.sqrt(this.getVariance(_24,len));
},max:function(_26,len){
var _28=this.createRange(_26,len);
if(_28.index<0){
return 0;
}
var max=Number.MIN_VALUE;
for(var i=_28.index;i>=_28.start;i--){
max=Math.max(_26[i].y,max);
}
return max;
},min:function(_2b,len){
var _2d=this.createRange(_2b,len);
if(_2d.index<0){
return 0;
}
var min=Number.MAX_VALUE;
for(var i=_2d.index;i>=_2d.start;i--){
min=Math.min(_2b[i].y,min);
}
return min;
},median:function(_30,len){
var _32=this.createRange(_30,len);
if(_32.index<0){
return 0;
}
var a=[];
for(var i=_32.index;i>=_32.start;i--){
var b=false;
for(var j=0;j<a.length;j++){
if(_30[i].y==a[j]){
b=true;
break;
}
}
if(!b){
a.push(_30[i].y);
}
}
a.sort();
if(a.length>0){
return a[Math.ceil(a.length/2)];
}
return 0;
},mode:function(_37,len){
var _39=this.createRange(_37,len);
if(_39.index<0){
return 0;
}
var o={};
var ret=0;
var _3c=Number.MIN_VALUE;
for(var i=_39.index;i>=_39.start;i--){
if(!o[_37[i].y]){
o[_37[i].y]=1;
}else{
o[_37[i].y]++;
}
}
for(var p in o){
if(_3c<o[p]){
_3c=o[p];
ret=p;
}
}
return ret;
}}});

