dojo.provide("dojo.charting.svg.PlotArea");
dojo.require("dojo.lang.common");
if(dojo.render.svg.capable){
dojo.require("dojo.svg");
dojo.extend(dojo.charting.PlotArea,{initializePlot:function(_1){
_1.destroy();
_1.dataNode=document.createElementNS(dojo.svg.xmlns.svg,"g");
_1.dataNode.setAttribute("id",_1.getId());
return _1.dataNode;
},initialize:function(){
this.destroy();
this.nodes.main=document.createElement("div");
this.nodes.area=document.createElementNS(dojo.svg.xmlns.svg,"svg");
this.nodes.area.setAttribute("id",this.getId());
this.nodes.area.setAttribute("width",this.size.width);
this.nodes.area.setAttribute("height",this.size.height);
this.nodes.main.appendChild(this.nodes.area);
var _2=this.getArea();
var _3=document.createElementNS(dojo.svg.xmlns.svg,"defs");
var _4=document.createElementNS(dojo.svg.xmlns.svg,"clipPath");
_4.setAttribute("id",this.getId()+"-clip");
var _5=document.createElementNS(dojo.svg.xmlns.svg,"rect");
_5.setAttribute("x",_2.left);
_5.setAttribute("y",_2.top);
_5.setAttribute("width",_2.right-_2.left);
_5.setAttribute("height",_2.bottom-_2.top);
_4.appendChild(_5);
_3.appendChild(_4);
this.nodes.area.appendChild(_3);
this.nodes.background=document.createElementNS(dojo.svg.xmlns.svg,"rect");
this.nodes.background.setAttribute("id",this.getId()+"-background");
this.nodes.background.setAttribute("width",this.size.width);
this.nodes.background.setAttribute("height",this.size.height);
this.nodes.background.setAttribute("fill","#fff");
this.nodes.area.appendChild(this.nodes.background);
this.nodes.plots=document.createElementNS(dojo.svg.xmlns.svg,"g");
this.nodes.plots.setAttribute("id",this.getId()+"-plots");
this.nodes.plots.setAttribute("style","clip-path:url(#"+this.getId()+"-clip);");
this.nodes.area.appendChild(this.nodes.plots);
for(var i=0;i<this.plots.length;i++){
this.nodes.plots.appendChild(this.initializePlot(this.plots[i]));
}
this.nodes.axes=document.createElementNS(dojo.svg.xmlns.svg,"g");
this.nodes.axes.setAttribute("id",this.getId()+"-axes");
this.nodes.area.appendChild(this.nodes.axes);
var _7=this.getAxes();
for(var p in _7){
var _9=_7[p];
this.nodes.axes.appendChild(_9.axis.initialize(this,_9.plot,_9.drawAgainst,_9.plane));
}
return this.nodes.main;
}});
}

