dojo.provide("dojo.html.style");
dojo.require("dojo.html.common");
dojo.require("dojo.uri.Uri");
dojo.html.getClass=function(_1){
_1=dojo.byId(_1);
if(!_1){
return "";
}
var cs="";
if(_1.className){
cs=_1.className;
}else{
if(dojo.html.hasAttribute(_1,"class")){
cs=dojo.html.getAttribute(_1,"class");
}
}
return cs.replace(/^\s+|\s+$/g,"");
};
dojo.html.getClasses=function(_3){
var c=dojo.html.getClass(_3);
return (c=="")?[]:c.split(/\s+/g);
};
dojo.html.hasClass=function(_5,_6){
return (new RegExp("(^|\\s+)"+_6+"(\\s+|$)")).test(dojo.html.getClass(_5));
};
dojo.html.prependClass=function(_7,_8){
_8+=" "+dojo.html.getClass(_7);
return dojo.html.setClass(_7,_8);
};
dojo.html.addClass=function(_9,_a){
if(dojo.html.hasClass(_9,_a)){
return false;
}
_a=(dojo.html.getClass(_9)+" "+_a).replace(/^\s+|\s+$/g,"");
return dojo.html.setClass(_9,_a);
};
dojo.html.setClass=function(_b,_c){
_b=dojo.byId(_b);
var cs=new String(_c);
try{
if(typeof _b.className=="string"){
_b.className=cs;
}else{
if(_b.setAttribute){
_b.setAttribute("class",_c);
_b.className=cs;
}else{
return false;
}
}
}
catch(e){
dojo.debug("dojo.html.setClass() failed",e);
}
return true;
};
dojo.html.removeClass=function(_e,_f,_10){
try{
if(!_10){
var _11=dojo.html.getClass(_e).replace(new RegExp("(^|\\s+)"+_f+"(\\s+|$)"),"$1$2");
}else{
var _11=dojo.html.getClass(_e).replace(_f,"");
}
dojo.html.setClass(_e,_11);
}
catch(e){
dojo.debug("dojo.html.removeClass() failed",e);
}
return true;
};
dojo.html.replaceClass=function(_12,_13,_14){
dojo.html.removeClass(_12,_14);
dojo.html.addClass(_12,_13);
};
dojo.html.classMatchType={ContainsAll:0,ContainsAny:1,IsOnly:2};
dojo.html.getElementsByClass=function(_15,_16,_17,_18,_19){
_19=false;
var _1a=dojo.doc();
_16=dojo.byId(_16)||_1a;
var _1b=_15.split(/\s+/g);
var _1c=[];
if(_18!=1&&_18!=2){
_18=0;
}
var _1d=new RegExp("(\\s|^)(("+_1b.join(")|(")+"))(\\s|$)");
var _1e=_1b.join(" ").length;
var _1f=[];
if(!_19&&_1a.evaluate){
var _20=".//"+(_17||"*")+"[contains(";
if(_18!=dojo.html.classMatchType.ContainsAny){
_20+="concat(' ',@class,' '), ' "+_1b.join(" ') and contains(concat(' ',@class,' '), ' ")+" ')";
if(_18==2){
_20+=" and string-length(@class)="+_1e+"]";
}else{
_20+="]";
}
}else{
_20+="concat(' ',@class,' '), ' "+_1b.join(" ') or contains(concat(' ',@class,' '), ' ")+" ')]";
}
var _21=_1a.evaluate(_20,_16,null,XPathResult.ANY_TYPE,null);
var _22=_21.iterateNext();
while(_22){
try{
_1f.push(_22);
_22=_21.iterateNext();
}
catch(e){
break;
}
}
return _1f;
}else{
if(!_17){
_17="*";
}
_1f=_16.getElementsByTagName(_17);
var _23,i=0;
outer:
while(_23=_1f[i++]){
var _24=dojo.html.getClasses(_23);
if(_24.length==0){
continue outer;
}
var _25=0;
for(var j=0;j<_24.length;j++){
if(_1d.test(_24[j])){
if(_18==dojo.html.classMatchType.ContainsAny){
_1c.push(_23);
continue outer;
}else{
_25++;
}
}else{
if(_18==dojo.html.classMatchType.IsOnly){
continue outer;
}
}
}
if(_25==_1b.length){
if((_18==dojo.html.classMatchType.IsOnly)&&(_25==_24.length)){
_1c.push(_23);
}else{
if(_18==dojo.html.classMatchType.ContainsAll){
_1c.push(_23);
}
}
}
}
return _1c;
}
};
dojo.html.getElementsByClassName=dojo.html.getElementsByClass;
dojo.html.toCamelCase=function(_27){
var arr=_27.split("-"),cc=arr[0];
for(var i=1;i<arr.length;i++){
cc+=arr[i].charAt(0).toUpperCase()+arr[i].substring(1);
}
return cc;
};
dojo.html.toSelectorCase=function(_2a){
return _2a.replace(/([A-Z])/g,"-$1").toLowerCase();
};
dojo.html.getComputedStyle=function(_2b,_2c,_2d){
_2b=dojo.byId(_2b);
var _2c=dojo.html.toSelectorCase(_2c);
var _2e=dojo.html.toCamelCase(_2c);
if(!_2b||!_2b.style){
return _2d;
}else{
if(document.defaultView&&dojo.html.isDescendantOf(_2b,_2b.ownerDocument)){
try{
var cs=document.defaultView.getComputedStyle(_2b,"");
if(cs){
return cs.getPropertyValue(_2c);
}
}
catch(e){
if(_2b.style.getPropertyValue){
return _2b.style.getPropertyValue(_2c);
}else{
return _2d;
}
}
}else{
if(_2b.currentStyle){
return _2b.currentStyle[_2e];
}
}
}
if(_2b.style.getPropertyValue){
return _2b.style.getPropertyValue(_2c);
}else{
return _2d;
}
};
dojo.html.getStyleProperty=function(_30,_31){
_30=dojo.byId(_30);
return (_30&&_30.style?_30.style[dojo.html.toCamelCase(_31)]:undefined);
};
dojo.html.getStyle=function(_32,_33){
var _34=dojo.html.getStyleProperty(_32,_33);
return (_34?_34:dojo.html.getComputedStyle(_32,_33));
};
dojo.html.setStyle=function(_35,_36,_37){
_35=dojo.byId(_35);
if(_35&&_35.style){
var _38=dojo.html.toCamelCase(_36);
_35.style[_38]=_37;
}
};
dojo.html.setStyleText=function(_39,_3a){
try{
_39.style.cssText=_3a;
}
catch(e){
_39.setAttribute("style",_3a);
}
};
dojo.html.copyStyle=function(_3b,_3c){
if(!_3c.style.cssText){
_3b.setAttribute("style",_3c.getAttribute("style"));
}else{
_3b.style.cssText=_3c.style.cssText;
}
dojo.html.addClass(_3b,dojo.html.getClass(_3c));
};
dojo.html.getUnitValue=function(_3d,_3e,_3f){
var s=dojo.html.getComputedStyle(_3d,_3e);
if((!s)||((s=="auto")&&(_3f))){
return {value:0,units:"px"};
}
var _41=s.match(/(\-?[\d.]+)([a-z%]*)/i);
if(!_41){
return dojo.html.getUnitValue.bad;
}
return {value:Number(_41[1]),units:_41[2].toLowerCase()};
};
dojo.html.getUnitValue.bad={value:NaN,units:""};
dojo.html.getPixelValue=function(_42,_43,_44){
var _45=dojo.html.getUnitValue(_42,_43,_44);
if(isNaN(_45.value)){
return 0;
}
if((_45.value)&&(_45.units!="px")){
return NaN;
}
return _45.value;
};
dojo.html.setPositivePixelValue=function(_46,_47,_48){
if(isNaN(_48)){
return false;
}
_46.style[_47]=Math.max(0,_48)+"px";
return true;
};
dojo.html.styleSheet=null;
dojo.html.insertCssRule=function(_49,_4a,_4b){
if(!dojo.html.styleSheet){
if(document.createStyleSheet){
dojo.html.styleSheet=document.createStyleSheet();
}else{
if(document.styleSheets[0]){
dojo.html.styleSheet=document.styleSheets[0];
}else{
return null;
}
}
}
if(arguments.length<3){
if(dojo.html.styleSheet.cssRules){
_4b=dojo.html.styleSheet.cssRules.length;
}else{
if(dojo.html.styleSheet.rules){
_4b=dojo.html.styleSheet.rules.length;
}else{
return null;
}
}
}
if(dojo.html.styleSheet.insertRule){
var _4c=_49+" { "+_4a+" }";
return dojo.html.styleSheet.insertRule(_4c,_4b);
}else{
if(dojo.html.styleSheet.addRule){
return dojo.html.styleSheet.addRule(_49,_4a,_4b);
}else{
return null;
}
}
};
dojo.html.removeCssRule=function(_4d){
if(!dojo.html.styleSheet){
dojo.debug("no stylesheet defined for removing rules");
return false;
}
if(dojo.render.html.ie){
if(!_4d){
_4d=dojo.html.styleSheet.rules.length;
dojo.html.styleSheet.removeRule(_4d);
}
}else{
if(document.styleSheets[0]){
if(!_4d){
_4d=dojo.html.styleSheet.cssRules.length;
}
dojo.html.styleSheet.deleteRule(_4d);
}
}
return true;
};
dojo.html._insertedCssFiles=[];
dojo.html.insertCssFile=function(URI,doc,_50,_51){
if(!URI){
return;
}
if(!doc){
doc=document;
}
var _52=dojo.hostenv.getText(URI,false,_51);
if(_52===null){
return;
}
_52=dojo.html.fixPathsInCssText(_52,URI);
if(_50){
var idx=-1,node,ent=dojo.html._insertedCssFiles;
for(var i=0;i<ent.length;i++){
if((ent[i].doc==doc)&&(ent[i].cssText==_52)){
idx=i;
node=ent[i].nodeRef;
break;
}
}
if(node){
var _55=doc.getElementsByTagName("style");
for(var i=0;i<_55.length;i++){
if(_55[i]==node){
return;
}
}
dojo.html._insertedCssFiles.shift(idx,1);
}
}
var _56=dojo.html.insertCssText(_52,doc);
dojo.html._insertedCssFiles.push({"doc":doc,"cssText":_52,"nodeRef":_56});
if(_56&&djConfig.isDebug){
_56.setAttribute("dbgHref",URI);
}
return _56;
};
dojo.html.insertCssText=function(_57,doc,URI){
if(!_57){
return;
}
if(!doc){
doc=document;
}
if(URI){
_57=dojo.html.fixPathsInCssText(_57,URI);
}
var _5a=doc.createElement("style");
_5a.setAttribute("type","text/css");
var _5b=doc.getElementsByTagName("head")[0];
if(!_5b){
dojo.debug("No head tag in document, aborting styles");
return;
}else{
_5b.appendChild(_5a);
}
if(_5a.styleSheet){
var _5c=function(){
try{
_5a.styleSheet.cssText=_57;
}
catch(e){
dojo.debug(e);
}
};
if(_5a.styleSheet.disabled){
setTimeout(_5c,10);
}else{
_5c();
}
}else{
var _5d=doc.createTextNode(_57);
_5a.appendChild(_5d);
}
return _5a;
};
dojo.html.fixPathsInCssText=function(_5e,URI){
if(!_5e||!URI){
return;
}
var _60,str="",url="",urlChrs="[\\t\\s\\w\\(\\)\\/\\.\\\\'\"-:#=&?~]+";
var _61=new RegExp("url\\(\\s*("+urlChrs+")\\s*\\)");
var _62=/(file|https?|ftps?):\/\//;
regexTrim=new RegExp("^[\\s]*(['\"]?)("+urlChrs+")\\1[\\s]*?$");
if(dojo.render.html.ie55||dojo.render.html.ie60){
var _63=new RegExp("AlphaImageLoader\\((.*)src=['\"]("+urlChrs+")['\"]");
while(_60=_63.exec(_5e)){
url=_60[2].replace(regexTrim,"$2");
if(!_62.exec(url)){
url=(new dojo.uri.Uri(URI,url).toString());
}
str+=_5e.substring(0,_60.index)+"AlphaImageLoader("+_60[1]+"src='"+url+"'";
_5e=_5e.substr(_60.index+_60[0].length);
}
_5e=str+_5e;
str="";
}
while(_60=_61.exec(_5e)){
url=_60[1].replace(regexTrim,"$2");
if(!_62.exec(url)){
url=(new dojo.uri.Uri(URI,url).toString());
}
str+=_5e.substring(0,_60.index)+"url("+url+")";
_5e=_5e.substr(_60.index+_60[0].length);
}
return str+_5e;
};
dojo.html.setActiveStyleSheet=function(_64){
var i=0,a,els=dojo.doc().getElementsByTagName("link");
while(a=els[i++]){
if(a.getAttribute("rel").indexOf("style")!=-1&&a.getAttribute("title")){
a.disabled=true;
if(a.getAttribute("title")==_64){
a.disabled=false;
}
}
}
};
dojo.html.getActiveStyleSheet=function(){
var i=0,a,els=dojo.doc().getElementsByTagName("link");
while(a=els[i++]){
if(a.getAttribute("rel").indexOf("style")!=-1&&a.getAttribute("title")&&!a.disabled){
return a.getAttribute("title");
}
}
return null;
};
dojo.html.getPreferredStyleSheet=function(){
var i=0,a,els=dojo.doc().getElementsByTagName("link");
while(a=els[i++]){
if(a.getAttribute("rel").indexOf("style")!=-1&&a.getAttribute("rel").indexOf("alt")==-1&&a.getAttribute("title")){
return a.getAttribute("title");
}
}
return null;
};
dojo.html.applyBrowserClass=function(_68){
var drh=dojo.render.html;
var _6a={dj_ie:drh.ie,dj_ie55:drh.ie55,dj_ie6:drh.ie60,dj_ie7:drh.ie70,dj_iequirks:drh.ie&&drh.quirks,dj_opera:drh.opera,dj_opera8:drh.opera&&(Math.floor(dojo.render.version)==8),dj_opera9:drh.opera&&(Math.floor(dojo.render.version)==9),dj_khtml:drh.khtml,dj_safari:drh.safari,dj_gecko:drh.mozilla};
for(var p in _6a){
if(_6a[p]){
dojo.html.addClass(_68,p);
}
}
};

