dojo.provide("dojo.lfx.Animation");
dojo.require("dojo.lang.func");
dojo.lfx.Line=function(_1,_2){
this.start=_1;
this.end=_2;
if(dojo.lang.isArray(_1)){
var _3=[];
dojo.lang.forEach(this.start,function(s,i){
_3[i]=this.end[i]-s;
},this);
this.getValue=function(n){
var _7=[];
dojo.lang.forEach(this.start,function(s,i){
_7[i]=(_3[i]*n)+s;
},this);
return _7;
};
}else{
var _3=_2-_1;
this.getValue=function(n){
return (_3*n)+this.start;
};
}
};
dojo.lfx.easeDefault=function(n){
if(dojo.render.html.khtml){
return (parseFloat("0.5")+((Math.sin((n+parseFloat("1.5"))*Math.PI))/2));
}else{
return (0.5+((Math.sin((n+1.5)*Math.PI))/2));
}
};
dojo.lfx.easeIn=function(n){
return Math.pow(n,3);
};
dojo.lfx.easeOut=function(n){
return (1-Math.pow(1-n,3));
};
dojo.lfx.easeInOut=function(n){
return ((3*Math.pow(n,2))-(2*Math.pow(n,3)));
};
dojo.lfx.IAnimation=function(){
};
dojo.lang.extend(dojo.lfx.IAnimation,{curve:null,duration:1000,easing:null,repeatCount:0,rate:25,handler:null,beforeBegin:null,onBegin:null,onAnimate:null,onEnd:null,onPlay:null,onPause:null,onStop:null,play:null,pause:null,stop:null,connect:function(_f,_10,_11){
if(!_11){
_11=_10;
_10=this;
}
_11=dojo.lang.hitch(_10,_11);
var _12=this[_f]||function(){
};
this[_f]=function(){
var ret=_12.apply(this,arguments);
_11.apply(this,arguments);
return ret;
};
return this;
},fire:function(evt,_15){
if(this[evt]){
this[evt].apply(this,(_15||[]));
}
return this;
},repeat:function(_16){
this.repeatCount=_16;
return this;
},_active:false,_paused:false});
dojo.lfx.Animation=function(_17,_18,_19,_1a,_1b,_1c){
dojo.lfx.IAnimation.call(this);
if(dojo.lang.isNumber(_17)||(!_17&&_18.getValue)){
_1c=_1b;
_1b=_1a;
_1a=_19;
_19=_18;
_18=_17;
_17=null;
}else{
if(_17.getValue||dojo.lang.isArray(_17)){
_1c=_1a;
_1b=_19;
_1a=_18;
_19=_17;
_18=null;
_17=null;
}
}
if(dojo.lang.isArray(_19)){
this.curve=new dojo.lfx.Line(_19[0],_19[1]);
}else{
this.curve=_19;
}
if(_18!=null&&_18>0){
this.duration=_18;
}
if(_1b){
this.repeatCount=_1b;
}
if(_1c){
this.rate=_1c;
}
if(_17){
dojo.lang.forEach(["handler","beforeBegin","onBegin","onEnd","onPlay","onStop","onAnimate"],function(_1d){
if(_17[_1d]){
this.connect(_1d,_17[_1d]);
}
},this);
}
if(_1a&&dojo.lang.isFunction(_1a)){
this.easing=_1a;
}
};
dojo.inherits(dojo.lfx.Animation,dojo.lfx.IAnimation);
dojo.lang.extend(dojo.lfx.Animation,{_startTime:null,_endTime:null,_timer:null,_percent:0,_startRepeatCount:0,play:function(_1e,_1f){
if(_1f){
clearTimeout(this._timer);
this._active=false;
this._paused=false;
this._percent=0;
}else{
if(this._active&&!this._paused){
return this;
}
}
this.fire("handler",["beforeBegin"]);
this.fire("beforeBegin");
if(_1e>0){
setTimeout(dojo.lang.hitch(this,function(){
this.play(null,_1f);
}),_1e);
return this;
}
this._startTime=new Date().valueOf();
if(this._paused){
this._startTime-=(this.duration*this._percent/100);
}
this._endTime=this._startTime+this.duration;
this._active=true;
this._paused=false;
var _20=this._percent/100;
var _21=this.curve.getValue(_20);
if(this._percent==0){
if(!this._startRepeatCount){
this._startRepeatCount=this.repeatCount;
}
this.fire("handler",["begin",_21]);
this.fire("onBegin",[_21]);
}
this.fire("handler",["play",_21]);
this.fire("onPlay",[_21]);
this._cycle();
return this;
},pause:function(){
clearTimeout(this._timer);
if(!this._active){
return this;
}
this._paused=true;
var _22=this.curve.getValue(this._percent/100);
this.fire("handler",["pause",_22]);
this.fire("onPause",[_22]);
return this;
},gotoPercent:function(pct,_24){
clearTimeout(this._timer);
this._active=true;
this._paused=true;
this._percent=pct;
if(_24){
this.play();
}
return this;
},stop:function(_25){
clearTimeout(this._timer);
var _26=this._percent/100;
if(_25){
_26=1;
}
var _27=this.curve.getValue(_26);
this.fire("handler",["stop",_27]);
this.fire("onStop",[_27]);
this._active=false;
this._paused=false;
return this;
},status:function(){
if(this._active){
return this._paused?"paused":"playing";
}else{
return "stopped";
}
return this;
},_cycle:function(){
clearTimeout(this._timer);
if(this._active){
var _28=new Date().valueOf();
var _29=(_28-this._startTime)/(this._endTime-this._startTime);
if(_29>=1){
_29=1;
this._percent=100;
}else{
this._percent=_29*100;
}
if((this.easing)&&(dojo.lang.isFunction(this.easing))){
_29=this.easing(_29);
}
var _2a=this.curve.getValue(_29);
this.fire("handler",["animate",_2a]);
this.fire("onAnimate",[_2a]);
if(_29<1){
this._timer=setTimeout(dojo.lang.hitch(this,"_cycle"),this.rate);
}else{
this._active=false;
this.fire("handler",["end"]);
this.fire("onEnd");
if(this.repeatCount>0){
this.repeatCount--;
this.play(null,true);
}else{
if(this.repeatCount==-1){
this.play(null,true);
}else{
if(this._startRepeatCount){
this.repeatCount=this._startRepeatCount;
this._startRepeatCount=0;
}
}
}
}
}
return this;
}});
dojo.lfx.Combine=function(_2b){
dojo.lfx.IAnimation.call(this);
this._anims=[];
this._animsEnded=0;
var _2c=arguments;
if(_2c.length==1&&(dojo.lang.isArray(_2c[0])||dojo.lang.isArrayLike(_2c[0]))){
_2c=_2c[0];
}
dojo.lang.forEach(_2c,function(_2d){
this._anims.push(_2d);
_2d.connect("onEnd",dojo.lang.hitch(this,"_onAnimsEnded"));
},this);
};
dojo.inherits(dojo.lfx.Combine,dojo.lfx.IAnimation);
dojo.lang.extend(dojo.lfx.Combine,{_animsEnded:0,play:function(_2e,_2f){
if(!this._anims.length){
return this;
}
this.fire("beforeBegin");
if(_2e>0){
setTimeout(dojo.lang.hitch(this,function(){
this.play(null,_2f);
}),_2e);
return this;
}
if(_2f||this._anims[0].percent==0){
this.fire("onBegin");
}
this.fire("onPlay");
this._animsCall("play",null,_2f);
return this;
},pause:function(){
this.fire("onPause");
this._animsCall("pause");
return this;
},stop:function(_30){
this.fire("onStop");
this._animsCall("stop",_30);
return this;
},_onAnimsEnded:function(){
this._animsEnded++;
if(this._animsEnded>=this._anims.length){
this.fire("onEnd");
}
return this;
},_animsCall:function(_31){
var _32=[];
if(arguments.length>1){
for(var i=1;i<arguments.length;i++){
_32.push(arguments[i]);
}
}
var _34=this;
dojo.lang.forEach(this._anims,function(_35){
_35[_31](_32);
},_34);
return this;
}});
dojo.lfx.Chain=function(_36){
dojo.lfx.IAnimation.call(this);
this._anims=[];
this._currAnim=-1;
var _37=arguments;
if(_37.length==1&&(dojo.lang.isArray(_37[0])||dojo.lang.isArrayLike(_37[0]))){
_37=_37[0];
}
var _38=this;
dojo.lang.forEach(_37,function(_39,i,_3b){
this._anims.push(_39);
if(i<_3b.length-1){
_39.connect("onEnd",dojo.lang.hitch(this,"_playNext"));
}else{
_39.connect("onEnd",dojo.lang.hitch(this,function(){
this.fire("onEnd");
}));
}
},this);
};
dojo.inherits(dojo.lfx.Chain,dojo.lfx.IAnimation);
dojo.lang.extend(dojo.lfx.Chain,{_currAnim:-1,play:function(_3c,_3d){
if(!this._anims.length){
return this;
}
if(_3d||!this._anims[this._currAnim]){
this._currAnim=0;
}
var _3e=this._anims[this._currAnim];
this.fire("beforeBegin");
if(_3c>0){
setTimeout(dojo.lang.hitch(this,function(){
this.play(null,_3d);
}),_3c);
return this;
}
if(_3e){
if(this._currAnim==0){
this.fire("handler",["begin",this._currAnim]);
this.fire("onBegin",[this._currAnim]);
}
this.fire("onPlay",[this._currAnim]);
_3e.play(null,_3d);
}
return this;
},pause:function(){
if(this._anims[this._currAnim]){
this._anims[this._currAnim].pause();
this.fire("onPause",[this._currAnim]);
}
return this;
},playPause:function(){
if(this._anims.length==0){
return this;
}
if(this._currAnim==-1){
this._currAnim=0;
}
var _3f=this._anims[this._currAnim];
if(_3f){
if(!_3f._active||_3f._paused){
this.play();
}else{
this.pause();
}
}
return this;
},stop:function(){
var _40=this._anims[this._currAnim];
if(_40){
_40.stop();
this.fire("onStop",[this._currAnim]);
}
return _40;
},_playNext:function(){
if(this._currAnim==-1||this._anims.length==0){
return this;
}
this._currAnim++;
if(this._anims[this._currAnim]){
this._anims[this._currAnim].play(null,true);
}
return this;
}});
dojo.lfx.combine=function(_41){
var _42=arguments;
if(dojo.lang.isArray(arguments[0])){
_42=arguments[0];
}
if(_42.length==1){
return _42[0];
}
return new dojo.lfx.Combine(_42);
};
dojo.lfx.chain=function(_43){
var _44=arguments;
if(dojo.lang.isArray(arguments[0])){
_44=arguments[0];
}
if(_44.length==1){
return _44[0];
}
return new dojo.lfx.Chain(_44);
};

