dojo.provide("dojo.storage.browser");
dojo.require("dojo.storage");
dojo.require("dojo.flash");
dojo.require("dojo.json");
dojo.require("dojo.uri.*");
dojo.storage.browser.WhatWGStorageProvider=function(){
};
dojo.inherits(dojo.storage.browser.WhatWGStorageProvider,dojo.storage);
dojo.lang.extend(dojo.storage.browser.WhatWGStorageProvider,{namespace:"default",initialized:false,_domain:null,_available:null,_statusHandler:null,initialize:function(){
if(djConfig["disableWhatWGStorage"]==true){
return;
}
this._domain=location.hostname;
this.initialized=true;
dojo.storage.manager.loaded();
},isAvailable:function(){
try{
var _1=globalStorage[location.hostname];
}
catch(e){
this._available=false;
return this._available;
}
this._available=true;
return this._available;
},put:function(_2,_3,_4){
if(this.isValidKey(_2)==false){
dojo.raise("Invalid key given: "+_2);
}
this._statusHandler=_4;
if(dojo.lang.isString(_3)){
_3="string:"+_3;
}else{
_3=dojo.json.serialize(_3);
}
window.addEventListener("storage",function(_5){
_4.call(null,dojo.storage.SUCCESS,_2);
},false);
try{
var _6=globalStorage[this._domain];
_6.setItem(_2,_3);
}
catch(e){
this._statusHandler.call(null,dojo.storage.FAILED,_2,e.toString());
}
},get:function(_7){
if(this.isValidKey(_7)==false){
dojo.raise("Invalid key given: "+_7);
}
var _8=globalStorage[this._domain];
var _9=_8.getItem(_7);
if(_9==null){
return null;
}
_9=_9.value;
if(!dojo.lang.isUndefined(_9)&&_9!=null&&/^string:/.test(_9)){
_9=_9.substring("string:".length);
}else{
_9=dojo.json.evalJson(_9);
}
return _9;
},getKeys:function(){
var _a=globalStorage[this._domain];
var _b=new Array();
for(i=0;i<_a.length;i++){
_b[i]=_a.key(i);
}
return _b;
},clear:function(){
var _c=globalStorage[this._domain];
var _d=new Array();
for(var i=0;i<_c.length;i++){
_d[_d.length]=_c.key(i);
}
for(var i=0;i<_d.length;i++){
_c.removeItem(_d[i]);
}
},remove:function(_f){
var _10=globalStorage[this._domain];
_10.removeItem(_f);
},isPermanent:function(){
return true;
},getMaximumSize:function(){
return dojo.storage.SIZE_NO_LIMIT;
},hasSettingsUI:function(){
return false;
},showSettingsUI:function(){
dojo.raise(this.getType()+" does not support a storage settings user-interface");
},hideSettingsUI:function(){
dojo.raise(this.getType()+" does not support a storage settings user-interface");
},getType:function(){
return "dojo.storage.browser.WhatWGStorageProvider";
}});
dojo.storage.browser.FlashStorageProvider=function(){
};
dojo.inherits(dojo.storage.browser.FlashStorageProvider,dojo.storage);
dojo.lang.extend(dojo.storage.browser.FlashStorageProvider,{namespace:"default",initialized:false,_available:null,_statusHandler:null,initialize:function(){
if(djConfig["disableFlashStorage"]==true){
return;
}
var _11=function(){
dojo.storage._flashLoaded();
};
dojo.flash.addLoadedListener(_11);
var _12=dojo.uri.dojoUri("Storage_version6.swf").toString();
var _13=dojo.uri.dojoUri("Storage_version8.swf").toString();
dojo.flash.setSwf({flash6:_12,flash8:_13,visible:false});
},isAvailable:function(){
if(djConfig["disableFlashStorage"]==true){
this._available=false;
}else{
this._available=true;
}
return this._available;
},put:function(key,_15,_16){
if(this.isValidKey(key)==false){
dojo.raise("Invalid key given: "+key);
}
this._statusHandler=_16;
if(dojo.lang.isString(_15)){
_15="string:"+_15;
}else{
_15=dojo.json.serialize(_15);
}
dojo.flash.comm.put(key,_15,this.namespace);
},get:function(key){
if(this.isValidKey(key)==false){
dojo.raise("Invalid key given: "+key);
}
var _18=dojo.flash.comm.get(key,this.namespace);
if(_18==""){
return null;
}
if(!dojo.lang.isUndefined(_18)&&_18!=null&&/^string:/.test(_18)){
_18=_18.substring("string:".length);
}else{
_18=dojo.json.evalJson(_18);
}
return _18;
},getKeys:function(){
var _19=dojo.flash.comm.getKeys(this.namespace);
if(_19==""){
return [];
}
return _19.split(",");
},clear:function(){
dojo.flash.comm.clear(this.namespace);
},remove:function(key){
dojo.unimplemented("dojo.storage.browser.FlashStorageProvider.remove");
},isPermanent:function(){
return true;
},getMaximumSize:function(){
return dojo.storage.SIZE_NO_LIMIT;
},hasSettingsUI:function(){
return true;
},showSettingsUI:function(){
dojo.flash.comm.showSettings();
dojo.flash.obj.setVisible(true);
dojo.flash.obj.center();
},hideSettingsUI:function(){
dojo.flash.obj.setVisible(false);
if(dojo.storage.onHideSettingsUI!=null&&!dojo.lang.isUndefined(dojo.storage.onHideSettingsUI)){
dojo.storage.onHideSettingsUI.call(null);
}
},getType:function(){
return "dojo.storage.browser.FlashStorageProvider";
},_flashLoaded:function(){
this._initialized=true;
dojo.storage.manager.loaded();
},_onStatus:function(_1b,key){
var ds=dojo.storage;
var dfo=dojo.flash.obj;
if(_1b==ds.PENDING){
dfo.center();
dfo.setVisible(true);
}else{
dfo.setVisible(false);
}
if((!dj_undef("_statusHandler",ds))&&(ds._statusHandler!=null)){
ds._statusHandler.call(null,_1b,key);
}
}});
dojo.storage.manager.register("dojo.storage.browser.WhatWGStorageProvider",new dojo.storage.browser.WhatWGStorageProvider());
dojo.storage.manager.register("dojo.storage.browser.FlashStorageProvider",new dojo.storage.browser.FlashStorageProvider());
dojo.storage.manager.initialize();

