dojo.provide("dojo.svg");
dojo.require("dojo.lang.common");
dojo.require("dojo.dom");
dojo.mixin(dojo.svg,dojo.dom);
dojo.svg.graphics=dojo.svg.g=new function(d){
this.suspend=function(){
try{
d.documentElement.suspendRedraw(0);
}
catch(e){
}
};
this.resume=function(){
try{
d.documentElement.unsuspendRedraw(0);
}
catch(e){
}
};
this.force=function(){
try{
d.documentElement.forceRedraw();
}
catch(e){
}
};
}(document);
dojo.svg.animations=dojo.svg.anim=new function(d){
this.arePaused=function(){
try{
return d.documentElement.animationsPaused();
}
catch(e){
return false;
}
};
this.pause=function(){
try{
d.documentElement.pauseAnimations();
}
catch(e){
}
};
this.resume=function(){
try{
d.documentElement.unpauseAnimations();
}
catch(e){
}
};
}(document);
dojo.svg.toCamelCase=function(_3){
var _4=_3.split("-"),cc=_4[0];
for(var i=1;i<_4.length;i++){
cc+=_4[i].charAt(0).toUpperCase()+_4[i].substring(1);
}
return cc;
};
dojo.svg.toSelectorCase=function(_6){
return _6.replace(/([A-Z])/g,"-$1").toLowerCase();
};
dojo.svg.getStyle=function(_7,_8){
return document.defaultView.getComputedStyle(_7,_8);
};
dojo.svg.getNumericStyle=function(_9,_a){
return parseFloat(dojo.svg.getStyle(_9,_a));
};
dojo.svg.getOpacity=function(_b){
return Math.min(1,dojo.svg.getNumericStyle(_b,"fill-opacity"));
};
dojo.svg.setOpacity=function(_c,_d){
_c.setAttributeNS(this.xmlns.svg,"fill-opacity",_d);
_c.setAttributeNS(this.xmlns.svg,"stroke-opacity",_d);
};
dojo.svg.clearOpacity=function(_e){
_e.setAttributeNS(this.xmlns.svg,"fill-opacity","1.0");
_e.setAttributeNS(this.xmlns.svg,"stroke-opacity","1.0");
};
dojo.svg.getCoords=function(_f){
if(_f.getBBox){
var box=_f.getBBox();
return {x:box.x,y:box.y};
}
return null;
};
dojo.svg.setCoords=function(_11,_12){
var p=dojo.svg.getCoords();
if(!p){
return;
}
var dx=p.x-_12.x;
var dy=p.y-_12.y;
dojo.svg.translate(_11,dx,dy);
};
dojo.svg.getDimensions=function(_16){
if(_16.getBBox){
var box=_16.getBBox();
return {width:box.width,height:box.height};
}
return null;
};
dojo.svg.setDimensions=function(_18,dim){
if(_18.width){
_18.width.baseVal.value=dim.width;
_18.height.baseVal.value=dim.height;
}else{
if(_18.r){
_18.r.baseVal.value=Math.min(dim.width,dim.height)/2;
}else{
if(_18.rx){
_18.rx.baseVal.value=dim.width/2;
_18.ry.baseVal.value=dim.height/2;
}
}
}
};
dojo.svg.translate=function(_1a,dx,dy){
if(_1a.transform&&_1a.ownerSVGElement&&_1a.ownerSVGElement.createSVGTransform){
var t=_1a.ownerSVGElement.createSVGTransform();
t.setTranslate(dx,dy);
_1a.transform.baseVal.appendItem(t);
}
};
dojo.svg.scale=function(_1e,_1f,_20){
if(!_20){
var _20=_1f;
}
if(_1e.transform&&_1e.ownerSVGElement&&_1e.ownerSVGElement.createSVGTransform){
var t=_1e.ownerSVGElement.createSVGTransform();
t.setScale(_1f,_20);
_1e.transform.baseVal.appendItem(t);
}
};
dojo.svg.rotate=function(_22,ang,cx,cy){
if(_22.transform&&_22.ownerSVGElement&&_22.ownerSVGElement.createSVGTransform){
var t=_22.ownerSVGElement.createSVGTransform();
if(cx==null){
t.setMatrix(t.matrix.rotate(ang));
}else{
t.setRotate(ang,cx,cy);
}
_22.transform.baseVal.appendItem(t);
}
};
dojo.svg.skew=function(_27,ang,_29){
var dir=_29||"x";
if(_27.transform&&_27.ownerSVGElement&&_27.ownerSVGElement.createSVGTransform){
var t=_27.ownerSVGElement.createSVGTransform();
if(dir!="x"){
t.setSkewY(ang);
}else{
t.setSkewX(ang);
}
_27.transform.baseVal.appendItem(t);
}
};
dojo.svg.flip=function(_2c,_2d){
var dir=_2d||"x";
if(_2c.transform&&_2c.ownerSVGElement&&_2c.ownerSVGElement.createSVGTransform){
var t=_2c.ownerSVGElement.createSVGTransform();
t.setMatrix((dir!="x")?t.matrix.flipY():t.matrix.flipX());
_2c.transform.baseVal.appendItem(t);
}
};
dojo.svg.invert=function(_30){
if(_30.transform&&_30.ownerSVGElement&&_30.ownerSVGElement.createSVGTransform){
var t=_30.ownerSVGElement.createSVGTransform();
t.setMatrix(t.matrix.inverse());
_30.transform.baseVal.appendItem(t);
}
};
dojo.svg.applyMatrix=function(_32,a,b,c,d,e,f){
if(_32.transform&&_32.ownerSVGElement&&_32.ownerSVGElement.createSVGTransform){
var m;
if(b){
var m=_32.ownerSVGElement.createSVGMatrix();
m.a=a;
m.b=b;
m.c=c;
m.d=d;
m.e=e;
m.f=f;
}else{
m=a;
}
var t=_32.ownerSVGElement.createSVGTransform();
t.setMatrix(m);
_32.transform.baseVal.appendItem(t);
}
};
dojo.svg.group=function(_3b){
var p=_3b.item(0).parentNode;
var g=document.createElementNS(this.xmlns.svg,"g");
for(var i=0;i<_3b.length;i++){
g.appendChild(_3b.item(i));
}
p.appendChild(g);
return g;
};
dojo.svg.ungroup=function(g){
var p=g.parentNode;
while(g.childNodes.length>0){
p.appendChild(g.childNodes.item(0));
}
p.removeChild(g);
};
dojo.svg.getGroup=function(_41){
var a=this.getAncestors(_41);
for(var i=0;i<a.length;i++){
if(a[i].nodeType==this.ELEMENT_NODE&&a[i].nodeName.toLowerCase()=="g"){
return a[i];
}
}
return null;
};
dojo.svg.bringToFront=function(_44){
var n=this.getGroup(_44)||_44;
n.ownerSVGElement.appendChild(n);
};
dojo.svg.sendToBack=function(_46){
var n=this.getGroup(_46)||_46;
n.ownerSVGElement.insertBefore(n,n.ownerSVGElement.firstChild);
};
dojo.svg.bringForward=function(_48){
var n=this.getGroup(_48)||_48;
if(this.getLastChildElement(n.parentNode)!=n){
this.insertAfter(n,this.getNextSiblingElement(n),true);
}
};
dojo.svg.sendBackward=function(_4a){
var n=this.getGroup(_4a)||_4a;
if(this.getFirstChildElement(n.parentNode)!=n){
this.insertBefore(n,this.getPreviousSiblingElement(n),true);
}
};
dojo.svg.createNodesFromText=function(txt,_4d){
var _4e=(new DOMParser()).parseFromString(txt,"text/xml").normalize();
if(_4d){
return [_4e.firstChild.cloneNode(true)];
}
var _4f=[];
for(var x=0;x<_4e.childNodes.length;x++){
_4f.push(_4e.childNodes.item(x).cloneNode(true));
}
return _4f;
};

