dojo.provide("dojo.widget.DocPane");
dojo.require("dojo.widget.*");
dojo.require("dojo.io.*");
dojo.require("dojo.event.*");
dojo.require("dojo.widget.HtmlWidget");
dojo.require("dojo.widget.Editor2");
dojo.require("dojo.widget.Dialog");
dojo.require("dojo.html.common");
dojo.require("dojo.html.display");
dojo.widget.DocPane=function(){
dojo.event.topic.subscribe("/docs/function/results",this,"onDocResults");
dojo.event.topic.subscribe("/docs/package/results",this,"onPkgResults");
dojo.event.topic.subscribe("/docs/function/detail",this,"onDocSelectFunction");
};
dojo.widget.defineWidget("dojo.widget.DocPane",dojo.widget.HtmlWidget,{dialog:null,dialogBg:null,dialogFg:null,logIn:null,edit:null,save:null,cancel:null,detail:null,result:null,packag:null,fn:null,fnLink:null,count:null,row:null,summary:null,description:null,variables:null,vRow:null,vLink:null,vDesc:null,methods:null,mRow:null,mLink:null,mDesc:null,requires:null,rRow:null,rRow2:null,rH3:null,rLink:null,parameters:null,pRow:null,pLink:null,pDesc:null,pOpt:null,pType:null,sType:null,sName:null,sParams:null,sPType:null,sPTypeSave:null,sPName:null,sPNameSave:null,pkgDescription:null,_appends:[],templatePath:dojo.uri.dojoUri("src/widget/templates/DocPane.html"),templateCssPath:dojo.uri.dojoUri("src/widget/templates/DocPane.css"),isContainer:true,fillInTemplate:function(){
this.requires=dojo.html.removeNode(this.requires);
this.rRow.style.display="none";
this.rRow2.style.display="none";
this.methods=dojo.html.removeNode(this.methods);
this.mRow.style.display="none";
this.dialog=dojo.widget.createWidget("dialog",{},this.dialog);
this.dialog.setCloseControl(this.cancel);
dojo.html.setOpacity(this.dialogBg,0.8);
dojo.html.setOpacity(this.dialogFg,1);
dojo.event.connect(this.edit,"onclick",dojo.lang.hitch(this,function(){
if(!this._isLoggedIn){
this.dialog.show();
}
}));
dojo.event.connect(this.logIn,"onclick",this,"_logIn");
dojo.event.connect(this.save,"onclick",this,"_save");
dojo.event.connect(dojo.docs,"logInSuccess",this,"_loggedIn");
this.homeSave=this.containerNode.cloneNode(true);
this.detailSave=dojo.html.removeNode(this.detail);
this.resultSave=dojo.html.removeNode(this.result);
this.packageSave=dojo.html.removeNode(this.packag);
this.results=dojo.html.removeNode(this.results);
this.rowParent=this.row.parentNode;
this.rowSave=dojo.html.removeNode(this.row);
this.vParent=this.vRow.parentNode;
this.vSave=dojo.html.removeNode(this.vRow);
this.pParent=this.pRow.parentNode;
this.pSave=dojo.html.removeNode(this.pRow);
this.sPTypeSave=dojo.html.removeNode(this.sPType);
this.sPNameSave=dojo.html.removeNode(this.sPName);
this.navSave=dojo.html.removeNode(this.nav);
},_logIn:function(){
dojo.docs.setUserName(this.userName.value);
dojo.docs.setPassword(this.password.value);
},_loggedIn:function(){
this._isLoggedIn=true;
this.dialog.hide();
this.pkgEditor=dojo.widget.createWidget("editor2",{toolbarAlwaysVisible:true},this.pkgDescription);
},_save:function(){
if(this.pkgEditor){
dojo.docs.savePackage(this._pkgPath,{description:this.pkgEditor.getEditorContent()});
}
},onDocSelectFunction:function(_1){
dojo.debug("onDocSelectFunction()");
for(var _2 in _1){
dojo.debug(_2+": "+dojo.json.serialize(_1[_2]));
}
var _3=_1.meta;
if(_3){
var _4=_3.variables;
var _5=_3.this_variables;
var _6=_3.child_variables;
var _7=_3.parameters;
}
var _8=_1.doc;
dojo.debug(dojo.json.serialize(_8));
var _9=this._appends;
dojo.html.removeChildren(this.domNode);
this.fn.innerHTML=_1.name;
this.variables.style.display="block";
var _a=[];
if(_4){
_a=_4;
}
if(_5){
_a=_a.concat(_5);
}
if(_6){
_a=_a.concat(_6);
}
if(!_a.length){
this.variables.style.display="none";
}else{
for(var i=0,one;one=_a[i];i++){
this.vLink.innerHTML=one;
this.vDesc.parentNode.style.display="none";
_9.push(this.vParent.appendChild(this.vSave.cloneNode(true)));
}
}
this.sParams.innerHTML="";
var _c=true;
for(var _d in _7){
var _e=_7[_d].type;
var _f=_7[_d].summary;
var _10=_d;
this.parameters.style.display="block";
this.pLink.innerHTML=_10;
this.pOpt.style.display="none";
if(_7[_d].opt){
this.pOpt.style.display="inline";
}
this.pType.parentNode.style.display="none";
if(_7[_d][0]){
this.pType.parentNode.style.display="inline";
this.pType.innerHTML=_e;
}
this.pDesc.parentNode.style.display="none";
if(_f){
this.pDesc.parentNode.style.display="inline";
this.pDesc.innerHTML=_f;
}
_9.push(this.pParent.appendChild(this.pSave.cloneNode(true)));
if(!_c){
this.sParams.appendChild(document.createTextNode(", "));
}
_c=false;
if(_e){
dojo.debug(this.sPTypeSave);
this.sPTypeSave.innerHTML=_e;
this.sParams.appendChild(this.sPTypeSave.cloneNode(true));
this.sParams.appendChild(document.createTextNode(" "));
}
dojo.debug(this.sPNameSave);
this.sPNameSave.innerHTML=_10;
this.sParams.appendChild(this.sPNameSave.cloneNode(true));
}
if(_1.returns){
this.sType.innerHTML=_1.returns;
}else{
this.sType.innerHTML="void";
}
this.sName.innerHTML=_1.name;
this.domNode.appendChild(this.navSave);
this.domNode.appendChild(this.detailSave.cloneNode(true));
for(var i=0,append;append=_9[i];i++){
dojo.html.removeNode(append);
}
},onPkgResult:function(_11){
if(this.pkgEditor){
this.pkgEditor.close(true);
dojo.debug(this.pkgDescription);
}
var _12=_11.methods;
var _13=_11.requires;
var _14=_11.description;
this._pkgPath=_11.path;
var _15=[];
var _16=this._appends;
while(_16.length){
dojo.html.removeNode(_16.shift());
}
dojo.html.removeChildren(this.domNode);
this.pkg.innerHTML=_11.pkg;
var _17=false;
for(var env in _13){
_17=true;
this.rH3.style.display="none";
if(env!="common"){
this.rH3.style.display="";
this.rH3.innerHTML=env;
}
for(var i=0,require;require=_13[env][i];i++){
_15.push({name:require});
this.rLink.innerHTML=require;
this.rLink.href="#"+require;
var _1a=this.rRow2.parentNode.insertBefore(this.rRow2.cloneNode(true),this.rRow2);
_1a.style.display="";
_16.push(_1a);
}
var _1b=this.rRow.parentNode.insertBefore(this.rRow.cloneNode(true),this.rRow);
_1b.style.display="";
_16.push(_1b);
}
if(_17){
_16.push(this.packageSave.appendChild(this.requires.cloneNode(true)));
}
if(_11.size){
for(var i=0,method;method=_12[i];i++){
this.mLink.innerHTML=method.name;
this.mLink.href="#"+method.name;
this.mDesc.parentNode.style.display="none";
if(method.summary){
this.mDesc.parentNode.style.display="inline";
this.mDesc.innerHTML=method.summary;
}
var _1c=this.mRow.parentNode.insertBefore(this.mRow.cloneNode(true),this.mRow);
_1c.style.display="";
_16.push(_1c);
}
_16.push(this.packageSave.appendChild(this.methods.cloneNode(true)));
}
this.domNode.appendChild(this.packageSave);
this.pkgDescription.innerHTML=_14;
function makeSelect(_1d,x){
return function(e){
dojo.event.topic.publish("/docs/"+_1d+"/select",x);
};
}
var as=this.domNode.getElementsByTagName("a");
for(var i=0,a;a=as[i];i++){
if(a.className=="docMLink"){
dojo.event.connect(a,"onclick",makeSelect("function",_12[i]));
}else{
if(a.className=="docRLink"){
dojo.event.connect(a,"onclick",makeSelect("package",_15[i]));
}
}
}
},onDocResults:function(fns){
dojo.debug("onDocResults(): called");
if(fns.length==1){
dojo.event.topic.publish("/docs/function/select",fns[0]);
return;
}
dojo.html.removeChildren(this.domNode);
this.count.innerHTML=fns.length;
var _22=[];
for(var i=0,fn;fn=fns[i];i++){
this.fnLink.innerHTML=fn.name;
this.fnLink.href="#"+fn.name;
if(fn.id){
this.fnLink.href=this.fnLink.href+","+fn.id;
}
this.summary.parentNode.style.display="none";
if(fn.summary){
this.summary.parentNode.style.display="inline";
this.summary.innerHTML=fn.summary;
}
_22.push(this.rowParent.appendChild(this.rowSave.cloneNode(true)));
}
function makeSelect(x){
return function(e){
dojo.event.topic.publish("/docs/function/select",x);
};
}
this.domNode.appendChild(this.resultSave.cloneNode(true));
var as=this.domNode.getElementsByTagName("a");
for(var i=0,a;a=as[i];i++){
dojo.event.connect(a,"onclick",makeSelect(fns[i]));
}
for(var i=0,append;append=_22[i];i++){
this.rowParent.removeChild(append);
}
}});

