dojo.provide("dojo.widget.MonthlyCalendar");
dojo.require("dojo.date.common");
dojo.require("dojo.date.format");
dojo.require("dojo.widget.*");
dojo.require("dojo.widget.DatePicker");
dojo.require("dojo.event.*");
dojo.require("dojo.html.*");
dojo.require("dojo.experimental");
dojo.experimental("dojo.widget.MonthlyCalendar");
dojo.widget.defineWidget("dojo.widget.MonthlyCalendar",dojo.widget.DatePicker,{dayWidth:"wide",templatePath:dojo.uri.dojoUri("src/widget/templates/MonthlyCalendar.html"),templateCssPath:dojo.uri.dojoUri("src/widget/templates/MonthlyCalendar.css"),initializer:function(){
this.iCalendars=[];
},addCalendar:function(_1){
dojo.debug("Adding Calendar");
this.iCalendars.push(_1);
dojo.debug("Starting init");
this.initUI();
dojo.debug("done init");
},createDayContents:function(_2,_3){
dojo.html.removeChildren(_2);
_2.appendChild(document.createTextNode(_3.getDate()));
for(var x=0;x<this.iCalendars.length;x++){
var _5=this.iCalendars[x].getEvents(_3);
if((dojo.lang.isArray(_5))&&(_5.length>0)){
for(var y=0;y<_5.length;y++){
var el=document.createElement("div");
dojo.html.addClass(el,"dojoMonthlyCalendarEvent");
el.appendChild(document.createTextNode(_5[y].summary.value));
el.width=dojo.html.getContentBox(_2).width;
_2.appendChild(el);
}
}
}
},initUI:function(){
var _8=dojo.date.getNames("days",this.dayWidth,"standAlone",this.lang);
var _9=this.dayLabelsRow.getElementsByTagName("td");
for(var i=0;i<7;i++){
_9.item(i).innerHTML=_8[i];
}
this.selectedIsUsed=false;
this.currentIsUsed=false;
var _b="";
var _c=new Date();
var _d=this.calendarDatesContainerNode.getElementsByTagName("td");
var _e;
_c.setHours(8);
var _f=new Date(this.firstSaturday.year,this.firstSaturday.month,this.firstSaturday.date,8);
var _10=new Date(this.firstSaturday.year,this.firstSaturday.month,this.firstSaturday.date+42,8);
if(this.iCalendars.length>0){
for(var x=0;x<this.iCalendars.length;x++){
this.iCalendars[x].preComputeRecurringEvents(_10);
}
}
if(this.firstSaturday.date<7){
var _12=6;
for(var i=this.firstSaturday.date;i>0;i--){
_e=_d.item(_12);
this.createDayContents(_e,_f);
dojo.html.setClass(_e,this.getDateClassName(_f,"current"));
_12--;
_c=_f;
_f=this.incrementDate(_f,false);
}
for(var i=_12;i>-1;i--){
_e=_d.item(i);
this.createDayContents(_e,_f);
dojo.html.setClass(_e,this.getDateClassName(_f,"previous"));
_c=_f;
_f=this.incrementDate(_f,false);
}
}else{
_f.setDate(1);
for(var i=0;i<7;i++){
_e=_d.item(i);
this.createDayContents(_e,_f);
dojo.html.setClass(_e,this.getDateClassName(_f,"current"));
_c=_f;
_f=this.incrementDate(_f,true);
}
}
_c.setDate(this.firstSaturday.date);
_c.setMonth(this.firstSaturday.month);
_c.setFullYear(this.firstSaturday.year);
_f=this.incrementDate(_c,true);
var _13=7;
_e=_d.item(_13);
while((_f.getMonth()==_c.getMonth())&&(_13<42)){
this.createDayContents(_e,_f);
dojo.html.setClass(_e,this.getDateClassName(_f,"current"));
_e=_d.item(++_13);
_c=_f;
_f=this.incrementDate(_f,true);
}
while(_13<42){
this.createDayContents(_e,_f);
dojo.html.setClass(_e,this.getDateClassName(_f,"next"));
_e=_d.item(++_13);
_c=_f;
_f=this.incrementDate(_f,true);
}
this.setMonthLabel(this.firstSaturday.month);
this.setYearLabels(this.firstSaturday.year);
}});
dojo.widget.MonthlyCalendar.util=new function(){
this.toRfcDate=function(_14){
if(!_14){
_14=this.today;
}
var _15=_14.getFullYear();
var _16=_14.getMonth()+1;
if(_16<10){
_16="0"+_16.toString();
}
var _17=_14.getDate();
if(_17<10){
_17="0"+_17.toString();
}
return _15+"-"+_16+"-"+_17+"T00:00:00+00:00";
};
this.fromRfcDate=function(_18){
var _19=_18.split("-");
if(_19.length<3){
return new Date();
}
return new Date(parseInt(_19[0]),(parseInt(_19[1],10)-1),parseInt(_19[2].substr(0,2),10));
};
this.initFirstSaturday=function(_1a,_1b){
if(!_1a){
_1a=this.date.getMonth();
}
if(!_1b){
_1b=this.date.getFullYear();
}
var _1c=new Date(_1b,_1a,1);
return {year:_1b,month:_1a,date:7-_1c.getDay()};
};
};

