dojo.provide("dojo.widget.Parse");
dojo.require("dojo.widget.Manager");
dojo.require("dojo.dom");
dojo.widget.Parse=function(_1){
this.propertySetsList=[];
this.fragment=_1;
this.createComponents=function(_2,_3){
var _4=[];
var _5=false;
try{
if(_2&&_2.tagName&&(_2!=_2.nodeRef)){
var _6=dojo.widget.tags;
var _7=String(_2.tagName).split(";");
for(var x=0;x<_7.length;x++){
var _9=_7[x].replace(/^\s+|\s+$/g,"").toLowerCase();
_2.tagName=_9;
var _a;
if(_6[_9]){
_5=true;
_a=_6[_9](_2,this,_3,_2.index);
_4.push(_a);
}else{
if(_9.indexOf(":")==-1){
_9="dojo:"+_9;
}
_a=dojo.widget.buildWidgetFromParseTree(_9,_2,this,_3,_2.index);
if(_a){
_5=true;
_4.push(_a);
}
}
}
}
}
catch(e){
dojo.debug("dojo.widget.Parse: error:",e);
}
if(!_5){
_4=_4.concat(this.createSubComponents(_2,_3));
}
return _4;
};
this.createSubComponents=function(_b,_c){
var _d,comps=[];
for(var _e in _b){
_d=_b[_e];
if(_d&&typeof _d=="object"&&(_d!=_b.nodeRef)&&(_d!=_b.tagName)&&(!dojo.dom.isNode(_d))){
comps=comps.concat(this.createComponents(_d,_c));
}
}
return comps;
};
this.parsePropertySets=function(_f){
return [];
};
this.parseProperties=function(_10){
var _11={};
for(var _12 in _10){
if((_10[_12]==_10.tagName)||(_10[_12]==_10.nodeRef)){
}else{
var _13=_10[_12];
if(_13.tagName&&dojo.widget.tags[_13.tagName.toLowerCase()]){
}else{
if(_13[0]&&_13[0].value!=""&&_13[0].value!=null){
try{
if(_12.toLowerCase()=="dataprovider"){
var _14=this;
this.getDataProvider(_14,_13[0].value);
_11.dataProvider=this.dataProvider;
}
_11[_12]=_13[0].value;
var _15=this.parseProperties(_13);
for(var _16 in _15){
_11[_16]=_15[_16];
}
}
catch(e){
dojo.debug(e);
}
}
}
switch(_12.toLowerCase()){
case "checked":
case "disabled":
if(typeof _11[_12]!="boolean"){
_11[_12]=true;
}
break;
}
}
}
return _11;
};
this.getDataProvider=function(_17,_18){
dojo.io.bind({url:_18,load:function(_19,_1a){
if(_19=="load"){
_17.dataProvider=_1a;
}
},mimetype:"text/javascript",sync:true});
};
this.getPropertySetById=function(_1b){
for(var x=0;x<this.propertySetsList.length;x++){
if(_1b==this.propertySetsList[x]["id"][0].value){
return this.propertySetsList[x];
}
}
return "";
};
this.getPropertySetsByType=function(_1d){
var _1e=[];
for(var x=0;x<this.propertySetsList.length;x++){
var cpl=this.propertySetsList[x];
var _21=cpl.componentClass||cpl.componentType||null;
var _22=this.propertySetsList[x]["id"][0].value;
if(_21&&(_22==_21[0].value)){
_1e.push(cpl);
}
}
return _1e;
};
this.getPropertySets=function(_23){
var ppl="dojo:propertyproviderlist";
var _25=[];
var _26=_23.tagName;
if(_23[ppl]){
var _27=_23[ppl].value.split(" ");
for(var _28 in _27){
if((_28.indexOf("..")==-1)&&(_28.indexOf("://")==-1)){
var _29=this.getPropertySetById(_28);
if(_29!=""){
_25.push(_29);
}
}else{
}
}
}
return this.getPropertySetsByType(_26).concat(_25);
};
this.createComponentFromScript=function(_2a,_2b,_2c,ns){
_2c.fastMixIn=true;
var ltn=(ns||"dojo")+":"+_2b.toLowerCase();
if(dojo.widget.tags[ltn]){
return [dojo.widget.tags[ltn](_2c,this,null,null,_2c)];
}
return [dojo.widget.buildWidgetFromParseTree(ltn,_2c,this,null,null,_2c)];
};
};
dojo.widget._parser_collection={"dojo":new dojo.widget.Parse()};
dojo.widget.getParser=function(_2f){
if(!_2f){
_2f="dojo";
}
if(!this._parser_collection[_2f]){
this._parser_collection[_2f]=new dojo.widget.Parse();
}
return this._parser_collection[_2f];
};
dojo.widget.createWidget=function(_30,_31,_32,_33){
var _34=false;
var _35=(typeof _30=="string");
if(_35){
var pos=_30.indexOf(":");
var ns=(pos>-1)?_30.substring(0,pos):"dojo";
if(pos>-1){
_30=_30.substring(pos+1);
}
var _38=_30.toLowerCase();
var _39=ns+":"+_38;
_34=(dojo.byId(_30)&&!dojo.widget.tags[_39]);
}
if((arguments.length==1)&&(_34||!_35)){
var xp=new dojo.xml.Parse();
var tn=_34?dojo.byId(_30):_30;
return dojo.widget.getParser().createComponents(xp.parseElement(tn,null,true))[0];
}
function fromScript(_3c,_3d,_3e,ns){
_3e[_39]={dojotype:[{value:_38}],nodeRef:_3c,fastMixIn:true};
_3e.ns=ns;
return dojo.widget.getParser().createComponentFromScript(_3c,_3d,_3e,ns);
}
_31=_31||{};
var _40=false;
var tn=null;
var h=dojo.render.html.capable;
if(h){
tn=document.createElement("span");
}
if(!_32){
_40=true;
_32=tn;
if(h){
dojo.body().appendChild(_32);
}
}else{
if(_33){
dojo.dom.insertAtPosition(tn,_32,_33);
}else{
tn=_32;
}
}
var _42=fromScript(tn,_30.toLowerCase(),_31,ns);
if((!_42)||(!_42[0])||(typeof _42[0].widgetType=="undefined")){
throw new Error("createWidget: Creation of \""+_30+"\" widget failed.");
}
try{
if(_40&&_42[0].domNode.parentNode){
_42[0].domNode.parentNode.removeChild(_42[0].domNode);
}
}
catch(e){
dojo.debug(e);
}
return _42[0];
};

