dojo.provide("dojo.widget.Rounded");
dojo.widget.tags.addParseTreeHandler("dojo:rounded");
dojo.require("dojo.widget.*");
dojo.require("dojo.widget.ContentPane");
dojo.require("dojo.html.style");
dojo.require("dojo.html.display");
dojo.require("dojo.gfx.color");
dojo.deprecated("dojo.widget.Rounded will be removed in version 0.5; you can now apply rounded corners to any block element using dojo.lfx.rounded.","0.5");
dojo.widget.defineWidget("dojo.widget.Rounded",dojo.widget.ContentPane,{isSafari:dojo.render.html.safari,boxMargin:"50px",radius:14,domNode:"",corners:"TR,TL,BR,BL",antiAlias:true,fillInTemplate:function(_1,_2){
dojo.widget.Rounded.superclass.fillInTemplate.call(this,_1,_2);
dojo.html.insertCssFile(this.templateCssPath);
if(this.domNode.style.height<=0){
var _3=(this.radius*1)+this.domNode.clientHeight;
this.domNode.style.height=_3+"px";
}
if(this.domNode.style.width<=0){
var _4=(this.radius*1)+this.domNode.clientWidth;
this.domNode.style.width=_4+"px";
}
var _5=["TR","TL","BR","BL"];
var _6=this.corners.split(",");
this.settings={antiAlias:this.antiAlias};
var _7=function(_8){
var _9=_8.toLowerCase();
if(dojo.lang.inArray(_6,_8)){
this.settings[_9]={radius:this.radius,enabled:true};
}else{
this.settings[_9]={radius:0};
}
};
dojo.lang.forEach(_5,_7,this);
this.domNode.style.margin=this.boxMargin;
this.curvyCorners(this.settings);
this.applyCorners();
},curvyCorners:function(_a){
this.box=this.domNode;
this.topContainer=null;
this.bottomContainer=null;
this.masterCorners=[];
var _b=dojo.html.getStyle(this.box,"height");
if(_b==""){
_b="0px";
}
var _c=dojo.html.getStyle(this.box,"width");
var _d=dojo.html.getStyle(this.box,"borderTopWidth");
if(_d==""){
_d="0px";
}
var _e=dojo.html.getStyle(this.box,"borderTopColor");
if(_d>0){
this.antiAlias=true;
}
var _f=dojo.html.getStyle(this.box,"backgroundColor");
var _10=dojo.html.getStyle(this.box,"backgroundImage");
var _11=dojo.html.getStyle(this.box,"position");
this.boxHeight=parseInt(((_b!=""&&_b!="auto"&&_b.indexOf("%")==-1)?_b.substring(0,_b.indexOf("px")):this.box.scrollHeight));
this.boxWidth=parseInt(((_c!=""&&_c!="auto"&&_c.indexOf("%")==-1)?_c.substring(0,_c.indexOf("px")):this.box.scrollWidth));
this.borderWidth=parseInt(((_d!=""&&_d.indexOf("px")!==-1)?_d.slice(0,_d.indexOf("px")):0));
var _12=new dojo.gfx.color.Color(_f);
this.boxColour=((_f!=""&&_f!="transparent")?((_f.substr(0,3)=="rgb")?this.rgb2Hex(_f):_f):"#ffffff");
this.borderColour=((_e!=""&&_e!="transparent"&&this.borderWidth>0)?((_e.substr(0,3)=="rgb")?this.rgb2Hex(_e):_e):this.boxColour);
this.borderString=this.borderWidth+"px"+" solid "+this.borderColour;
this.backgroundImage=((_10!="none")?_10:"");
if(_11!="absolute"){
this.box.style.position="relative";
}
this.applyCorners=function(){
for(var t=0;t<2;t++){
switch(t){
case 0:
if(this.settings.tl.enabled||this.settings.tr.enabled){
var _14=document.createElement("DIV");
with(_14.style){
width="100%";
fontSize="1px";
overflow="hidden";
position="absolute";
paddingLeft=this.borderWidth+"px";
paddingRight=this.borderWidth+"px";
var _15=Math.max(this.settings.tl?this.settings.tl.radius:0,this.settings.tr?this.settings.tr.radius:0);
height=_15+"px";
top=0-_15+"px";
left=0-this.borderWidth+"px";
}
this.topContainer=this.box.appendChild(_14);
}
break;
case 1:
if(this.settings.bl.enabled||this.settings.br.enabled){
var _14=document.createElement("DIV");
with(_14.style){
width="100%";
fontSize="1px";
overflow="hidden";
position="absolute";
paddingLeft=this.borderWidth+"px";
paddingRight=this.borderWidth+"px";
var _16=Math.max(this.settings.bl?this.settings.bl.radius:0,this.settings.br?this.settings.br.radius:0);
height=_16+"px";
bottom=0-_16+"px";
left=0-this.borderWidth+"px";
}
this.bottomContainer=this.box.appendChild(_14);
}
break;
}
}
if(this.topContainer){
this.box.style.borderTopWidth="0px";
}
if(this.bottomContainer){
this.box.style.borderBottomWidth="0px";
}
var _17=["tr","tl","br","bl"];
for(var i in _17){
var cc=_17[i];
if(!this.settings[cc]){
if(((cc=="tr"||cc=="tl")&&this.topContainer!=null)||((cc=="br"||cc=="bl")&&this.bottomContainer!=null)){
var _1a=document.createElement("DIV");
_1a.style.position="relative";
_1a.style.fontSize="1px";
_1a.style.overflow="hidden";
if(this.backgroundImage==""){
_1a.style.backgroundColor=this.boxColour;
}else{
_1a.style.backgroundImage=this.backgroundImage;
}
switch(cc){
case "tl":
with(_1a.style){
height=_15-this.borderWidth+"px";
marginRight=this.settings.tr.radius-(this.borderWidth*2)+"px";
borderLeft=this.borderString;
borderTop=this.borderString;
left=-this.borderWidth+"px";
}
break;
case "tr":
with(_1a.style){
height=_15-this.borderWidth+"px";
marginLeft=this.settings.tl.radius-(this.borderWidth*2)+"px";
borderRight=this.borderString;
borderTop=this.borderString;
backgroundPosition="-"+this.boxWidth+"px 0px";
left=this.borderWidth+"px";
}
break;
case "bl":
with(_1a.style){
height=_16-this.borderWidth+"px";
marginRight=this.settings.br.radius-(this.borderWidth*2)+"px";
borderLeft=this.borderString;
borderBottom=this.borderString;
left=-this.borderWidth+"px";
}
break;
case "br":
with(_1a.style){
height=_16-this.borderWidth+"px";
marginLeft=this.settings.bl.radius-(this.borderWidth*2)+"px";
borderRight=this.borderString;
borderBottom=this.borderString;
left=this.borderWidth+"px";
}
break;
}
}
}else{
if(this.masterCorners[this.settings[cc].radius]){
var _1a=this.masterCorners[this.settings[cc].radius].cloneNode(true);
}else{
var _1a=document.createElement("DIV");
with(_1a.style){
height=this.settings[cc].radius+"px";
width=this.settings[cc].radius+"px";
position="absolute";
fontSize="1px";
overflow="hidden";
}
var _1b=parseInt(this.settings[cc].radius-this.borderWidth);
for(var _1c=0,j=this.settings[cc].radius;_1c<j;_1c++){
if((_1c+1)>=_1b){
var y1=-1;
}else{
var y1=(Math.floor(Math.sqrt(Math.pow(_1b,2)-Math.pow((_1c+1),2)))-1);
}
if(_1b!=j){
if((_1c)>=_1b){
var y2=-1;
}else{
var y2=Math.ceil(Math.sqrt(Math.pow(_1b,2)-Math.pow(_1c,2)));
}
if((_1c+1)>=j){
var y3=-1;
}else{
var y3=(Math.floor(Math.sqrt(Math.pow(j,2)-Math.pow((_1c+1),2)))-1);
}
}
if((_1c)>=j){
var y4=-1;
}else{
var y4=Math.ceil(Math.sqrt(Math.pow(j,2)-Math.pow(_1c,2)));
}
if(y1>-1){
this.drawPixel(_1c,0,this.boxColour,100,(y1+1),_1a,-1,this.settings[cc].radius);
}
if(_1b!=j){
if(this.antiAlias){
for(var _21=(y1+1);_21<y2;_21++){
if(this.backgroundImage!=""){
var _22=(this.pixelFraction(_1c,_21,_1b)*100);
if(_22<30){
this.drawPixel(_1c,_21,this.borderColour,100,1,_1a,0,this.settings[cc].radius);
}else{
this.drawPixel(_1c,_21,this.borderColour,100,1,_1a,-1,this.settings[cc].radius);
}
}else{
var _23=dojo.gfx.color.blend(this.boxColour,this.borderColour,this.pixelFraction(_1c,_21,_1b));
this.drawPixel(_1c,_21,_23,100,1,_1a,0,this.settings[cc].radius);
}
}
}
if(y3>=y2){
if(y1==-1){
y1=0;
}
this.drawPixel(_1c,y2,this.borderColour,100,(y3-y2+1),_1a,0,this.settings[cc].radius);
}
var _24=this.borderColour;
}else{
var _24=this.boxColour;
var y3=y1;
}
if(this.antiAlias){
for(var _21=(y3+1);_21<y4;_21++){
this.drawPixel(_1c,_21,_24,(this.pixelFraction(_1c,_21,j)*100),1,_1a,((this.borderWidth>0)?0:-1),this.settings[cc].radius);
}
}
}
this.masterCorners[this.settings[cc].radius]=_1a.cloneNode(true);
}
if(cc!="br"){
for(var t=0,k=_1a.childNodes.length;t<k;t++){
var _25=_1a.childNodes[t];
var _26=parseInt(_25.style.top.substring(0,_25.style.top.indexOf("px")));
var _27=parseInt(_25.style.left.substring(0,_25.style.left.indexOf("px")));
var _28=parseInt(_25.style.height.substring(0,_25.style.height.indexOf("px")));
if(cc=="tl"||cc=="bl"){
_25.style.left=this.settings[cc].radius-_27-1+"px";
}
if(cc=="tr"||cc=="tl"){
_25.style.top=this.settings[cc].radius-_28-_26+"px";
}
var _29;
switch(cc){
case "tr":
_29=(-1*(Math.abs((this.boxWidth-this.settings[cc].radius+this.borderWidth)+_27)-(Math.abs(this.settings[cc].radius-_28-_26-this.borderWidth))));
_25.style.backgroundPosition=_29+"px";
break;
case "tl":
_29=(-1*(Math.abs((this.settings[cc].radius-_27-1)-this.borderWidth)-(Math.abs(this.settings[cc].radius-_28-_26-this.borderWidth))));
_25.style.backgroundPosition=_29+"px";
break;
case "bl":
_29=(-1*(Math.abs((this.settings[cc].radius-_27-1)-this.borderWidth)-(Math.abs((this.boxHeight+this.settings[cc].radius+_26)-this.borderWidth))));
_25.style.backgroundPosition=_29+"px";
break;
}
}
}
}
if(_1a){
switch(cc){
case "tl":
if(_1a.style.position=="absolute"){
_1a.style.top="0px";
}
if(_1a.style.position=="absolute"){
_1a.style.left="0px";
}
if(this.topContainer){
this.topContainer.appendChild(_1a);
}
break;
case "tr":
if(_1a.style.position=="absolute"){
_1a.style.top="0px";
}
if(_1a.style.position=="absolute"){
_1a.style.right="0px";
}
if(this.topContainer){
this.topContainer.appendChild(_1a);
}
break;
case "bl":
if(_1a.style.position=="absolute"){
_1a.style.bottom="0px";
}
if(_1a.style.position=="absolute"){
_1a.style.left="0px";
}
if(this.bottomContainer){
this.bottomContainer.appendChild(_1a);
}
break;
case "br":
if(_1a.style.position=="absolute"){
_1a.style.bottom="0px";
}
if(_1a.style.position=="absolute"){
_1a.style.right="0px";
}
if(this.bottomContainer){
this.bottomContainer.appendChild(_1a);
}
break;
}
}
}
var _2a=[];
_2a["t"]=this.settings.tl.enabled&&this.settings.tr.enabled?Math.abs(this.settings.tl.radius-this.settings.tr.radius):0;
_2a["b"]=this.settings.bl.enabled&&this.settings.br.enabled?Math.abs(this.settings.bl.radius-this.settings.br.radius):0;
for(var z in _2a){
if(_2a[z]){
var _2c=((this.settings[z+"l"].radius<this.settings[z+"r"].radius)?z+"l":z+"r");
var _2d=document.createElement("DIV");
with(_2d.style){
height=_2a[z]+"px";
width=this.settings[_2c].radius+"px";
position="absolute";
fontSize="1px";
overflow="hidden";
backgroundColor=this.boxColour;
}
switch(_2c){
case "tl":
with(_2d.style){
bottom="0px";
left="0px";
borderLeft=this.borderString;
}
this.topContainer.appendChild(_2d);
break;
case "tr":
with(_2d.style){
bottom="0px";
right="0px";
borderRight=this.borderString;
}
this.topContainer.appendChild(_2d);
break;
case "bl":
with(_2d.style){
top="0px";
left="0px";
borderLeft=this.borderString;
}
this.bottomContainer.appendChild(_2d);
break;
case "br":
with(_2d.style){
top="0px";
right="0px";
borderRight=this.borderString;
}
this.bottomContainer.appendChild(_2d);
break;
}
}
var _2e=document.createElement("DIV");
with(_2e.style){
position="relative";
fontSize="1px";
overflow="hidden";
backgroundColor=this.boxColour;
}
switch(z){
case "t":
if(this.topContainer){
with(_2e.style){
height=_15-this.borderWidth+"px";
marginLeft=this.settings.tl.radius-this.borderWidth+"px";
marginRight=this.settings.tr.radius-this.borderWidth+"px";
borderTop=this.borderString;
}
this.topContainer.appendChild(_2e);
}
break;
case "b":
if(this.bottomContainer){
with(_2e.style){
height=_16-this.borderWidth+"px";
marginLeft=this.settings.bl.radius-this.borderWidth+"px";
marginRight=this.settings.br.radius-this.borderWidth+"px";
borderBottom=this.borderString;
}
this.bottomContainer.appendChild(_2e);
}
break;
}
}
};
this.drawPixel=function(_2f,_30,_31,_32,_33,_34,_35,_36){
var _37=document.createElement("DIV");
_37.style.height=_33+"px";
_37.style.width="1px";
_37.style.position="absolute";
_37.style.fontSize="1px";
_37.style.overflow="hidden";
if(_35==-1&&this.backgroundImage!=""){
_37.style.backgroundImage=this.backgroundImage;
_37.style.backgroundPosition="-"+(this.boxWidth-(_36-_2f)+this.borderWidth)+"px -"+((this.boxHeight+_36+_30)-this.borderWidth)+"px";
}else{
_37.style.backgroundColor=_31;
}
if(_32!=100){
dojo.html.setOpacity(_37,_32);
}
_37.style.top=_30+"px";
_37.style.left=_2f+"px";
_34.appendChild(_37);
};
},pixelFraction:function(x,y,r){
var _3b=0;
var _3c=[];
var _3d=[];
var _3e=0;
var _3f="";
var _40=Math.sqrt((Math.pow(r,2)-Math.pow(x,2)));
if((_40>=y)&&(_40<(y+1))){
_3f="Left";
_3c[_3e]=0;
_3d[_3e]=_40-y;
_3e=_3e+1;
}
var _40=Math.sqrt((Math.pow(r,2)-Math.pow(y+1,2)));
if((_40>=x)&&(_40<(x+1))){
_3f=_3f+"Top";
_3c[_3e]=_40-x;
_3d[_3e]=1;
_3e=_3e+1;
}
var _40=Math.sqrt((Math.pow(r,2)-Math.pow(x+1,2)));
if((_40>=y)&&(_40<(y+1))){
_3f=_3f+"Right";
_3c[_3e]=1;
_3d[_3e]=_40-y;
_3e=_3e+1;
}
var _40=Math.sqrt((Math.pow(r,2)-Math.pow(y,2)));
if((_40>=x)&&(_40<(x+1))){
_3f=_3f+"Bottom";
_3c[_3e]=_40-x;
_3d[_3e]=0;
}
switch(_3f){
case "LeftRight":
_3b=Math.min(_3d[0],_3d[1])+((Math.max(_3d[0],_3d[1])-Math.min(_3d[0],_3d[1]))/2);
break;
case "TopRight":
_3b=1-(((1-_3c[0])*(1-_3d[1]))/2);
break;
case "TopBottom":
_3b=Math.min(_3c[0],_3c[1])+((Math.max(_3c[0],_3c[1])-Math.min(_3c[0],_3c[1]))/2);
break;
case "LeftBottom":
_3b=(_3d[0]*_3c[1])/2;
break;
default:
_3b=1;
}
return _3b;
},rgb2Hex:function(_41){
try{
var _42=this.rgb2Array(_41);
var red=parseInt(_42[0]);
var _44=parseInt(_42[1]);
var _45=parseInt(_42[2]);
var _46="#"+this.intToHex(red)+this.intToHex(_44)+this.intToHex(_45);
}
catch(e){
alert("There was an error converting the RGB value to Hexadecimal in function rgb2Hex");
}
return _46;
},intToHex:function(_47){
var _48=_47/16;
var rem=_47%16;
var _48=_48-(rem/16);
var _4a=this.makeHex(_48);
var _4b=this.makeHex(rem);
return _4a+""+_4b;
},makeHex:function(x){
if((x>=0)&&(x<=9)){
return x;
}else{
switch(x){
case 10:
return "A";
case 11:
return "B";
case 12:
return "C";
case 13:
return "D";
case 14:
return "E";
case 15:
return "F";
}
}
},rgb2Array:function(_4d){
var _4e=_4d.substring(4,_4d.indexOf(")"));
var _4f=_4e.split(", ");
return _4f;
}});

