dojo.provide("dojo.widget.Show");
dojo.require("dojo.widget.*");
dojo.require("dojo.widget.HtmlWidget");
dojo.require("dojo.uri.Uri");
dojo.require("dojo.event.*");
dojo.require("dojo.lfx.*");
dojo.require("dojo.math.curves");
dojo.require("dojo.lang.common");
dojo.require("dojo.lang.func");
dojo.widget.defineWidget("dojo.widget.Show",dojo.widget.HtmlWidget,function(){
this._slides=[];
},{isContainer:true,_slide:-1,body:null,nav:null,hider:null,select:null,option:null,inNav:false,debugPane:null,noClick:false,templatePath:dojo.uri.dojoUri("src/widget/templates/Show.html"),templateCssPath:dojo.uri.dojoUri("src/widget/templates/Show.css"),fillInTemplate:function(_1,_2){
if(_1.debugPane){
var dp=this.debugPane=dojo.widget.byId(_1.debugPane);
dp.hide();
dojo.event.connect(dp,"closeWindow",dojo.lang.hitch(this,function(){
this.debugPane=false;
}));
}
var _4=this.getFragNodeRef(_2);
this.sourceNode=dojo.body().appendChild(_4.cloneNode(true));
for(var i=0,child;child=this.sourceNode.childNodes[i];i++){
if(child.tagName&&child.getAttribute("dojotype").toLowerCase()=="showslide"){
child.className="dojoShowPrintSlide";
child.innerHTML="<h1>"+child.title+"</h1>"+child.innerHTML;
}
}
this.sourceNode.className="dojoShowPrint";
this.sourceNode.style.display="none";
dojo.event.connect(document,"onclick",this,"gotoSlideByEvent");
if(dojo.render.html.ie){
dojo.event.connect(document,"onkeydown",this,"gotoSlideByEvent");
}else{
dojo.event.connect(document,"onkeypress",this,"gotoSlideByEvent");
}
dojo.event.connect(window,"onresize",this,"resizeWindow");
dojo.event.connect(this.nav,"onmousemove",this,"popUpNav");
},postCreate:function(){
this._slides=[];
for(var i=0,child;child=this.children[i];i++){
if(child.widgetType=="ShowSlide"){
this._slides.push(child);
this.option.text=child.title+" ("+(i+1)+")";
this.option.parentNode.insertBefore(this.option.cloneNode(true),this.option);
}
}
this.option.parentNode.removeChild(this.option);
this.domNode.style.display="block";
this.resizeWindow();
this.gotoSlide(0,true);
dojo.addOnLoad(dojo.lang.hitch(this,function(){
var th=window.location.hash;
if(th.length){
var _8=(""+window.location).split(this.widgetId+"_SlideNo_");
if(_8.length>1){
setTimeout(dojo.lang.hitch(this,function(){
this.gotoSlide(parseInt(_8[1]),true);
}),300);
}
}
}));
},gotoSlide:function(_9,_a){
if(_9==this._slide){
return;
}
if(!this._slides[_9]){
for(var i=0,child;child=this._slides[i];i++){
if(child.title==_9){
_9=i;
break;
}
}
}
if(!this._slides[_9]){
return;
}
if(this.debugPane){
if(this._slides[_9].debug){
this.debugPane.show();
}else{
this.debugPane.hide();
}
}
if(this._slide!=-1){
while(this._slides[this._slide].previousAction()){
}
}
if(!_a){
window.location.href="#"+this.widgetId+"_SlideNo_"+_9;
}
if(this._slides[this._slide]){
this._slides[this._slide].hide();
}
this._slide=_9;
this.select.selectedIndex=_9;
var cn=this.contentNode;
while(cn.firstChild){
cn.removeChild(cn.firstChild);
}
cn.appendChild(this._slides[_9].domNode);
this._slides[_9].show();
},gotoSlideByEvent:function(_d){
var _e=_d.target;
var _f=_d.type;
if(_f=="click"){
if(_e.tagName=="OPTION"&&_e.parentNode==this.select){
this.gotoSlide(_e.index);
}else{
if(_e==this.select){
this.gotoSlide(_e.selectedIndex);
}else{
this.nextSlide(_d);
}
}
}else{
if(_f=="keydown"||_f=="keypress"){
var key=_d.keyCode;
var ch=_d.charCode;
if(key==63234||key==37){
this.previousSlide(_d);
}else{
if(key==63235||key==39||ch==32){
this.nextSlide(_d);
}
}
}
}
},nextSlide:function(_12){
if(!this.stopEvent(_12)){
return false;
}
if(!this._slides[this._slide].nextAction(_12)){
if((this._slide+1)!=this._slides.length){
this.gotoSlide(this._slide+1);
return true;
}
return false;
}
},previousSlide:function(_13){
if(!this.stopEvent(_13)){
return false;
}
if(!this._slides[this._slide].previousAction(_13)){
if((this._slide-1)!=-1){
this.gotoSlide(this._slide-1);
return true;
}
return false;
}
},stopEvent:function(ev){
if(!ev){
return true;
}
if(ev.type=="click"&&(this._slides[this._slide].noClick||this.noClick)){
return false;
}
var _15=ev.target;
while(_15!=null){
if(_15==this.domNode){
_15=ev.target;
break;
}
_15=_15.parentNode;
}
if(!dojo.dom.isDescendantOf(_15,this.nav)){
while(_15&&_15!=this.domNode){
if(_15.tagName=="A"||_15.tagName=="INPUT"||_15.tagName=="TEXTAREA"||_15.tagName=="SELECT"){
return false;
}
if(typeof _15.onclick=="function"||typeof _15.onkeypress=="function"){
return false;
}
_15=_15.parentNode;
}
}
if(window.event){
ev.returnValue=false;
ev.cancelBubble=true;
}else{
ev.preventDefault();
ev.stopPropagation();
}
return true;
},popUpNav:function(){
if(!this.inNav){
dojo.lfx.propertyAnimation(this.nav,{"height":{start:5,end:30}},250).play();
}
clearTimeout(this.inNav);
this.inNav=setTimeout(dojo.lang.hitch(this,"hideNav"),2000);
},hideNav:function(){
clearTimeout(this.inNav);
this.inNav=false;
dojo.lfx.propertyAnimation(this.nav,{"height":{start:30,end:5}},250).play();
},resizeWindow:function(ev){
dojo.body().style.height="auto";
var h=Math.max(document.documentElement.scrollHeight||dojo.body().scrollHeight,dojo.html.getViewport().height);
dojo.body().style.height=h+"px";
}});

