dojo.provide("dojo.widget.SortableTable");
dojo.deprecated("SortableTable will be removed in favor of FilteringTable.","0.5");
dojo.require("dojo.lang.common");
dojo.require("dojo.date.format");
dojo.require("dojo.html.*");
dojo.require("dojo.html.selection");
dojo.require("dojo.html.util");
dojo.require("dojo.html.style");
dojo.require("dojo.event.*");
dojo.require("dojo.widget.*");
dojo.require("dojo.widget.HtmlWidget");
dojo.widget.defineWidget("dojo.widget.SortableTable",dojo.widget.HtmlWidget,function(){
this.data=[];
this.selected=[];
this.columns=[];
},{enableMultipleSelect:false,maximumNumberOfSelections:0,enableAlternateRows:false,minRows:0,defaultDateFormat:"%D",sortIndex:0,sortDirection:0,valueField:"Id",headClass:"",tbodyClass:"",headerClass:"",headerSortUpClass:"selected",headerSortDownClass:"selected",rowClass:"",rowAlternateClass:"alt",rowSelectedClass:"selected",columnSelected:"sorted-column",isContainer:false,templatePath:null,templateCssPath:null,getTypeFromString:function(s){
var _2=s.split("."),i=0,obj=dj_global;
do{
obj=obj[_2[i++]];
}while(i<_2.length&&obj);
return (obj!=dj_global)?obj:null;
},compare:function(o1,o2){
for(var p in o1){
if(!(p in o2)){
return false;
}
if(o1[p].valueOf()!=o2[p].valueOf()){
return false;
}
}
return true;
},isSelected:function(o){
for(var i=0;i<this.selected.length;i++){
if(this.compare(this.selected[i],o)){
return true;
}
}
return false;
},removeFromSelected:function(o){
var _9=-1;
for(var i=0;i<this.selected.length;i++){
if(this.compare(this.selected[i],o)){
_9=i;
break;
}
}
if(_9>=0){
this.selected.splice(_9,1);
}
},getSelection:function(){
return this.selected;
},getValue:function(){
var a=[];
for(var i=0;i<this.selected.length;i++){
if(this.selected[i][this.valueField]){
a.push(this.selected[i][this.valueField]);
}
}
return a.join();
},reset:function(){
this.columns=[];
this.data=[];
this.resetSelections(this.domNode.getElementsByTagName("tbody")[0]);
},resetSelections:function(_d){
this.selected=[];
var _e=0;
var _f=_d.getElementsByTagName("tr");
for(var i=0;i<_f.length;i++){
if(_f[i].parentNode==_d){
_f[i].removeAttribute("selected");
if(this.enableAlternateRows&&_e%2==1){
_f[i].className=this.rowAlternateClass;
}else{
_f[i].className="";
}
_e++;
}
}
},getObjectFromRow:function(row){
var _12=row.getElementsByTagName("td");
var o={};
for(var i=0;i<this.columns.length;i++){
if(this.columns[i].sortType=="__markup__"){
o[this.columns[i].getField()]=_12[i].innerHTML;
}else{
var _15=dojo.html.renderedTextContent(_12[i]);
var val=_15;
if(this.columns[i].getType()!=String){
var val=new (this.columns[i].getType())(_15);
}
o[this.columns[i].getField()]=val;
}
}
if(dojo.html.hasAttribute(row,"value")){
o[this.valueField]=dojo.html.getAttribute(row,"value");
}
return o;
},setSelectionByRow:function(row){
var o=this.getObjectFromRow(row);
var b=false;
for(var i=0;i<this.selected.length;i++){
if(this.compare(this.selected[i],o)){
b=true;
break;
}
}
if(!b){
this.selected.push(o);
}
},parseColumns:function(_1b){
this.reset();
var row=_1b.getElementsByTagName("tr")[0];
var _1d=row.getElementsByTagName("td");
if(_1d.length==0){
_1d=row.getElementsByTagName("th");
}
for(var i=0;i<_1d.length;i++){
var o={field:null,format:null,noSort:false,sortType:"String",dataType:String,sortFunction:null,label:null,align:"left",valign:"middle",getField:function(){
return this.field||this.label;
},getType:function(){
return this.dataType;
}};
if(dojo.html.hasAttribute(_1d[i],"align")){
o.align=dojo.html.getAttribute(_1d[i],"align");
}
if(dojo.html.hasAttribute(_1d[i],"valign")){
o.valign=dojo.html.getAttribute(_1d[i],"valign");
}
if(dojo.html.hasAttribute(_1d[i],"nosort")){
o.noSort=dojo.html.getAttribute(_1d[i],"nosort")=="true";
}
if(dojo.html.hasAttribute(_1d[i],"sortusing")){
var _20=dojo.html.getAttribute(_1d[i],"sortusing");
var f=this.getTypeFromString(_20);
if(f!=null&&f!=window&&typeof (f)=="function"){
o.sortFunction=f;
}
}
if(dojo.html.hasAttribute(_1d[i],"field")){
o.field=dojo.html.getAttribute(_1d[i],"field");
}
if(dojo.html.hasAttribute(_1d[i],"format")){
o.format=dojo.html.getAttribute(_1d[i],"format");
}
if(dojo.html.hasAttribute(_1d[i],"dataType")){
var _22=dojo.html.getAttribute(_1d[i],"dataType");
if(_22.toLowerCase()=="html"||_22.toLowerCase()=="markup"){
o.sortType="__markup__";
o.noSort=true;
}else{
var _23=this.getTypeFromString(_22);
if(_23){
o.sortType=_22;
o.dataType=_23;
}
}
}
o.label=dojo.html.renderedTextContent(_1d[i]);
this.columns.push(o);
if(dojo.html.hasAttribute(_1d[i],"sort")){
this.sortIndex=i;
var dir=dojo.html.getAttribute(_1d[i],"sort");
if(!isNaN(parseInt(dir))){
dir=parseInt(dir);
this.sortDirection=(dir!=0)?1:0;
}else{
this.sortDirection=(dir.toLowerCase()=="desc")?1:0;
}
}
}
},parseData:function(_25){
this.data=[];
this.selected=[];
for(var i=0;i<_25.length;i++){
var o={};
for(var j=0;j<this.columns.length;j++){
var _29=this.columns[j].getField();
if(this.columns[j].sortType=="__markup__"){
o[_29]=String(_25[i][_29]);
}else{
var _2a=this.columns[j].getType();
var val=_25[i][_29];
var t=this.columns[j].sortType.toLowerCase();
if(_2a==String){
o[_29]=val;
}else{
if(val!=null){
o[_29]=new _2a(val);
}else{
o[_29]=new _2a();
}
}
}
}
if(_25[i][this.valueField]&&!o[this.valueField]){
o[this.valueField]=_25[i][this.valueField];
}
this.data.push(o);
}
},parseDataFromTable:function(_2d){
this.data=[];
this.selected=[];
var _2e=_2d.getElementsByTagName("tr");
for(var i=0;i<_2e.length;i++){
if(dojo.html.getAttribute(_2e[i],"ignoreIfParsed")=="true"){
continue;
}
var o={};
var _31=_2e[i].getElementsByTagName("td");
for(var j=0;j<this.columns.length;j++){
var _33=this.columns[j].getField();
if(this.columns[j].sortType=="__markup__"){
o[_33]=_31[j].innerHTML;
}else{
var _34=this.columns[j].getType();
var val=dojo.html.renderedTextContent(_31[j]);
if(_34==String){
o[_33]=val;
}else{
if(val!=null){
o[_33]=new _34(val);
}else{
o[_33]=new _34();
}
}
}
}
if(dojo.html.hasAttribute(_2e[i],"value")&&!o[this.valueField]){
o[this.valueField]=dojo.html.getAttribute(_2e[i],"value");
}
this.data.push(o);
if(dojo.html.getAttribute(_2e[i],"selected")=="true"){
this.selected.push(o);
}
}
},showSelections:function(){
var _36=this.domNode.getElementsByTagName("tbody")[0];
var _37=_36.getElementsByTagName("tr");
var idx=0;
for(var i=0;i<_37.length;i++){
if(_37[i].parentNode==_36){
if(dojo.html.getAttribute(_37[i],"selected")=="true"){
_37[i].className=this.rowSelectedClass;
}else{
if(this.enableAlternateRows&&idx%2==1){
_37[i].className=this.rowAlternateClass;
}else{
_37[i].className="";
}
}
idx++;
}
}
},render:function(_3a){
var _3b=[];
var _3c=this.domNode.getElementsByTagName("tbody")[0];
if(!_3a){
this.parseDataFromTable(_3c);
}
for(var i=0;i<this.data.length;i++){
_3b.push(this.data[i]);
}
var col=this.columns[this.sortIndex];
if(!col.noSort){
var _3f=col.getField();
if(col.sortFunction){
var _40=col.sortFunction;
}else{
var _40=function(a,b){
if(a[_3f]>b[_3f]){
return 1;
}
if(a[_3f]<b[_3f]){
return -1;
}
return 0;
};
}
_3b.sort(_40);
if(this.sortDirection!=0){
_3b.reverse();
}
}
while(_3c.childNodes.length>0){
_3c.removeChild(_3c.childNodes[0]);
}
for(var i=0;i<_3b.length;i++){
var row=document.createElement("tr");
dojo.html.disableSelection(row);
if(_3b[i][this.valueField]){
row.setAttribute("value",_3b[i][this.valueField]);
}
if(this.isSelected(_3b[i])){
row.className=this.rowSelectedClass;
row.setAttribute("selected","true");
}else{
if(this.enableAlternateRows&&i%2==1){
row.className=this.rowAlternateClass;
}
}
for(var j=0;j<this.columns.length;j++){
var _45=document.createElement("td");
_45.setAttribute("align",this.columns[j].align);
_45.setAttribute("valign",this.columns[j].valign);
dojo.html.disableSelection(_45);
if(this.sortIndex==j){
_45.className=this.columnSelected;
}
if(this.columns[j].sortType=="__markup__"){
_45.innerHTML=_3b[i][this.columns[j].getField()];
for(var k=0;k<_45.childNodes.length;k++){
var _47=_45.childNodes[k];
if(_47&&_47.nodeType==dojo.html.ELEMENT_NODE){
dojo.html.disableSelection(_47);
}
}
}else{
if(this.columns[j].getType()==Date){
var _48=this.defaultDateFormat;
if(this.columns[j].format){
_48=this.columns[j].format;
}
_45.appendChild(document.createTextNode(dojo.date.strftime(_3b[i][this.columns[j].getField()],_48)));
}else{
_45.appendChild(document.createTextNode(_3b[i][this.columns[j].getField()]));
}
}
row.appendChild(_45);
}
_3c.appendChild(row);
dojo.event.connect(row,"onclick",this,"onUISelect");
}
var _49=parseInt(this.minRows);
if(!isNaN(_49)&&_49>0&&_3b.length<_49){
var mod=0;
if(_3b.length%2==0){
mod=1;
}
var _4b=_49-_3b.length;
for(var i=0;i<_4b;i++){
var row=document.createElement("tr");
row.setAttribute("ignoreIfParsed","true");
if(this.enableAlternateRows&&i%2==mod){
row.className=this.rowAlternateClass;
}
for(var j=0;j<this.columns.length;j++){
var _45=document.createElement("td");
_45.appendChild(document.createTextNode("\xa0"));
row.appendChild(_45);
}
_3c.appendChild(row);
}
}
},onSelect:function(e){
},onUISelect:function(e){
var row=dojo.html.getParentByType(e.target,"tr");
var _4f=dojo.html.getParentByType(row,"tbody");
if(this.enableMultipleSelect){
if(e.metaKey||e.ctrlKey){
if(this.isSelected(this.getObjectFromRow(row))){
this.removeFromSelected(this.getObjectFromRow(row));
row.removeAttribute("selected");
}else{
this.setSelectionByRow(row);
row.setAttribute("selected","true");
}
}else{
if(e.shiftKey){
var _50;
var _51=_4f.getElementsByTagName("tr");
for(var i=0;i<_51.length;i++){
if(_51[i].parentNode==_4f){
if(_51[i]==row){
break;
}
if(dojo.html.getAttribute(_51[i],"selected")=="true"){
_50=_51[i];
}
}
}
if(!_50){
_50=row;
for(;i<_51.length;i++){
if(dojo.html.getAttribute(_51[i],"selected")=="true"){
row=_51[i];
break;
}
}
}
this.resetSelections(_4f);
if(_50==row){
row.setAttribute("selected","true");
this.setSelectionByRow(row);
}else{
var _53=false;
for(var i=0;i<_51.length;i++){
if(_51[i].parentNode==_4f){
_51[i].removeAttribute("selected");
if(_51[i]==_50){
_53=true;
}
if(_53){
this.setSelectionByRow(_51[i]);
_51[i].setAttribute("selected","true");
}
if(_51[i]==row){
_53=false;
}
}
}
}
}else{
this.resetSelections(_4f);
row.setAttribute("selected","true");
this.setSelectionByRow(row);
}
}
}else{
this.resetSelections(_4f);
row.setAttribute("selected","true");
this.setSelectionByRow(row);
}
this.showSelections();
this.onSelect(e);
e.stopPropagation();
e.preventDefault();
},onHeaderClick:function(e){
var _55=this.sortIndex;
var _56=this.sortDirection;
var _57=e.target;
var row=dojo.html.getParentByType(_57,"tr");
var _59="td";
if(row.getElementsByTagName(_59).length==0){
_59="th";
}
var _5a=row.getElementsByTagName(_59);
var _5b=dojo.html.getParentByType(_57,_59);
for(var i=0;i<_5a.length;i++){
if(_5a[i]==_5b){
if(i!=_55){
this.sortIndex=i;
this.sortDirection=0;
_5a[i].className=this.headerSortDownClass;
}else{
this.sortDirection=(_56==0)?1:0;
if(this.sortDirection==0){
_5a[i].className=this.headerSortDownClass;
}else{
_5a[i].className=this.headerSortUpClass;
}
}
}else{
_5a[i].className=this.headerClass;
}
}
this.render();
},postCreate:function(){
var _5d=this.domNode.getElementsByTagName("thead")[0];
if(this.headClass.length>0){
_5d.className=this.headClass;
}
dojo.html.disableSelection(this.domNode);
this.parseColumns(_5d);
var _5e="td";
if(_5d.getElementsByTagName(_5e).length==0){
_5e="th";
}
var _5f=_5d.getElementsByTagName(_5e);
for(var i=0;i<_5f.length;i++){
if(!this.columns[i].noSort){
dojo.event.connect(_5f[i],"onclick",this,"onHeaderClick");
}
if(this.sortIndex==i){
if(this.sortDirection==0){
_5f[i].className=this.headerSortDownClass;
}else{
_5f[i].className=this.headerSortUpClass;
}
}
}
var _61=this.domNode.getElementsByTagName("tbody")[0];
if(this.tbodyClass.length>0){
_61.className=this.tbodyClass;
}
this.parseDataFromTable(_61);
this.render(true);
}});

