dojo.provide("dojo.widget.YahooMap");
dojo.require("dojo.event.*");
dojo.require("dojo.math");
dojo.require("dojo.widget.*");
dojo.require("dojo.widget.HtmlWidget");
(function(){
var _1=djConfig["yAppId"]||djConfig["yahooAppId"]||"dojotoolkit";
if(!dojo.hostenv.post_load_){
if(_1=="dojotoolkit"){
dojo.debug("please provide a unique Yahoo App ID in djConfig.yahooAppId when using the map widget");
}
var _2="<scr"+"ipt src='http://api.maps.yahoo.com/ajaxymap?v=3.0&appid="+_1+"'></scri"+"pt>";
if(!dj_global["YMap"]){
document.write(_2);
}
}else{
dojo.debug("cannot initialize map system after the page has been loaded! Please either manually include the script block provided by Yahoo in your page or require() the YahooMap widget before onload has fired");
}
})();
dojo.widget.defineWidget("dojo.widget.YahooMap",dojo.widget.HtmlWidget,function(){
this.map=null;
this.datasrc="";
this.data=[];
this.width=0;
this.height=0;
this.controls=["zoomlong","maptype","pan"];
},{isContainer:false,templatePath:null,templateCssPath:null,findCenter:function(_3){
var _4=new YGeoPoint(37,-90);
if(_3.length==0){
return _4;
}
var _5,maxLat,minLon,maxLon,cLat,cLon;
_5=maxLat=_3[0].Lat;
minLon=maxLon=_3[0].Lon;
for(var i=0;i<_3.length;i++){
_5=Math.min(_5,_3[i].Lat);
maxLat=Math.max(maxLat,_3[i].Lat);
minLon=Math.min(minLon,_3[i].Lon);
maxLon=Math.max(maxLon,_3[i].Lon);
}
cLat=dojo.math.round((_5+maxLat)/2,6);
cLon=dojo.math.round((minLon+maxLon)/2,6);
return new YGeoPoint(cLat,cLon);
},setControls:function(){
var _7={maptype:"addTypeControl",pan:"addPanControl",zoomlong:"addZoomLong",zoomshort:"addZoomShort"};
var c=this.controls;
for(var i=0;i<c.length;i++){
var _a=_7[c[i].toLowerCase()];
if(this.map[_a]){
this.map[_a]();
}
}
},parse:function(_b){
this.data=[];
var h=_b.getElementsByTagName("thead")[0];
if(!h){
return;
}
var a=[];
var _e=h.getElementsByTagName("td");
if(_e.length==0){
_e=h.getElementsByTagName("th");
}
for(var i=0;i<_e.length;i++){
var c=_e[i].innerHTML.toLowerCase();
if(c=="long"){
c="lng";
}
a.push(c);
}
var b=_b.getElementsByTagName("tbody")[0];
if(!b){
return;
}
for(var i=0;i<b.childNodes.length;i++){
if(!(b.childNodes[i].nodeName&&b.childNodes[i].nodeName.toLowerCase()=="tr")){
continue;
}
var _12=b.childNodes[i].getElementsByTagName("td");
var o={};
for(var j=0;j<a.length;j++){
var col=a[j];
if(col=="lat"||col=="lng"){
o[col]=parseFloat(_12[j].innerHTML);
}else{
o[col]=_12[j].innerHTML;
}
}
this.data.push(o);
}
},render:function(){
var pts=[];
var d=this.data;
for(var i=0;i<d.length;i++){
var pt=new YGeoPoint(d[i].lat,d[i].lng);
pts.push(pt);
var _1a=d[i].icon||null;
if(_1a){
_1a=new YImage(_1a);
}
var m=new YMarker(pt,_1a);
if(d[i].description){
m.addAutoExpand("<div>"+d[i].description+"</div>");
}
this.map.addOverlay(m);
}
var c=this.findCenter(pts);
var z=this.map.getZoomLevel(pts);
this.map.drawZoomAndCenter(c,z);
},initialize:function(_1e,_1f){
if(!YMap||!YGeoPoint){
dojo.raise("dojo.widget.YahooMap: The Yahoo Map script must be included in order to use this widget.");
}
if(this.datasrc){
this.parse(dojo.byId(this.datasrc));
}else{
if(this.domNode.getElementsByTagName("table")[0]){
this.parse(this.domNode.getElementsByTagName("table")[0]);
}
}
},postCreate:function(){
while(this.domNode.childNodes.length>0){
this.domNode.removeChild(this.domNode.childNodes[0]);
}
if(this.width>0&&this.height>0){
this.map=new YMap(this.domNode,YAHOO_MAP_REG,new YSize(this.width,this.height));
}else{
this.map=new YMap(this.domNode);
}
this.setControls();
this.render();
}});

