dojo.provide("dojo.widget.html.loader");
dojo.require("dojo.widget.HtmlWidget");
dojo.require("dojo.io.*");
dojo.require("dojo.lang.common");
dojo.require("dojo.lang.extras");
dojo.require("dojo.experimental");
dojo.experimental("dojo.widget.html.loader");
dojo.widget.html.loader=new (function(){
this.toString=function(){
return "dojo.widget.html.loader";
};
var _1=this;
dojo.addOnLoad(function(){
dojo.experimental(_1.toString());
var _2=dojo.evalObjPath("dojo.undo.browser");
if(djConfig["preventBackButtonFix"]&&_2&&!_2.initialState){
_2.setInitialState(new trackerObj);
}
});
var _3={};
var _4=function(id,_6){
this.id=id;
this.data=_6;
};
_4.prototype.handle=function(_7){
if(typeof dojo=="undefined"){
return;
}
var wg=dojo.widget.byId(this.id);
if(wg){
wg.setContent(this.data,true);
}
};
this._log=function(_9,_a){
if(_9.trackHistory){
if(!_3[_9.widgetId]){
_3[_9.widgetId]={childrenIds:[],stack:[_a]};
}
var _b=_3[_9.widgetId].childrenIds;
while(_b&&_b.length){
delete _3[_b.pop()];
}
for(var _c in _9.children){
_3[_9.widgetId].childrenIds=_c.widgetId;
}
dojo.undo.browser.addToHistory(new _4(_9.widgetId,dojo.lang.shallowCopy(_a,true)));
}
};
var _d=dojo.lang.isUndefined;
var _e=dojo.lang.isFunction;
function handleDefaults(e,_10,_11){
if(!_10){
_10="onContentError";
}
if(dojo.lang.isString(e)){
e={_text:e};
}
if(!e._text){
e._text=e.toString();
}
e.toString=function(){
return this._text;
};
if(typeof e.returnValue!="boolean"){
e.returnValue=true;
}
if(typeof e.preventDefault!="function"){
e.preventDefault=function(){
this.returnValue=false;
};
}
this[_10](e);
if(e.returnValue){
if(_11){
alert(e.toString());
}else{
this.loader.callOnUnLoad.call(this,false);
this.onSetContent(e.toString());
}
}
}
function downloader(_12){
for(var x in this.bindArgs){
_12[x]=(_d(_12[x])?this.bindArgs[x]:undefined);
}
var _14=this.cacheContent;
if(_d(_12.useCache)){
_12.useCache=_14;
}
if(_d(_12.preventCache)){
_12.preventCache=!_14;
}
if(_d(_12.mimetype)){
_12.mimetype="text/html";
}
this.loader.bindObj=dojo.io.bind(_12);
}
function stackRunner(st){
var err="",func=null;
var _17=this.scriptScope||dojo.global();
while(st.length){
func=st.shift();
try{
func.call(_17);
}
catch(e){
err+="\n"+func+" failed: "+e;
}
}
if(err.length){
var _18=(st==this.loader.addOnLoads)?"addOnLoad":"addOnUnLoad";
handleDefaults.call(this,_18+" failure\n "+err,"onExecError",true);
}
}
function stackPusher(st,obj,_1b){
if(typeof _1b=="undefined"){
st.push(obj);
}else{
st.push(function(){
obj[_1b]();
});
}
}
function refreshed(){
this.onResized();
this.onLoad();
this.isLoaded=true;
}
function asyncParse(_1c){
if(this.executeScripts){
this.onExecScript.call(this,_1c.scripts);
}
if(this.parseContent){
this.onContentParse.call(this);
}
refreshed.call(this);
}
function runHandler(){
if(dojo.lang.isFunction(this.handler)){
this.handler(this,this.containerNode||this.domNode);
refreshed.call(this);
return false;
}
return true;
}
this.htmlContentBasicFix=function(s,url){
var _1f=[],styles=[];
var _20=/<title[^>]*>([\s\S]*?)<\/title>/i;
var _21,attr;
while(_21=_20.exec(s)){
_1f.push(_21[1]);
s=s.substring(0,_21.index)+s.substr(_21.index+_21[0].length);
}
_20=/(?:<(style)[^>]*>([\s\S]*?)<\/style>|<link ([^>]*rel=['"]?stylesheet['"]?[^>]*)>)/i;
while(_21=_20.exec(s)){
if(_21[1]&&_21[1].toLowerCase()=="style"){
styles.push(dojo.html.fixPathsInCssText(_21[2],url));
}else{
if(attr=_21[3].match(/href=(['"]?)([^'">]*)\1/i)){
styles.push({path:attr[2]});
}
}
s=s.substring(0,_21.index)+s.substr(_21.index+_21[0].length);
}
return {"s":s,"titles":_1f,"styles":styles};
};
this.htmlContentAdjustPaths=function(s,url){
var tag="",str="",tagFix="",path="";
var _25=[],origPath="",fix="";
var _26=/<[a-z][a-z0-9]*[^>]*\s(?:(?:src|href|style)=[^>])+[^>]*>/i;
var _27=/\s(src|href|style)=(['"]?)([\w()\[\]\/.,\\'"-:;#=&?\s@]+?)\2/i;
var _28=/^(?:[#]|(?:(?:https?|ftps?|file|javascript|mailto|news):))/;
while(tag=_26.exec(s)){
str+=s.substring(0,tag.index);
s=s.substring((tag.index+tag[0].length),s.length);
tag=tag[0];
tagFix="";
while(_25=_27.exec(tag)){
path="";
origPath=_25[3];
switch(_25[1].toLowerCase()){
case "src":
case "href":
if(_28.exec(origPath)){
path=origPath;
}else{
path=(new dojo.uri.Uri(url,origPath).toString());
}
break;
case "style":
path=dojo.html.fixPathsInCssText(origPath,url);
break;
default:
path=origPath;
}
fix=" "+_25[1]+"="+_25[2]+path+_25[2];
tagFix+=tag.substring(0,_25.index)+fix;
tag=tag.substring((_25.index+_25[0].length),tag.length);
}
str+=tagFix+tag;
}
return str+s;
};
this.htmlContentScripts=function(s,_2a){
var _2b=[],requires=[],match=[];
var _2c="",tmp=null,tag="",sc="",str="";
var _2d=/<script([^>]*)>([\s\S]*?)<\/script>/i;
var _2e=/src=(['"]?)([^"']*)\1/i;
var _2f=/.*(\bdojo\b\.js(?:\.uncompressed\.js)?)$/;
var _30=/(?:var )?\bdjConfig\b(?:[\s]*=[\s]*\{[^}]+\}|\.[\w]*[\s]*=[\s]*[^;\n]*)?;?|dojo\.hostenv\.writeIncludes\(\s*\);?/g;
var _31=/dojo\.(?:(?:require(?:After)?(?:If)?)|(?:widget\.(?:manager\.)?registerWidgetPackage)|(?:(?:hostenv\.)?setModulePrefix)|defineNamespace)\((['"]).*?\1\)\s*;?/;
while(match=_2d.exec(s)){
if(this.executeScripts&&match[1]){
if(_2c=_2e.exec(match[1])){
if(_2f.exec(_2c[2])){
dojo.debug("Security note! inhibit:"+_2c[2]+" from  beeing loaded again.");
}else{
_2b.push({path:_2c[2]});
}
}
}
if(match[2]){
sc=match[2].replace(_30,"");
if(!sc){
continue;
}
while(tmp=_31.exec(sc)){
requires.push(tmp[0]);
sc=sc.substring(0,tmp.index)+sc.substr(tmp.index+tmp[0].length);
}
if(_2a){
_2b.push(sc);
}
}
s=s.substr(0,match.index)+s.substr(match.index+match[0].length);
}
if(_2a){
var _2d=/(<[a-zA-Z][a-zA-Z0-9]*\s[^>]*\S=(['"])[^>]*[^\.\]])scriptScope([^>]*>)/;
str="";
while(tag=_2d.exec(s)){
tmp=((tag[2]=="'")?"\"":"'");
str+=s.substring(0,tag.index);
s=s.substr(tag.index).replace(_2d,"$1dojo.widget.byId("+tmp+this.widgetId+tmp+").scriptScope$3");
}
s=str+s;
}
return {"s":s,"requires":requires,"scripts":_2b};
};
this.splitAndFixPaths=function(_32){
if(!_32.url){
_32.url="./";
}
url=new dojo.uri.Uri(location,_32.url).toString();
var ret={"xml":"","styles":[],"titles":[],"requires":[],"scripts":[],"url":url};
if(_32.content){
var tmp=null,content=_32.content;
if(_32.adjustPaths){
content=_1.htmlContentAdjustPaths.call(this,content,url);
}
tmp=_1.htmlContentBasicFix.call(this,content,url);
content=tmp.s;
ret.styles=tmp.styles;
ret.titles=tmp.titles;
if(_32.collectRequires||_32.collectScripts){
tmp=_1.htmlContentScripts.call(this,content,_32.collectScripts);
content=tmp.s;
ret.requires=tmp.requires;
ret.scripts=tmp.scripts;
}
var _35=[];
if(_32.bodyExtract){
_35=content.match(/<body[^>]*>\s*([\s\S]+)\s*<\/body>/im);
if(_35){
content=_35[1];
}
}
ret.xml=content;
}
return ret;
};
this.hookUp=function(_36){
var _37=_36.widget;
if(dojo.lang.isString(_37)){
if(_36.mixin){
dojo.raise(this.toString()+", cant use mixin when widget is a string");
}
_37=dojo.evalObjPath(_37);
}
if(!_37||!(_37 instanceof dojo.widget.HtmlWidget)){
dojo.raise(this.toString()+" Widget isn't defined or isn't a HtmlWidget instance");
}
if(_37.loader&&_37.setUrl){
return;
}
var _38=(_36.mixin)?_37:_37.constructor.prototype;
_37.loader={isLoaded:false,styleNodes:[],addOnLoads:[],addOnUnLoads:[],callOnUnLoad:(function(_39){
return function(_3a){
this.abort();
if(_39){
this.onUnLoad();
}
_39=_3a;
};
})(false),bindObj:null,unHook:(function(w,wg){
var _3d={isContainer:w.isContainer,adjustPats:w.adjustPaths,href:w.href,extractContent:w.extractContent,parseContent:w.parseContent,cacheContent:w.cacheContent,bindArgs:w.bindArgs,preload:w.preload,refreshOnShow:w.refreshOnShow,handler:w.handler,trackHistory:w.trackHistory,executeScripts:w.executeScripts,scriptScope:w.scriptScope,postCreate:w.postCreate,show:w.show,refresh:w.refresh,loadContents:w.loadContents,abort:w.abort,destroy:w.destroy,onLoad:w.onLoad,onUnLoad:w.onUnLoad,addOnLoad:w.addOnLoad,addOnUnLoad:w.addOnUnLoad,onDownloadStart:w.onDownloadStart,onDownloadEnd:w.onDownloadEnd,onDownloadError:w.onDownloadError,onContentError:w.onContentError,onExecError:w.onExecError,onSetContent:w.onSetContent,setUrl:w.setUrl,setContent:w.setContent,onContentParse:w.onContentParse,onExecScript:w.onExecScript,setHandler:w.setHandler};
return function(){
if(wg.abort){
wg.abort();
}
if((w!=wg)&&(dojo.widget.byType(wg.widgetType).length>1)){
return;
}
for(var x in _3d){
if(_3d[x]===undefined){
delete w[x];
continue;
}
w[x]=_3d[x];
}
delete wg._loader_defined;
delete wg.loader;
};
})(_38,_37)};
if(_38._loader_defined||_37._loader_defined){
return;
}
dojo.mixin(_38,{isContainer:true,adjustPaths:_d(_38.adjustPaths)?true:_38.adjustPaths,href:_d(_38.href)?"":_38.href,extractContent:_d(_38.extractContent)?true:_38.extractContent,parseContent:_d(_38.parseContent)?true:_38.parseContent,cacheContent:_d(_38.cacheContent)?true:_38.cacheContent,bindArgs:_d(_38.bindArgs)?{}:_38.bindArgs,preload:_d(_38.preload)?false:_38.preload,refreshOnShow:_d(_38.refreshOnShow)?false:_38.refreshOnShow,handler:_d(_38.handler)?"":_38.handler,executeScripts:_d(_38.executeScripts)?false:_38.executeScripts,trackHistory:_d(_38.tracHistory)?false:_38.trackHistory,scriptScope:null});
_38.postCreate=(function(_3f){
return function(){
if(_38.constructor.superclass.postCreate!=_3f){
_3f.apply(this,arguments);
}else{
_38.constructor.superclass.postCreate.apply(this,arguments);
}
if(this.handler!==""){
this.setHandler(this.handler);
}
if(this.isShowing()||this.preload){
this.loadContents();
if(!this.href){
_1._log(this,(this.domNode||this.containerNode).innerHTML);
}
}
};
})(_38.postCreate);
_38.show=(function(_40){
return function(){
if(this.refreshOnShow){
this.refresh();
}else{
this.loadContents();
}
if((_38.constructor.superclass.show==_40)||!_e(_40)){
_38.constructor.superclass.show.apply(this,arguments);
}else{
_40.apply(this,arguments);
}
};
})(_38.show);
_38.destroy=(function(_41){
return function(_42){
this.onUnLoad();
this.abort();
this.loader.unHook();
if((_38.constructor.superclass.destroy!=_42)&&_e(_42)){
_42.apply(this,arguments);
}else{
_38.constructor.superclass.destroy.apply(this,arguments);
}
};
})(_38.destroy);
if(!_38.refresh){
_38.refresh=function(){
this.loader.isLoaded=false;
this.loadContents();
};
}
if(!_38.loadContents){
_38.loadContents=function(){
if(this.loader.isLoaded){
return;
}
if(_e(this.handler)){
runHandler.call(this);
}else{
if(this.href!==""){
handleDefaults.call(this,"Loading...","onDownloadStart");
var _43=this,url=this.href;
downloader.call(this,{url:url,load:function(_44,_45,xhr){
_43.onDownloadEnd.call(_43,url,_45);
},error:function(_47,err,xhr){
var e={responseText:xhr.responseText,status:xhr.status,statusText:xhr.statusText,responseHeaders:(xhr.getAllResponseHeaders)?xhr.getAllResponseHeaders():[],_text:"Error loading '"+url+"' ("+xhr.status+" "+xhr.statusText+")"};
handleDefaults.call(_43,e,"onDownloadError");
_43.onLoad();
}});
}
}
};
}
if(!_38.abort){
_38.abort=function(){
if(!this.loader||!this.loader.bindObj||!this.loader.bindObj.abort){
return;
}
this.loader.bindObj.abort();
this.loader.bindObj=null;
};
}
if(!_38.onLoad){
_38.onLoad=function(){
stackRunner.call(this,this.loader.addOnLoads);
this.loader.isLoaded=true;
};
}
if(!_38.onUnLoad){
_38.onUnLoad=function(){
stackRunner.call(this,this.loader.addOnUnLoads);
delete this.scriptScope;
};
}
if(!_38.addOnLoad){
_38.addOnLoad=function(obj,_4c){
stackPusher.call(this,this.loader.addOnLoads,obj,_4c);
};
}
if(!_38.addOnUnLoad){
_38.addOnUnLoad=function(obj,_4e){
stackPusher.call(this,this.loader.addOnUnLoads,obj,_4e);
};
}
if(!_38.onExecError){
_38.onExecError=function(){
};
}
if(!_38.onContentError){
_38.onContentError=function(){
};
}
if(!_38.onDownloadError){
_38.onDownloadError=function(){
};
}
if(!_38.onDownloadStart){
_38.onDownloadStart=function(_4f){
};
}
if(!_38.onDownloadEnd){
_38.onDownloadEnd=function(url,_51){
var _52={content:_51,url:url,adjustPaths:this.adjustPaths,collectScripts:this.executeScripts,collectRequires:this.parseContent,bodyExtract:this.extractContent};
_51=_1.splitAndFixPaths.call(this,_52);
this.setContent(_51);
};
}
if(!_38.onSetContent){
_38.onSetContent=function(_53){
this.destroyChildren();
var _54=this.loader.styleNodes;
while(_54.length){
var st=_54.pop();
if(st&&st.parentNode){
st.parentNode.removeChild(st);
}
}
var _56=this.containerNode||this.domNode;
while(_56.firstChild){
try{
dojo.event.browser.clean(_56.firstChild);
}
catch(e){
}
_56.removeChild(_56.firstChild);
}
try{
if(typeof _53!="string"){
_56.appendChild(_53);
}else{
try{
_56.innerHTML=_53;
}
catch(e){
var tmp;
(tmp=dojo.doc().createElement("div")).innerHTML=_53;
while(tmp.firstChild){
_56.appendChild(tmp.removeChild(tmp.firstChild));
}
}
}
}
catch(e){
e._text="Could'nt load content: "+e;
var _58=(this.loader._onSetContent_err==e._text);
this.loader._onSetContent_err=e._text;
handleDefaults.call(this,e,"onContentError",_58);
}
};
}
if(!_38.setUrl){
_38.setUrl=function(url){
this.href=url;
this.loader.isLoaded=false;
if(this.preload||this.isShowing()){
this.loadContents();
}
};
}
if(!_38.setContent){
_38.setContent=function(_5a,_5b){
this.loader.callOnUnLoad.call(this,true);
if(!_5a||dojo.html.isNode(_5a)){
this.onSetContent(_5a);
refreshed.call(this);
}else{
if(typeof _5a.xml!="string"){
this.href="";
var _5c={content:_5a,url:this.href,adjustPaths:this.adjustPaths,collectScripts:this.executeScripts,collectRequires:this.parseContent,bodyExtract:this.extractContent};
_5a=_1.splitAndFixPaths.call(this,_5c);
}else{
if(_5a.url!="./"){
this.url=_5a.url;
}
}
this.onSetContent(_5a.xml);
for(var i=0,styles=_5a.styles;i<styles.length;i++){
if(styles[i].path){
this.loader.styleNodes.push(dojo.html.insertCssFile(styles[i].path));
}else{
this.loader.styleNodes.push(dojo.html.insertCssText(styles[i]));
}
}
if(this.parseContent){
for(var i=0,requires=_5a.requires;i<requires.length;i++){
try{
eval(requires[i]);
}
catch(e){
e._text="dojo.widget.html.loader.hookUp: error in package loading calls, "+(e.description||e);
handleDefaults.call(this,e,"onContentError",true);
}
}
}
if(dojo.hostenv.isXDomain&&_5a.requires.length){
dojo.addOnLoad(function(){
asyncParse.call(this,_5a);
if(!_5b){
_1._log(this,_5a);
}
});
_5b=true;
}else{
asyncParse.call(this,_5a);
}
}
if(!_5b){
}
};
}
if(!_38.onContentParse){
_38.onContentParse=function(){
var _5e=this.containerNode||this.domNode;
var _5f=new dojo.xml.Parse();
var _60=_5f.parseElement(_5e,null,true);
dojo.widget.getParser().createSubComponents(_60,this);
};
}
if(!_38.onExecScript){
_38.onExecScript=function(_61){
var _62=this,tmp="",code="";
for(var i=0;i<_61.length;i++){
if(_61[i].path){
var url=_61[i].path;
downloader.call(this,{"url":url,"load":function(_65,_66){
(function(){
tmp=_66;
_61[i]=_66;
}).call(_62);
},"error":function(_67,_68){
_68._text=_67+" downloading remote script";
handleDefaults.call(_62,_68,"onExecError",true);
},"mimetype":"text/plain","sync":true});
code+=tmp;
}else{
code+=_61[i];
}
}
try{
delete this.scriptScope;
this.scriptScope=new (new Function("_container_",code+"; return this;"))(_62);
}
catch(e){
e._text="Error running scripts from content:\n"+(e.description||e.toString());
handleDefaults.call(this,e,"onExecError",true);
}
};
}
if(!_38.setHandler){
_38.setHandler=function(_69){
var fcn=dojo.lang.isFunction(_69)?_69:window[_69];
if(!_e(fcn)){
handleDefaults.call(this,"Unable to set handler, '"+_69+"' not a function.","onExecError",true);
return;
}
this.handler=function(){
return fcn.apply(this,arguments);
};
};
}
_38._loader_defined=true;
};
})();

