dojo.provide("dojo.collections.Store");
dojo.require("dojo.lang.common");
dojo.collections.Store=function(_1){
var _2=[];
this.keyField="Id";
this.get=function(){
return _2;
};
this.getByKey=function(_3){
for(var i=0;i<_2.length;i++){
if(_2[i].key==_3){
return _2[i];
}
}
return null;
};
this.getByIndex=function(_5){
return _2[_5];
};
this.getData=function(){
var _6=[];
for(var i=0;i<_2.length;i++){
_6.push(_2[i].src);
}
return _6;
};
this.getDataByKey=function(_8){
for(var i=0;i<_2.length;i++){
if(_2[i].key==_8){
return _2[i].src;
}
}
return null;
};
this.getDataByIndex=function(_a){
return _2[_a].src;
};
this.update=function(_b,_c,_d){
var _e=_c.split("."),i=0,o=_b,field;
if(_e.length>1){
field=_e.pop();
do{
if(_e[i].indexOf("()")>-1){
var _f=_e[i++].split("()")[0];
if(!o[_f]){
dojo.raise("dojo.collections.Store.getField(obj, '"+field+"'): '"+_f+"' is not a property of the passed object.");
}else{
o=o[_f]();
}
}else{
o=o[_e[i++]];
}
}while(i<_e.length&&o!=null);
}else{
field=_e[0];
}
_b[field]=_d;
this.onUpdateField(_b,_c,_d);
};
this.forEach=function(fn){
if(Array.forEach){
Array.forEach(_2,fn,this);
}else{
for(var i=0;i<_2.length;i++){
fn.call(this,_2[i]);
}
}
};
this.forEachData=function(fn){
if(Array.forEach){
Array.forEach(this.getData(),fn,this);
}else{
var a=this.getData();
for(var i=0;i<a.length;i++){
fn.call(this,a[i]);
}
}
};
this.setData=function(arr){
_2=[];
for(var i=0;i<arr.length;i++){
_2.push({key:arr[i][this.keyField],src:arr[i]});
}
this.onSetData();
};
this.clearData=function(){
_2=[];
this.onClearData();
};
this.addData=function(obj,key){
var k=key||obj[this.keyField];
if(this.getByKey(k)){
var o=this.getByKey(k);
o.src=obj;
}else{
var o={key:k,src:obj};
_2.push(o);
}
this.onAddData(o);
};
this.addDataRange=function(arr){
var _1c=[];
for(var i=0;i<arr.length;i++){
var k=arr[i][this.keyField];
if(this.getByKey(k)){
var o=this.getByKey(k);
o.src=obj;
}else{
var o={key:k,src:arr[i]};
_2.push(o);
}
_1c.push(o);
}
this.onAddDataRange(_1c);
};
this.removeData=function(obj){
var idx=-1;
var o=null;
for(var i=0;i<_2.length;i++){
if(_2[i].src==obj){
idx=i;
o=_2[i];
break;
}
}
this.onRemoveData(o);
if(idx>-1){
_2.splice(idx,1);
}
};
this.removeDataByKey=function(key){
this.removeData(this.getDataByKey(key));
};
this.removeDataByIndex=function(idx){
this.removeData(this.getDataByIndex(idx));
};
if(_1&&_1.length&&_1[0]){
this.setData(_1);
}
};
dojo.extend(dojo.collections.Store,{getField:function(obj,_27){
var _28=_27.split("."),i=0,o=obj;
do{
if(_28[i].indexOf("()")>-1){
var _29=_28[i++].split("()")[0];
if(!o[_29]){
dojo.raise("dojo.collections.Store.getField(obj, '"+_27+"'): '"+_29+"' is not a property of the passed object.");
}else{
o=o[_29]();
}
}else{
o=o[_28[i++]];
}
}while(i<_28.length&&o!=null);
if(i<_28.length){
dojo.raise("dojo.collections.Store.getField(obj, '"+_27+"'): '"+_27+"' is not a property of the passed object.");
}
return o;
},getFromHtml:function(_2a,_2b,_2c){
var _2d=_2b.rows;
var _2e=function(row){
var obj={};
for(var i=0;i<_2a.length;i++){
var o=obj;
var _33=row.cells[i].innerHTML;
var p=_2a[i].getField();
if(p.indexOf(".")>-1){
p=p.split(".");
while(p.length>1){
var pr=p.shift();
o[pr]={};
o=o[pr];
}
p=p[0];
}
var _36=_2a[i].getType();
if(_36==String){
o[p]=_33;
}else{
if(_33){
o[p]=new _36(_33);
}else{
o[p]=new _36();
}
}
}
return obj;
};
var arr=[];
for(var i=0;i<_2d.length;i++){
var o=_2e(_2d[i]);
if(_2c){
_2c(o,_2d[i]);
}
arr.push(o);
}
return arr;
},onSetData:function(){
},onClearData:function(){
},onAddData:function(obj){
},onAddDataRange:function(arr){
},onRemoveData:function(obj){
},onUpdateField:function(obj,_3e,val){
}});

