dojo.provide("dojo.data.OpmlStore");
dojo.require("dojo.data.core.Read");
dojo.require("dojo.data.core.Result");
dojo.require("dojo.lang.assert");
dojo.require("dojo.json");
dojo.require("dojo.experimental");
dojo.experimental("dojo.data.OpmlStore");
dojo.declare("dojo.data.OpmlStore",dojo.data.core.Read,{initializer:function(_1){
this._arrayOfTopLevelItems=[];
this._metadataNodes=null;
this._loadFinished=false;
this._opmlFileUrl=_1["url"];
},_assertIsItem:function(_2){
if(!this.isItem(_2)){
throw new Error("dojo.data.OpmlStore: a function was passed an item argument that was not an item");
}
},_removeChildNodesThatAreNotElementNodes:function(_3,_4){
var _5=_3.childNodes;
if(_5.length==0){
return;
}
var _6=[];
var i,childNode;
for(i=0;i<_5.length;++i){
childNode=_5[i];
if(childNode.nodeType!=Node.ELEMENT_NODE){
_6.push(childNode);
}
}
for(i=0;i<_6.length;++i){
childNode=_6[i];
_3.removeChild(childNode);
}
if(_4){
for(i=0;i<_5.length;++i){
childNode=_5[i];
this._removeChildNodesThatAreNotElementNodes(childNode,_4);
}
}
},_processRawXmlTree:function(_8){
var _9=_8.getElementsByTagName("head");
var _a=_9[0];
this._removeChildNodesThatAreNotElementNodes(_a);
this._metadataNodes=_a.childNodes;
var _b=_8.getElementsByTagName("body");
var _c=_b[0];
this._removeChildNodesThatAreNotElementNodes(_c,true);
var _d=_b[0].childNodes;
for(var i=0;i<_d.length;++i){
var _f=_d[i];
if(_f.tagName=="outline"){
this._arrayOfTopLevelItems.push(_f);
}
}
},get:function(_10,_11,_12){
this._assertIsItem(_10);
if(_11=="children"){
return (_10.firstChild||_12);
}else{
var _13=_10.getAttribute(_11);
_13=(_13!=undefined)?_13:_12;
return _13;
}
},getValues:function(_14,_15){
this._assertIsItem(_14);
if(_15=="children"){
var _16=[];
for(var i=0;i<_14.childNodes.length;++i){
_16.push(_14.childNodes[i]);
}
return _16;
}else{
return [_14.getAttribute(_15)];
}
},getAttributes:function(_18){
this._assertIsItem(_18);
var _19=[];
var _1a=_18;
var _1b=_1a.attributes;
for(var i=0;i<_1b.length;++i){
var _1d=_1b.item(i);
_19.push(_1d.nodeName);
}
if(_1a.childNodes.length>0){
_19.push("children");
}
return _19;
},hasAttribute:function(_1e,_1f){
return (this.getValues(_1e,_1f).length>0);
},containsValue:function(_20,_21,_22){
var _23=this.getValues(_20,_21);
for(var i=0;i<_23.length;++i){
var _25=_23[i];
if(_22==_25){
return true;
}
}
return false;
},isItem:function(_26){
return (_26&&_26.nodeType==Node.ELEMENT_NODE&&_26.tagName=="outline");
},isItemAvailable:function(_27){
return this.isItem(_27);
},find:function(_28){
var _29=null;
if(_28 instanceof dojo.data.core.Result){
_29=_28;
_29.store=this;
}else{
_29=new dojo.data.core.Result(_28,this);
}
var _2a=this;
var _2b=function(_2c,_2d,evt){
var _2f=_29.scope||dj_global;
if(_2c=="load"){
_2a._processRawXmlTree(_2d);
if(_29.saveResult){
_29.items=_2a._arrayOfTopLevelItems;
}
if(_29.onbegin){
_29.onbegin.call(_2f,_29);
}
for(var i=0;i<_2a._arrayOfTopLevelItems.length;i++){
var _31=_2a._arrayOfTopLevelItems[i];
if(_29.onnext&&!_29._aborted){
_29.onnext.call(_2f,_31,_29);
}
}
if(_29.oncompleted&&!_29._aborted){
_29.oncompleted.call(_2f,_29);
}
}else{
if(_2c=="error"||_2c=="timeout"){
var _32=_2d;
if(_29.onerror){
_29.onerror.call(_2f,_2d);
}
}
}
};
if(!this._loadFinished){
if(this._opmlFileUrl){
var _33=dojo.io.bind({url:this._opmlFileUrl,handle:_2b,mimetype:"text/xml",sync:(_29.sync||false)});
_29._abortFunc=_33.abort;
}
}
return _29;
},getIdentity:function(_34){
dojo.unimplemented("dojo.data.OpmlStore.getIdentity()");
return null;
},findByIdentity:function(_35){
dojo.unimplemented("dojo.data.OpmlStore.findByIdentity()");
return null;
}});

