dojo.provide("dojo.io.common");
dojo.require("dojo.string");
dojo.require("dojo.lang.extras");
dojo.io.transports=[];
dojo.io.hdlrFuncNames=["load","error","timeout"];
dojo.io.Request=function(_1,_2,_3,_4){
if((arguments.length==1)&&(arguments[0].constructor==Object)){
this.fromKwArgs(arguments[0]);
}else{
this.url=_1;
if(_2){
this.mimetype=_2;
}
if(_3){
this.transport=_3;
}
if(arguments.length>=4){
this.changeUrl=_4;
}
}
};
dojo.lang.extend(dojo.io.Request,{url:"",mimetype:"text/plain",method:"GET",content:undefined,transport:undefined,changeUrl:undefined,formNode:undefined,sync:false,bindSuccess:false,useCache:false,preventCache:false,load:function(_5,_6,_7,_8){
},error:function(_9,_a,_b,_c){
},timeout:function(_d,_e,_f,_10){
},handle:function(_11,_12,_13,_14){
},timeoutSeconds:0,abort:function(){
},fromKwArgs:function(_15){
if(_15["url"]){
_15.url=_15.url.toString();
}
if(_15["formNode"]){
_15.formNode=dojo.byId(_15.formNode);
}
if(!_15["method"]&&_15["formNode"]&&_15["formNode"].method){
_15.method=_15["formNode"].method;
}
if(!_15["handle"]&&_15["handler"]){
_15.handle=_15.handler;
}
if(!_15["load"]&&_15["loaded"]){
_15.load=_15.loaded;
}
if(!_15["changeUrl"]&&_15["changeURL"]){
_15.changeUrl=_15.changeURL;
}
_15.encoding=dojo.lang.firstValued(_15["encoding"],djConfig["bindEncoding"],"");
_15.sendTransport=dojo.lang.firstValued(_15["sendTransport"],djConfig["ioSendTransport"],false);
var _16=dojo.lang.isFunction;
for(var x=0;x<dojo.io.hdlrFuncNames.length;x++){
var fn=dojo.io.hdlrFuncNames[x];
if(_15[fn]&&_16(_15[fn])){
continue;
}
if(_15["handle"]&&_16(_15["handle"])){
_15[fn]=_15.handle;
}
}
dojo.lang.mixin(this,_15);
}});
dojo.io.Error=function(msg,_1a,num){
this.message=msg;
this.type=_1a||"unknown";
this.number=num||0;
};
dojo.io.transports.addTransport=function(_1c){
this.push(_1c);
this[_1c]=dojo.io[_1c];
};
dojo.io.bind=function(_1d){
if(!(_1d instanceof dojo.io.Request)){
try{
_1d=new dojo.io.Request(_1d);
}
catch(e){
dojo.debug(e);
}
}
var _1e="";
if(_1d["transport"]){
_1e=_1d["transport"];
if(!this[_1e]){
dojo.io.sendBindError(_1d,"No dojo.io.bind() transport with name '"+_1d["transport"]+"'.");
return _1d;
}
if(!this[_1e].canHandle(_1d)){
dojo.io.sendBindError(_1d,"dojo.io.bind() transport with name '"+_1d["transport"]+"' cannot handle this type of request.");
return _1d;
}
}else{
for(var x=0;x<dojo.io.transports.length;x++){
var tmp=dojo.io.transports[x];
if((this[tmp])&&(this[tmp].canHandle(_1d))){
_1e=tmp;
break;
}
}
if(_1e==""){
dojo.io.sendBindError(_1d,"None of the loaded transports for dojo.io.bind()"+" can handle the request.");
return _1d;
}
}
this[_1e].bind(_1d);
_1d.bindSuccess=true;
return _1d;
};
dojo.io.sendBindError=function(_21,_22){
if((typeof _21.error=="function"||typeof _21.handle=="function")&&(typeof setTimeout=="function"||typeof setTimeout=="object")){
var _23=new dojo.io.Error(_22);
setTimeout(function(){
_21[(typeof _21.error=="function")?"error":"handle"]("error",_23,null,_21);
},50);
}else{
dojo.raise(_22);
}
};
dojo.io.queueBind=function(_24){
if(!(_24 instanceof dojo.io.Request)){
try{
_24=new dojo.io.Request(_24);
}
catch(e){
dojo.debug(e);
}
}
var _25=_24.load;
_24.load=function(){
dojo.io._queueBindInFlight=false;
var ret=_25.apply(this,arguments);
dojo.io._dispatchNextQueueBind();
return ret;
};
var _27=_24.error;
_24.error=function(){
dojo.io._queueBindInFlight=false;
var ret=_27.apply(this,arguments);
dojo.io._dispatchNextQueueBind();
return ret;
};
dojo.io._bindQueue.push(_24);
dojo.io._dispatchNextQueueBind();
return _24;
};
dojo.io._dispatchNextQueueBind=function(){
if(!dojo.io._queueBindInFlight){
dojo.io._queueBindInFlight=true;
if(dojo.io._bindQueue.length>0){
dojo.io.bind(dojo.io._bindQueue.shift());
}else{
dojo.io._queueBindInFlight=false;
}
}
};
dojo.io._bindQueue=[];
dojo.io._queueBindInFlight=false;
dojo.io.argsFromMap=function(map,_2a,_2b){
var enc=/utf/i.test(_2a||"")?encodeURIComponent:dojo.string.encodeAscii;
var _2d=[];
var _2e=new Object();
for(var _2f in map){
var _30=function(elt){
var val=enc(_2f)+"="+enc(elt);
_2d[(_2b==_2f)?"push":"unshift"](val);
};
if(!_2e[_2f]){
var _33=map[_2f];
if(dojo.lang.isArray(_33)){
dojo.lang.forEach(_33,_30);
}else{
_30(_33);
}
}
}
return _2d.join("&");
};
dojo.io.setIFrameSrc=function(_34,src,_36){
try{
var r=dojo.render.html;
if(!_36){
if(r.safari){
_34.location=src;
}else{
frames[_34.name].location=src;
}
}else{
var _38;
if(r.ie){
_38=_34.contentWindow.document;
}else{
if(r.safari){
_38=_34.document;
}else{
_38=_34.contentWindow;
}
}
if(!_38){
_34.location=src;
return;
}else{
_38.location.replace(src);
}
}
}
catch(e){
dojo.debug(e);
dojo.debug("setIFrameSrc: "+e);
}
};

