dojo.provide("dojo.widget.Checkbox");
dojo.require("dojo.widget.*");
dojo.require("dojo.widget.HtmlWidget");
dojo.require("dojo.event.*");
dojo.require("dojo.html.style");
dojo.require("dojo.html.selection");
dojo.widget.defineWidget("dojo.widget.Checkbox",dojo.widget.HtmlWidget,{templatePath:dojo.uri.dojoUri("src/widget/templates/Checkbox.html"),templateCssPath:dojo.uri.dojoUri("src/widget/templates/Checkbox.css"),name:"",id:"",checked:false,tabIndex:"",value:"on",postMixInProperties:function(){
dojo.widget.Checkbox.superclass.postMixInProperties.apply(this,arguments);
if(!this.disabled&&this.tabIndex==""){
this.tabIndex="0";
}
},fillInTemplate:function(){
this._setInfo();
},postCreate:function(){
var _1=true;
this.id=this.id!=""?this.id:this.widgetId;
if(this.id!=""){
var _2=document.getElementsByTagName("label");
if(_2!=null&&_2.length>0){
for(var i=0;i<_2.length;i++){
if(_2[i].htmlFor==this.id){
_2[i].id=(_2[i].htmlFor+"label");
this._connectEvents(_2[i]);
dojo.widget.wai.setAttr(this.domNode,"waiState","labelledby",_2[i].id);
break;
}
}
}
}
this._connectEvents(this.domNode);
this.inputNode.checked=this.checked;
},_connectEvents:function(_4){
dojo.event.connect(_4,"onmouseover",this,"mouseOver");
dojo.event.connect(_4,"onmouseout",this,"mouseOut");
dojo.event.connect(_4,"onkey",this,"onKey");
dojo.event.connect(_4,"onclick",this,"_onClick");
dojo.html.disableSelection(_4);
},_onClick:function(e){
if(this.disabled==false){
this.checked=!this.checked;
this._setInfo();
}
e.preventDefault();
e.stopPropagation();
this.onClick();
},setValue:function(_6){
if(this.disabled==false){
this.checked=_6;
this._setInfo();
}
},onClick:function(){
},onKey:function(e){
var k=dojo.event.browser.keys;
if(e.key==" "){
this._onClick(e);
}
},mouseOver:function(e){
this._hover(e,true);
},mouseOut:function(e){
this._hover(e,false);
},_hover:function(e,_c){
if(this.disabled==false){
var _d=this.checked?"On":"Off";
var _e="dojoHtmlCheckbox"+_d+"Hover";
if(_c){
dojo.html.addClass(this.imageNode,_e);
}else{
dojo.html.removeClass(this.imageNode,_e);
}
}
},_setInfo:function(){
var _f="dojoHtmlCheckbox"+(this.disabled?"Disabled":"")+(this.checked?"On":"Off");
dojo.html.setClass(this.imageNode,"dojoHtmlCheckbox "+_f);
this.inputNode.checked=this.checked;
if(this.disabled){
this.inputNode.setAttribute("disabled",true);
}else{
this.inputNode.removeAttribute("disabled");
}
dojo.widget.wai.setAttr(this.domNode,"waiState","checked",this.checked);
}});
dojo.widget.defineWidget("dojo.widget.a11y.Checkbox",dojo.widget.Checkbox,{templatePath:dojo.uri.dojoUri("src/widget/templates/CheckboxA11y.html"),fillInTemplate:function(){
},postCreate:function(_10,_11){
this.inputNode.checked=this.checked;
if(this.disabled){
this.inputNode.setAttribute("disabled",true);
}
},_onClick:function(){
this.onClick();
}});

