dojo.provide("dojo.widget.ContentPane");
dojo.require("dojo.widget.*");
dojo.require("dojo.io.*");
dojo.require("dojo.widget.HtmlWidget");
dojo.require("dojo.string");
dojo.require("dojo.string.extras");
dojo.require("dojo.html.style");
dojo.widget.defineWidget("dojo.widget.ContentPane",dojo.widget.HtmlWidget,function(){
this._styleNodes=[];
this._onLoadStack=[];
this._onUnloadStack=[];
this._callOnUnload=false;
this._ioBindObj;
this.scriptScope;
this.bindArgs={};
},{isContainer:true,adjustPaths:true,href:"",extractContent:true,parseContent:true,cacheContent:true,preload:false,refreshOnShow:false,handler:"",executeScripts:false,scriptSeparation:true,loadingMessage:"Loading...",isLoaded:false,postCreate:function(_1,_2,_3){
if(this.handler!==""){
this.setHandler(this.handler);
}
if(this.isShowing()||this.preload){
this.loadContents();
}
},show:function(){
if(this.refreshOnShow){
this.refresh();
}else{
this.loadContents();
}
dojo.widget.ContentPane.superclass.show.call(this);
},refresh:function(){
this.isLoaded=false;
this.loadContents();
},loadContents:function(){
if(this.isLoaded){
return;
}
if(dojo.lang.isFunction(this.handler)){
this._runHandler();
}else{
if(this.href!=""){
this._downloadExternalContent(this.href,this.cacheContent&&!this.refreshOnShow);
}
}
},setUrl:function(_4){
this.href=_4;
this.isLoaded=false;
if(this.preload||this.isShowing()){
this.loadContents();
}
},abort:function(){
var _5=this._ioBindObj;
if(!_5||!_5.abort){
return;
}
_5.abort();
delete this._ioBindObj;
},_downloadExternalContent:function(_6,_7){
this.abort();
this._handleDefaults(this.loadingMessage,"onDownloadStart");
var _8=this;
this._ioBindObj=dojo.io.bind(this._cacheSetting({url:_6,mimetype:"text/html",handler:function(_9,_a,_b){
delete _8._ioBindObj;
if(_9=="load"){
_8.onDownloadEnd.call(_8,_6,_a);
}else{
var e={responseText:_b.responseText,status:_b.status,statusText:_b.statusText,responseHeaders:_b.getAllResponseHeaders(),text:"Error loading '"+_6+"' ("+_b.status+" "+_b.statusText+")"};
_8._handleDefaults.call(_8,e,"onDownloadError");
_8.onLoad();
}
}},_7));
},_cacheSetting:function(_d,_e){
for(var x in this.bindArgs){
if(dojo.lang.isUndefined(_d[x])){
_d[x]=this.bindArgs[x];
}
}
if(dojo.lang.isUndefined(_d.useCache)){
_d.useCache=_e;
}
if(dojo.lang.isUndefined(_d.preventCache)){
_d.preventCache=!_e;
}
if(dojo.lang.isUndefined(_d.mimetype)){
_d.mimetype="text/html";
}
return _d;
},onLoad:function(e){
this._runStack("_onLoadStack");
this.isLoaded=true;
},onUnLoad:function(e){
dojo.deprecated(this.widgetType+".onUnLoad, use .onUnload (lowercased load)",0.5);
},onUnload:function(e){
this._runStack("_onUnloadStack");
delete this.scriptScope;
if(this.onUnLoad!==dojo.widget.ContentPane.prototype.onUnLoad){
this.onUnLoad.apply(this,arguments);
}
},_runStack:function(_13){
var st=this[_13];
var err="";
var _16=this.scriptScope||window;
for(var i=0;i<st.length;i++){
try{
st[i].call(_16);
}
catch(e){
err+="\n"+st[i]+" failed: "+e.description;
}
}
this[_13]=[];
if(err.length){
var _18=(_13=="_onLoadStack")?"addOnLoad":"addOnUnLoad";
this._handleDefaults(_18+" failure\n "+err,"onExecError","debug");
}
},addOnLoad:function(obj,_1a){
this._pushOnStack(this._onLoadStack,obj,_1a);
},addOnUnload:function(obj,_1c){
this._pushOnStack(this._onUnloadStack,obj,_1c);
},addOnUnLoad:function(){
dojo.deprecated(this.widgetType+".addOnUnLoad, use addOnUnload instead. (lowercased Load)",0.5);
this.addOnUnload.apply(this,arguments);
},_pushOnStack:function(_1d,obj,_1f){
if(typeof _1f=="undefined"){
_1d.push(obj);
}else{
_1d.push(function(){
obj[_1f]();
});
}
},destroy:function(){
this.onUnload();
dojo.widget.ContentPane.superclass.destroy.call(this);
},onExecError:function(e){
},onContentError:function(e){
},onDownloadError:function(e){
},onDownloadStart:function(e){
},onDownloadEnd:function(url,_25){
_25=this.splitAndFixPaths(_25,url);
this.setContent(_25);
},_handleDefaults:function(e,_27,_28){
if(!_27){
_27="onContentError";
}
if(dojo.lang.isString(e)){
e={text:e};
}
if(!e.text){
e.text=e.toString();
}
e.toString=function(){
return this.text;
};
if(typeof e.returnValue!="boolean"){
e.returnValue=true;
}
if(typeof e.preventDefault!="function"){
e.preventDefault=function(){
this.returnValue=false;
};
}
this[_27](e);
if(e.returnValue){
switch(_28){
case true:
case "alert":
alert(e.toString());
break;
case "debug":
dojo.debug(e.toString());
break;
default:
if(this._callOnUnload){
this.onUnload();
}
this._callOnUnload=false;
if(arguments.callee._loopStop){
dojo.debug(e.toString());
}else{
arguments.callee._loopStop=true;
this._setContent(e.toString());
}
}
}
arguments.callee._loopStop=false;
},splitAndFixPaths:function(s,url){
var _2b=[],scripts=[],tmp=[];
var _2c=[],requires=[],attr=[],styles=[];
var str="",path="",fix="",tagFix="",tag="",origPath="";
if(!url){
url="./";
}
if(s){
var _2e=/<title[^>]*>([\s\S]*?)<\/title>/i;
while(_2c=_2e.exec(s)){
_2b.push(_2c[1]);
s=s.substring(0,_2c.index)+s.substr(_2c.index+_2c[0].length);
}
if(this.adjustPaths){
var _2f=/<[a-z][a-z0-9]*[^>]*\s(?:(?:src|href|style)=[^>])+[^>]*>/i;
var _30=/\s(src|href|style)=(['"]?)([\w()\[\]\/.,\\'"-:;#=&?\s@]+?)\2/i;
var _31=/^(?:[#]|(?:(?:https?|ftps?|file|javascript|mailto|news):))/;
while(tag=_2f.exec(s)){
str+=s.substring(0,tag.index);
s=s.substring((tag.index+tag[0].length),s.length);
tag=tag[0];
tagFix="";
while(attr=_30.exec(tag)){
path="";
origPath=attr[3];
switch(attr[1].toLowerCase()){
case "src":
case "href":
if(_31.exec(origPath)){
path=origPath;
}else{
path=(new dojo.uri.Uri(url,origPath).toString());
}
break;
case "style":
path=dojo.html.fixPathsInCssText(origPath,url);
break;
default:
path=origPath;
}
fix=" "+attr[1]+"="+attr[2]+path+attr[2];
tagFix+=tag.substring(0,attr.index)+fix;
tag=tag.substring((attr.index+attr[0].length),tag.length);
}
str+=tagFix+tag;
}
s=str+s;
}
_2e=/(?:<(style)[^>]*>([\s\S]*?)<\/style>|<link ([^>]*rel=['"]?stylesheet['"]?[^>]*)>)/i;
while(_2c=_2e.exec(s)){
if(_2c[1]&&_2c[1].toLowerCase()=="style"){
styles.push(dojo.html.fixPathsInCssText(_2c[2],url));
}else{
if(attr=_2c[3].match(/href=(['"]?)([^'">]*)\1/i)){
styles.push({path:attr[2]});
}
}
s=s.substring(0,_2c.index)+s.substr(_2c.index+_2c[0].length);
}
var _2e=/<script([^>]*)>([\s\S]*?)<\/script>/i;
var _32=/src=(['"]?)([^"']*)\1/i;
var _33=/.*(\bdojo\b\.js(?:\.uncompressed\.js)?)$/;
var _34=/(?:var )?\bdjConfig\b(?:[\s]*=[\s]*\{[^}]+\}|\.[\w]*[\s]*=[\s]*[^;\n]*)?;?|dojo\.hostenv\.writeIncludes\(\s*\);?/g;
var _35=/dojo\.(?:(?:require(?:After)?(?:If)?)|(?:widget\.(?:manager\.)?registerWidgetPackage)|(?:(?:hostenv\.)?setModulePrefix|registerModulePath)|defineNamespace)\((['"]).*?\1\)\s*;?/;
while(_2c=_2e.exec(s)){
if(this.executeScripts&&_2c[1]){
if(attr=_32.exec(_2c[1])){
if(_33.exec(attr[2])){
dojo.debug("Security note! inhibit:"+attr[2]+" from  being loaded again.");
}else{
scripts.push({path:attr[2]});
}
}
}
if(_2c[2]){
var sc=_2c[2].replace(_34,"");
if(!sc){
continue;
}
while(tmp=_35.exec(sc)){
requires.push(tmp[0]);
sc=sc.substring(0,tmp.index)+sc.substr(tmp.index+tmp[0].length);
}
if(this.executeScripts){
scripts.push(sc);
}
}
s=s.substr(0,_2c.index)+s.substr(_2c.index+_2c[0].length);
}
if(this.extractContent){
_2c=s.match(/<body[^>]*>\s*([\s\S]+)\s*<\/body>/im);
if(_2c){
s=_2c[1];
}
}
if(this.executeScripts&&this.scriptSeparation){
var _2e=/(<[a-zA-Z][a-zA-Z0-9]*\s[^>]*?\S=)((['"])[^>]*scriptScope[^>]*>)/;
var _37=/([\s'";:\(])scriptScope(.*)/;
str="";
while(tag=_2e.exec(s)){
tmp=((tag[3]=="'")?"\"":"'");
fix="";
str+=s.substring(0,tag.index)+tag[1];
while(attr=_37.exec(tag[2])){
tag[2]=tag[2].substring(0,attr.index)+attr[1]+"dojo.widget.byId("+tmp+this.widgetId+tmp+").scriptScope"+attr[2];
}
str+=tag[2];
s=s.substr(tag.index+tag[0].length);
}
s=str+s;
}
}
return {"xml":s,"styles":styles,"titles":_2b,"requires":requires,"scripts":scripts,"url":url};
},_setContent:function(_38){
this.destroyChildren();
for(var i=0;i<this._styleNodes.length;i++){
if(this._styleNodes[i]&&this._styleNodes[i].parentNode){
this._styleNodes[i].parentNode.removeChild(this._styleNodes[i]);
}
}
this._styleNodes=[];
try{
var _3a=this.containerNode||this.domNode;
while(_3a.firstChild){
dojo.html.destroyNode(_3a.firstChild);
}
if(typeof _38!="string"){
_3a.appendChild(_38);
}else{
_3a.innerHTML=_38;
}
}
catch(e){
e.text="Couldn't load content:"+e.description;
this._handleDefaults(e,"onContentError");
}
},setContent:function(_3b){
this.abort();
if(this._callOnUnload){
this.onUnload();
}
this._callOnUnload=true;
if(!_3b||dojo.html.isNode(_3b)){
this._setContent(_3b);
this.onResized();
this.onLoad();
}else{
if(typeof _3b.xml!="string"){
this.href="";
_3b=this.splitAndFixPaths(_3b);
}
this._setContent(_3b.xml);
for(var i=0;i<_3b.styles.length;i++){
if(_3b.styles[i].path){
this._styleNodes.push(dojo.html.insertCssFile(_3b.styles[i].path,dojo.doc(),false,true));
}else{
this._styleNodes.push(dojo.html.insertCssText(_3b.styles[i]));
}
}
if(this.parseContent){
for(var i=0;i<_3b.requires.length;i++){
try{
eval(_3b.requires[i]);
}
catch(e){
e.text="ContentPane: error in package loading calls, "+(e.description||e);
this._handleDefaults(e,"onContentError","debug");
}
}
}
var _3d=this;
function asyncParse(){
if(_3d.executeScripts){
_3d._executeScripts(_3b.scripts);
}
if(_3d.parseContent){
var _3e=_3d.containerNode||_3d.domNode;
var _3f=new dojo.xml.Parse();
var _40=_3f.parseElement(_3e,null,true);
dojo.widget.getParser().createSubComponents(_40,_3d);
}
_3d.onResized();
_3d.onLoad();
}
if(dojo.hostenv.isXDomain&&_3b.requires.length){
dojo.addOnLoad(asyncParse);
}else{
asyncParse();
}
}
},setHandler:function(_41){
var fcn=dojo.lang.isFunction(_41)?_41:window[_41];
if(!dojo.lang.isFunction(fcn)){
this._handleDefaults("Unable to set handler, '"+_41+"' not a function.","onExecError",true);
return;
}
this.handler=function(){
return fcn.apply(this,arguments);
};
},_runHandler:function(){
var ret=true;
if(dojo.lang.isFunction(this.handler)){
this.handler(this,this.domNode);
ret=false;
}
this.onLoad();
return ret;
},_executeScripts:function(_44){
var _45=this;
var tmp="",code="";
for(var i=0;i<_44.length;i++){
if(_44[i].path){
dojo.io.bind(this._cacheSetting({"url":_44[i].path,"load":function(_48,_49){
dojo.lang.hitch(_45,tmp=";"+_49);
},"error":function(_4a,_4b){
_4b.text=_4a+" downloading remote script";
_45._handleDefaults.call(_45,_4b,"onExecError","debug");
},"mimetype":"text/plain","sync":true},this.cacheContent));
code+=tmp;
}else{
code+=_44[i];
}
}
try{
if(this.scriptSeparation){
delete this.scriptScope;
this.scriptScope=new (new Function("_container_",code+"; return this;"))(_45);
}else{
var djg=dojo.global();
if(djg.execScript){
djg.execScript(code);
}else{
var djd=dojo.doc();
var sc=djd.createElement("script");
sc.appendChild(djd.createTextNode(code));
(this.containerNode||this.domNode).appendChild(sc);
}
}
}
catch(e){
e.text="Error running scripts from content:\n"+e.description;
this._handleDefaults(e,"onExecError","debug");
}
}});

