dojo.provide("dojo.widget.FilteringTable");
dojo.require("dojo.date.format");
dojo.require("dojo.collections.Store");
dojo.require("dojo.html.*");
dojo.require("dojo.html.util");
dojo.require("dojo.html.style");
dojo.require("dojo.html.selection");
dojo.require("dojo.event.*");
dojo.require("dojo.widget.*");
dojo.require("dojo.widget.HtmlWidget");
dojo.widget.defineWidget("dojo.widget.FilteringTable",dojo.widget.HtmlWidget,function(){
this.store=new dojo.collections.Store();
this.valueField="Id";
this.multiple=false;
this.maxSelect=0;
this.maxSortable=1;
this.minRows=0;
this.defaultDateFormat="%D";
this.isInitialized=false;
this.alternateRows=false;
this.columns=[];
this.sortInformation=[{index:0,direction:0}];
this.headClass="";
this.tbodyClass="";
this.headerClass="";
this.headerUpClass="selectedUp";
this.headerDownClass="selectedDown";
this.rowClass="";
this.rowAlternateClass="alt";
this.rowSelectedClass="selected";
this.columnSelected="sorted-column";
},{isContainer:false,templatePath:null,templateCssPath:null,getTypeFromString:function(s){
var _2=s.split("."),i=0,obj=dj_global;
do{
obj=obj[_2[i++]];
}while(i<_2.length&&obj);
return (obj!=dj_global)?obj:null;
},getByRow:function(_3){
return this.store.getByKey(dojo.html.getAttribute(_3,"value"));
},getDataByRow:function(_4){
return this.store.getDataByKey(dojo.html.getAttribute(_4,"value"));
},getRow:function(_5){
var _6=this.domNode.tBodies[0].rows;
for(var i=0;i<_6.length;i++){
if(this.store.getDataByKey(dojo.html.getAttribute(_6[i],"value"))==_5){
return _6[i];
}
}
return null;
},getColumnIndex:function(_8){
for(var i=0;i<this.columns.length;i++){
if(this.columns[i].getField()==_8){
return i;
}
}
return -1;
},getSelectedData:function(){
var _a=this.store.get();
var a=[];
for(var i=0;i<_a.length;i++){
if(_a[i].isSelected){
a.push(_a[i].src);
}
}
if(this.multiple){
return a;
}else{
return a[0];
}
},isSelected:function(_d){
var _e=this.store.get();
for(var i=0;i<_e.length;i++){
if(_e[i].src==_d){
return true;
}
}
return false;
},isValueSelected:function(val){
var v=this.store.getByKey(val);
if(v){
return v.isSelected;
}
return false;
},isIndexSelected:function(idx){
var v=this.store.getByIndex(idx);
if(v){
return v.isSelected;
}
return false;
},isRowSelected:function(row){
var v=this.getByRow(row);
if(v){
return v.isSelected;
}
return false;
},reset:function(){
this.store.clearData();
this.columns=[];
this.sortInformation=[{index:0,direction:0}];
this.resetSelections();
this.isInitialized=false;
this.onReset();
},resetSelections:function(){
this.store.forEach(function(_16){
_16.isSelected=false;
});
},onReset:function(){
},select:function(obj){
var _18=this.store.get();
for(var i=0;i<_18.length;i++){
if(_18[i].src==obj){
_18[i].isSelected=true;
break;
}
}
this.onDataSelect(obj);
},selectByValue:function(val){
this.select(this.store.getDataByKey(val));
},selectByIndex:function(idx){
this.select(this.store.getDataByIndex(idx));
},selectByRow:function(row){
this.select(this.getDataByRow(row));
},selectAll:function(){
this.store.forEach(function(_1d){
_1d.isSelected=true;
});
},onDataSelect:function(obj){
},toggleSelection:function(obj){
var _20=this.store.get();
for(var i=0;i<_20.length;i++){
if(_20[i].src==obj){
_20[i].isSelected=!_20[i].isSelected;
break;
}
}
this.onDataToggle(obj);
},toggleSelectionByValue:function(val){
this.toggleSelection(this.store.getDataByKey(val));
},toggleSelectionByIndex:function(idx){
this.toggleSelection(this.store.getDataByIndex(idx));
},toggleSelectionByRow:function(row){
this.toggleSelection(this.getDataByRow(row));
},toggleAll:function(){
this.store.forEach(function(_25){
_25.isSelected=!_25.isSelected;
});
},onDataToggle:function(obj){
},_meta:{field:null,format:null,filterer:null,noSort:false,sortType:"String",dataType:String,sortFunction:null,filterFunction:null,label:null,align:"left",valign:"middle",getField:function(){
return this.field||this.label;
},getType:function(){
return this.dataType;
}},createMetaData:function(obj){
for(var p in this._meta){
if(!obj[p]){
obj[p]=this._meta[p];
}
}
if(!obj.label){
obj.label=obj.field;
}
if(!obj.filterFunction){
obj.filterFunction=this._defaultFilter;
}
return obj;
},parseMetadata:function(_29){
this.columns=[];
this.sortInformation=[];
var row=_29.getElementsByTagName("tr")[0];
var _2b=row.getElementsByTagName("td");
if(_2b.length==0){
_2b=row.getElementsByTagName("th");
}
for(var i=0;i<_2b.length;i++){
var o=this.createMetaData({});
if(dojo.html.hasAttribute(_2b[i],"align")){
o.align=dojo.html.getAttribute(_2b[i],"align");
}
if(dojo.html.hasAttribute(_2b[i],"valign")){
o.valign=dojo.html.getAttribute(_2b[i],"valign");
}
if(dojo.html.hasAttribute(_2b[i],"nosort")){
o.noSort=(dojo.html.getAttribute(_2b[i],"nosort")=="true");
}
if(dojo.html.hasAttribute(_2b[i],"sortusing")){
var _2e=dojo.html.getAttribute(_2b[i],"sortusing");
var f=this.getTypeFromString(_2e);
if(f!=null&&f!=window&&typeof (f)=="function"){
o.sortFunction=f;
}
}
o.label=dojo.html.renderedTextContent(_2b[i]);
if(dojo.html.hasAttribute(_2b[i],"field")){
o.field=dojo.html.getAttribute(_2b[i],"field");
}else{
if(o.label.length>0){
o.field=o.label;
}else{
o.field="field"+i;
}
}
if(dojo.html.hasAttribute(_2b[i],"format")){
o.format=dojo.html.getAttribute(_2b[i],"format");
}
if(dojo.html.hasAttribute(_2b[i],"dataType")){
var _30=dojo.html.getAttribute(_2b[i],"dataType");
if(_30.toLowerCase()=="html"||_30.toLowerCase()=="markup"){
o.sortType="__markup__";
}else{
var _31=this.getTypeFromString(_30);
if(_31){
o.sortType=_30;
o.dataType=_31;
}
}
}
if(dojo.html.hasAttribute(_2b[i],"filterusing")){
var _2e=dojo.html.getAttribute(_2b[i],"filterusing");
var f=this.getTypeFromString(_2e);
if(f!=null&&f!=window&&typeof (f)=="function"){
o.filterFunction=f;
}
}
this.columns.push(o);
if(dojo.html.hasAttribute(_2b[i],"sort")){
var _32={index:i,direction:0};
var dir=dojo.html.getAttribute(_2b[i],"sort");
if(!isNaN(parseInt(dir))){
dir=parseInt(dir);
_32.direction=(dir!=0)?1:0;
}else{
_32.direction=(dir.toLowerCase()=="desc")?1:0;
}
this.sortInformation.push(_32);
}
}
if(this.sortInformation.length==0){
this.sortInformation.push({index:0,direction:0});
}else{
if(this.sortInformation.length>this.maxSortable){
this.sortInformation.length=this.maxSortable;
}
}
},parseData:function(_34){
if(_34.rows.length==0&&this.columns.length==0){
return;
}
var _35=this;
this["__selected__"]=[];
var arr=this.store.getFromHtml(this.columns,_34,function(obj,row){
if(typeof (obj[_35.valueField])=="undefined"||obj[_35.valueField]==null){
obj[_35.valueField]=dojo.html.getAttribute(row,"value");
}
if(dojo.html.getAttribute(row,"selected")=="true"){
_35["__selected__"].push(obj);
}
});
this.store.setData(arr,true);
this.render();
for(var i=0;i<this["__selected__"].length;i++){
this.select(this["__selected__"][i]);
}
this.renderSelections();
delete this["__selected__"];
this.isInitialized=true;
},onSelect:function(e){
var row=dojo.html.getParentByType(e.target,"tr");
if(dojo.html.hasAttribute(row,"emptyRow")){
return;
}
var _3c=dojo.html.getParentByType(row,"tbody");
if(this.multiple){
if(e.shiftKey){
var _3d;
var _3e=_3c.rows;
for(var i=0;i<_3e.length;i++){
if(_3e[i]==row){
break;
}
if(this.isRowSelected(_3e[i])){
_3d=_3e[i];
}
}
if(!_3d){
_3d=row;
for(;i<_3e.length;i++){
if(this.isRowSelected(_3e[i])){
row=_3e[i];
break;
}
}
}
this.resetSelections();
if(_3d==row){
this.toggleSelectionByRow(row);
}else{
var _40=false;
for(var i=0;i<_3e.length;i++){
if(_3e[i]==_3d){
_40=true;
}
if(_40){
this.selectByRow(_3e[i]);
}
if(_3e[i]==row){
_40=false;
}
}
}
}else{
this.toggleSelectionByRow(row);
}
}else{
this.resetSelections();
this.toggleSelectionByRow(row);
}
this.renderSelections();
},onSort:function(e){
var _42=this.sortIndex;
var _43=this.sortDirection;
var _44=e.target;
var row=dojo.html.getParentByType(_44,"tr");
var _46="td";
if(row.getElementsByTagName(_46).length==0){
_46="th";
}
var _47=row.getElementsByTagName(_46);
var _48=dojo.html.getParentByType(_44,_46);
for(var i=0;i<_47.length;i++){
dojo.html.setClass(_47[i],this.headerClass);
if(_47[i]==_48){
if(this.sortInformation[0].index!=i){
this.sortInformation.unshift({index:i,direction:0});
}else{
this.sortInformation[0]={index:i,direction:(~this.sortInformation[0].direction)&1};
}
}
}
this.sortInformation.length=Math.min(this.sortInformation.length,this.maxSortable);
for(var i=0;i<this.sortInformation.length;i++){
var idx=this.sortInformation[i].index;
var dir=(~this.sortInformation[i].direction)&1;
dojo.html.setClass(_47[idx],dir==0?this.headerDownClass:this.headerUpClass);
}
this.render();
},onFilter:function(){
},_defaultFilter:function(obj){
return true;
},setFilter:function(_4d,fn){
for(var i=0;i<this.columns.length;i++){
if(this.columns[i].getField()==_4d){
this.columns[i].filterFunction=fn;
break;
}
}
this.applyFilters();
},setFilterByIndex:function(idx,fn){
this.columns[idx].filterFunction=fn;
this.applyFilters();
},clearFilter:function(_52){
for(var i=0;i<this.columns.length;i++){
if(this.columns[i].getField()==_52){
this.columns[i].filterFunction=this._defaultFilter;
break;
}
}
this.applyFilters();
},clearFilterByIndex:function(idx){
this.columns[idx].filterFunction=this._defaultFilter;
this.applyFilters();
},clearFilters:function(){
for(var i=0;i<this.columns.length;i++){
this.columns[i].filterFunction=this._defaultFilter;
}
var _56=this.domNode.tBodies[0].rows;
for(var i=0;i<_56.length;i++){
_56[i].style.display="";
if(this.alternateRows){
dojo.html[((i%2==1)?"addClass":"removeClass")](_56[i],this.rowAlternateClass);
}
}
this.onFilter();
},applyFilters:function(){
var alt=0;
var _58=this.domNode.tBodies[0].rows;
for(var i=0;i<_58.length;i++){
var b=true;
var row=_58[i];
for(var j=0;j<this.columns.length;j++){
var _5d=this.store.getField(this.getDataByRow(row),this.columns[j].getField());
if(this.columns[j].getType()==Date&&_5d!=null&&!_5d.getYear){
_5d=new Date(_5d);
}
if(!this.columns[j].filterFunction(_5d)){
b=false;
break;
}
}
row.style.display=(b?"":"none");
if(b&&this.alternateRows){
dojo.html[((alt++%2==1)?"addClass":"removeClass")](row,this.rowAlternateClass);
}
}
this.onFilter();
},createSorter:function(_5e){
var _5f=this;
var _60=[];
function createSortFunction(_61,dir){
var _63=_5f.columns[_61];
var _64=_63.getField();
return function(_65,_66){
if(dojo.html.hasAttribute(_65,"emptyRow")){
return 1;
}
if(dojo.html.hasAttribute(_66,"emptyRow")){
return -1;
}
var a=_5f.store.getField(_5f.getDataByRow(_65),_64);
var b=_5f.store.getField(_5f.getDataByRow(_66),_64);
var ret=0;
if(a>b){
ret=1;
}
if(a<b){
ret=-1;
}
return dir*ret;
};
}
var _6a=0;
var max=Math.min(_5e.length,this.maxSortable,this.columns.length);
while(_6a<max){
var _6c=(_5e[_6a].direction==0)?1:-1;
_60.push(createSortFunction(_5e[_6a].index,_6c));
_6a++;
}
return function(_6d,_6e){
var idx=0;
while(idx<_60.length){
var ret=_60[idx++](_6d,_6e);
if(ret!=0){
return ret;
}
}
return 0;
};
},createRow:function(obj){
var row=document.createElement("tr");
dojo.html.disableSelection(row);
if(obj.key!=null){
row.setAttribute("value",obj.key);
}
for(var j=0;j<this.columns.length;j++){
var _74=document.createElement("td");
_74.setAttribute("align",this.columns[j].align);
_74.setAttribute("valign",this.columns[j].valign);
dojo.html.disableSelection(_74);
var val=this.store.getField(obj.src,this.columns[j].getField());
if(typeof (val)=="undefined"){
val="";
}
this.fillCell(_74,this.columns[j],val);
row.appendChild(_74);
}
return row;
},fillCell:function(_76,_77,val){
if(_77.sortType=="__markup__"){
_76.innerHTML=val;
}else{
if(_77.getType()==Date){
val=new Date(val);
if(!isNaN(val)){
var _79=this.defaultDateFormat;
if(_77.format){
_79=_77.format;
}
_76.innerHTML=dojo.date.strftime(val,_79);
}else{
_76.innerHTML=val;
}
}else{
if("Number number int Integer float Float".indexOf(_77.getType())>-1){
if(val.length==0){
val="0";
}
var n=parseFloat(val,10)+"";
if(n.indexOf(".")>-1){
n=dojo.math.round(parseFloat(val,10),2);
}
_76.innerHTML=n;
}else{
_76.innerHTML=val;
}
}
}
},prefill:function(){
this.isInitialized=false;
var _7b=this.domNode.tBodies[0];
while(_7b.childNodes.length>0){
_7b.removeChild(_7b.childNodes[0]);
}
if(this.minRows>0){
for(var i=0;i<this.minRows;i++){
var row=document.createElement("tr");
if(this.alternateRows){
dojo.html[((i%2==1)?"addClass":"removeClass")](row,this.rowAlternateClass);
}
row.setAttribute("emptyRow","true");
for(var j=0;j<this.columns.length;j++){
var _7f=document.createElement("td");
_7f.innerHTML="&nbsp;";
row.appendChild(_7f);
}
_7b.appendChild(row);
}
}
},init:function(){
this.isInitialized=false;
var _80=this.domNode.getElementsByTagName("thead")[0];
if(_80.getElementsByTagName("tr").length==0){
var row=document.createElement("tr");
for(var i=0;i<this.columns.length;i++){
var _83=document.createElement("td");
_83.setAttribute("align",this.columns[i].align);
_83.setAttribute("valign",this.columns[i].valign);
dojo.html.disableSelection(_83);
_83.innerHTML=this.columns[i].label;
row.appendChild(_83);
if(!this.columns[i].noSort){
dojo.event.connect(_83,"onclick",this,"onSort");
}
}
dojo.html.prependChild(row,_80);
}
if(this.store.get().length==0){
return false;
}
var idx=this.domNode.tBodies[0].rows.length;
if(!idx||idx==0||this.domNode.tBodies[0].rows[0].getAttribute("emptyRow")=="true"){
idx=0;
var _85=this.domNode.tBodies[0];
while(_85.childNodes.length>0){
_85.removeChild(_85.childNodes[0]);
}
var _86=this.store.get();
for(var i=0;i<_86.length;i++){
var row=this.createRow(_86[i]);
_85.appendChild(row);
idx++;
}
}
if(this.minRows>0&&idx<this.minRows){
idx=this.minRows-idx;
for(var i=0;i<idx;i++){
row=document.createElement("tr");
row.setAttribute("emptyRow","true");
for(var j=0;j<this.columns.length;j++){
_83=document.createElement("td");
_83.innerHTML="&nbsp;";
row.appendChild(_83);
}
_85.appendChild(row);
}
}
var row=this.domNode.getElementsByTagName("thead")[0].rows[0];
var _88="td";
if(row.getElementsByTagName(_88).length==0){
_88="th";
}
var _89=row.getElementsByTagName(_88);
for(var i=0;i<_89.length;i++){
dojo.html.setClass(_89[i],this.headerClass);
}
for(var i=0;i<this.sortInformation.length;i++){
var idx=this.sortInformation[i].index;
var dir=(~this.sortInformation[i].direction)&1;
dojo.html.setClass(_89[idx],dir==0?this.headerDownClass:this.headerUpClass);
}
this.isInitialized=true;
return this.isInitialized;
},render:function(){
if(!this.isInitialized){
var b=this.init();
if(!b){
this.prefill();
return;
}
}
var _8c=[];
var _8d=this.domNode.tBodies[0];
var _8e=-1;
for(var i=0;i<_8d.rows.length;i++){
_8c.push(_8d.rows[i]);
}
var _90=this.createSorter(this.sortInformation);
if(_90){
_8c.sort(_90);
}
for(var i=0;i<_8c.length;i++){
if(this.alternateRows){
dojo.html[((i%2==1)?"addClass":"removeClass")](_8c[i],this.rowAlternateClass);
}
dojo.html[(this.isRowSelected(_8d.rows[i])?"addClass":"removeClass")](_8d.rows[i],this.rowSelectedClass);
_8d.appendChild(_8c[i]);
}
},renderSelections:function(){
var _91=this.domNode.tBodies[0];
for(var i=0;i<_91.rows.length;i++){
dojo.html[(this.isRowSelected(_91.rows[i])?"addClass":"removeClass")](_91.rows[i],this.rowSelectedClass);
}
},initialize:function(){
var _93=this;
dojo.event.connect(this.store,"onSetData",function(){
_93.store.forEach(function(_94){
_94.isSelected=false;
});
_93.isInitialized=false;
var _95=_93.domNode.tBodies[0];
if(_95){
while(_95.childNodes.length>0){
_95.removeChild(_95.childNodes[0]);
}
}
_93.render();
});
dojo.event.connect(this.store,"onClearData",function(){
_93.isInitialized=false;
_93.render();
});
dojo.event.connect(this.store,"onAddData",function(_96){
var row=_93.createRow(_96);
_93.domNode.tBodies[0].appendChild(row);
_93.render();
});
dojo.event.connect(this.store,"onAddDataRange",function(arr){
for(var i=0;i<arr.length;i++){
arr[i].isSelected=false;
var row=_93.createRow(arr[i]);
_93.domNode.tBodies[0].appendChild(row);
}
_93.render();
});
dojo.event.connect(this.store,"onRemoveData",function(_9b){
var _9c=_93.domNode.tBodies[0].rows;
for(var i=0;i<_9c.length;i++){
if(_93.getDataByRow(_9c[i])==_9b.src){
_9c[i].parentNode.removeChild(_9c[i]);
break;
}
}
_93.render();
});
dojo.event.connect(this.store,"onUpdateField",function(obj,_9f,val){
var row=_93.getRow(obj);
var idx=_93.getColumnIndex(_9f);
if(row&&row.cells[idx]&&_93.columns[idx]){
_93.fillCell(row.cells[idx],_93.columns[idx],val);
}
});
},postCreate:function(){
this.store.keyField=this.valueField;
if(this.domNode){
if(this.domNode.nodeName.toLowerCase()!="table"){
}
if(this.domNode.getElementsByTagName("thead")[0]){
var _a3=this.domNode.getElementsByTagName("thead")[0];
if(this.headClass.length>0){
_a3.className=this.headClass;
}
dojo.html.disableSelection(this.domNode);
this.parseMetadata(_a3);
var _a4="td";
if(_a3.getElementsByTagName(_a4).length==0){
_a4="th";
}
var _a5=_a3.getElementsByTagName(_a4);
for(var i=0;i<_a5.length;i++){
if(!this.columns[i].noSort){
dojo.event.connect(_a5[i],"onclick",this,"onSort");
}
}
}else{
this.domNode.appendChild(document.createElement("thead"));
}
if(this.domNode.tBodies.length<1){
var _a7=document.createElement("tbody");
this.domNode.appendChild(_a7);
}else{
var _a7=this.domNode.tBodies[0];
}
if(this.tbodyClass.length>0){
_a7.className=this.tbodyClass;
}
dojo.event.connect(_a7,"onclick",this,"onSelect");
this.parseData(_a7);
}
}});

