dojo.provide("dojo.widget.Form");
dojo.require("dojo.widget.*");
dojo.require("dojo.widget.HtmlWidget");
dojo.widget.defineWidget("dojo.widget.Form",dojo.widget.HtmlWidget,{isContainer:true,templateString:"<form dojoAttachPoint='containerNode' dojoAttachEvent='onSubmit:onSubmit'></form>",formElements:[],ignoreNullValues:false,postCreate:function(_1,_2){
for(var _3 in _1){
if(_3=="dojotype"){
continue;
}
var _4=document.createAttribute(_3);
_4.nodeValue=_1[_3];
this.containerNode.setAttributeNode(_4);
}
},_createRepeaters:function(_5,_6){
for(var i=0;i<_6.children.length;++i){
if(_6.children[i].widgetType=="RepeaterContainer"){
var _8=_6.children[i].index;
var _9=_8.indexOf("%{index}");
_8=_8.substr(0,_9-1);
var _a=this._getObject(_5,_8);
if(typeof (_a)=="object"&&_a.length==0){
_a=new Array();
}
var _b=_6.children[i].getRowCount();
for(var j=0,len=_b;j<len;++j){
_6.children[i].deleteRow(0);
}
for(var j=0;j<_a.length;j++){
_6.children[i].addRow(false);
}
}
if(_6.children[i].isContainer){
this._createRepeaters(_5,_6.children[i]);
}
}
},_createFormElements:function(){
if(dojo.render.html.safari){
this.formElements=[];
var _d=["INPUT","SELECT","TEXTAREA"];
for(var k=0;k<_d.length;k++){
var _f=this.containerNode.getElementsByTagName(_d[k]);
for(var j=0,len2=_f.length;j<len2;j++){
this.formElements.push(_f[j]);
}
}
}else{
this.formElements=this.containerNode.elements;
}
},onSubmit:function(e){
e.preventDefault();
},submit:function(){
this.containerNode.submit();
},_getFormElement:function(_12){
if(dojo.render.html.ie){
for(var i=0,len=this.formElements.length;i<len;i++){
var _14=this.formElements[i];
if(_14.name==_12){
return _14;
}
}
}else{
var _15=this.formElements[_12];
if(typeof (_15)!="undefined"){
return _15;
}
}
return null;
},_getObject:function(obj,_17){
var _18=[];
_18=_17.split(".");
var _19=obj;
var _1a=_18[_18.length-1];
for(var j=0,len=_18.length;j<len;++j){
var p=_18[j];
if(typeof (_19[p])=="undefined"){
_19[p]={};
}
_19=_19[p];
}
return _19;
},_setToContainers:function(obj,_1e){
for(var i=0,len=_1e.children.length;i<len;++i){
var _20=_1e.children[i];
if(_20.widgetType=="Repeater"){
for(var j=0,len=_20.getRowCount();j<len;++j){
_20._initRow(j);
}
}
if(_20.isContainer){
this._setToContainers(obj,_20);
continue;
}
switch(_20.widgetType){
case "Checkbox":
_20.setValue(_20.inputNode.checked);
break;
case "DropdownDatePicker":
_20.setValue(_20.getValue());
break;
case "Select":
continue;
break;
case "ComboBox":
continue;
break;
default:
break;
}
}
},setValues:function(obj){
this._createFormElements();
this._createRepeaters(obj,this);
for(var i=0,len=this.formElements.length;i<len;i++){
var _24=this.formElements[i];
if(_24.name==""){
continue;
}
var _25=new Array();
_25=_24.name.split(".");
var _26=obj;
var _27=_25[_25.length-1];
for(var j=1,len2=_25.length;j<len2;++j){
var p=_25[j-1];
if(typeof (_26[p])=="undefined"){
_26=undefined;
break;
}
_26=_26[p];
}
if(typeof (_26)=="undefined"){
continue;
}
if(typeof (_26[_27])=="undefined"&&this.ignoreNullValues){
continue;
}
var _2a=_24.type;
if(_2a=="hidden"||_2a=="text"||_2a=="textarea"||_2a=="password"){
_2a="text";
}
switch(_2a){
case "checkbox":
_24.checked=false;
if(typeof (_26[_27])=="undefined"){
continue;
}
for(var j=0,len2=_26[_27].length;j<len2;++j){
if(_24.value==_26[_27][j]){
_24.checked=true;
}
}
break;
case "radio":
_24.checked=false;
if(typeof (_26[_27])=="undefined"){
continue;
}
if(_26[_27]==_24.value){
_24.checked=true;
}
break;
case "select-multiple":
_24.selectedIndex=-1;
for(var j=0,len2=_24.options.length;j<len2;++j){
for(var k=0,len3=_26[_27].length;k<len3;++k){
if(_24.options[j].value==_26[_27][k]){
_24.options[j].selected=true;
}
}
}
break;
case "select-one":
_24.selectedIndex="0";
for(var j=0,len2=_24.options.length;j<len2;++j){
if(_24.options[j].value==_26[_27]){
_24.options[j].selected=true;
}else{
}
}
break;
case "text":
var _2c="";
if(typeof (_26[_27])!="undefined"){
_2c=_26[_27];
}
_24.value=_2c;
break;
default:
dojo.debug("Not supported type ("+_2a+")");
break;
}
}
this._setToContainers(obj,this);
},getValues:function(){
this._createFormElements();
var obj={};
for(var i=0,len=this.formElements.length;i<len;i++){
var elm=this.formElements[i];
var _30=[];
if(elm.name==""){
continue;
}
_30=elm.name.split(".");
var _31=obj;
var _32=_30[_30.length-1];
for(var j=1,len2=_30.length;j<len2;++j){
var _34=null;
var p=_30[j-1];
var _36=p.split("[");
if(_36.length>1){
if(typeof (_31[_36[0]])=="undefined"){
_31[_36[0]]=[];
}
_34=parseInt(_36[1]);
if(typeof (_31[_36[0]][_34])=="undefined"){
_31[_36[0]][_34]={};
}
}else{
if(typeof (_31[_36[0]])=="undefined"){
_31[_36[0]]={};
}
}
if(_36.length==1){
_31=_31[_36[0]];
}else{
_31=_31[_36[0]][_34];
}
}
if((elm.type!="select-multiple"&&elm.type!="checkbox"&&elm.type!="radio")||(elm.type=="radio"&&elm.checked)){
if(_32==_32.split("[")[0]){
_31[_32]=elm.value;
}else{
}
}else{
if(elm.type=="checkbox"&&elm.checked){
if(typeof (_31[_32])=="undefined"){
_31[_32]=[];
}
_31[_32].push(elm.value);
}else{
if(elm.type=="select-multiple"){
if(typeof (_31[_32])=="undefined"){
_31[_32]=[];
}
for(var jdx=0,len3=elm.options.length;jdx<len3;++jdx){
if(elm.options[jdx].selected){
_31[_32].push(elm.options[jdx].value);
}
}
}
}
}
_32=undefined;
}
return obj;
}});

