dojo.provide("dojo.widget.Repeater");
dojo.require("dojo.widget.HtmlWidget");
dojo.require("dojo.string");
dojo.require("dojo.event.*");
dojo.require("dojo.experimental");
dojo.experimental("dojo.widget.Repeater");
dojo.widget.defineWidget("dojo.widget.Repeater",dojo.widget.HtmlWidget,{name:"",rowTemplate:"",myObject:null,pattern:"",useDnd:false,isContainer:true,initialize:function(_1,_2){
var _3=this.getFragNodeRef(_2);
_3.removeAttribute("dojotype");
this.setRow(dojo.string.trim(_3.innerHTML),{});
_3.innerHTML="";
_2=null;
},postCreate:function(_4,_5){
if(this.useDnd){
dojo.require("dojo.dnd.*");
var _6=new dojo.dnd.HtmlDropTarget(this.domNode,[this.widgetId]);
}
},_reIndexRows:function(){
for(var i=0,len=this.domNode.childNodes.length;i<len;i++){
var _8=["INPUT","SELECT","TEXTAREA"];
for(var k=0;k<_8.length;k++){
var _a=this.domNode.childNodes[i].getElementsByTagName(_8[k]);
for(var j=0,len2=_a.length;j<len2;j++){
var _c=_a[j].name;
var _d=dojo.string.escape("regexp",this.pattern);
_d=_d.replace(/(%\\\{index\\\})/g,"%{index}");
var _e=dojo.string.substituteParams(_d,{"index":"[0-9]*"});
var _f=dojo.string.substituteParams(this.pattern,{"index":""+i});
var re=new RegExp(_e,"g");
_a[j].name=_c.replace(re,_f);
}
}
}
},onDeleteRow:function(e){
var _12=dojo.string.escape("regexp",this.pattern);
_12=_12.replace(/%\\\{index\\\}/g,"%{index}");
var _13=dojo.string.substituteParams(_12,{"index":"([0-9]*)"});
var re=new RegExp(_13,"g");
this.deleteRow(re.exec(e.target.name)[1]);
},hasRows:function(){
if(this.domNode.childNodes.length>0){
return true;
}
return false;
},getRowCount:function(){
return this.domNode.childNodes.length;
},deleteRow:function(idx){
this.domNode.removeChild(this.domNode.childNodes[idx]);
this._reIndexRows();
},_changeRowPosition:function(e){
if(e.dragStatus=="dropFailure"){
this.domNode.removeChild(e["dragSource"].domNode);
}else{
if(e.dragStatus=="dropSuccess"){
}
}
this._reIndexRows();
},setRow:function(_17,_18){
_17=_17.replace(/\%\{(index)\}/g,"0");
this.rowTemplate=_17;
this.myObject=_18;
},getRow:function(){
return this.rowTemplate;
},_initRow:function(_19){
if(typeof (_19)=="number"){
_19=this.domNode.childNodes[_19];
}
var _1a=["INPUT","SELECT","IMG"];
for(var k=0;k<_1a.length;k++){
var _1c=_19.getElementsByTagName(_1a[k]);
for(var i=0,len=_1c.length;i<len;i++){
var _1e=_1c[i];
if(_1e.nodeType!=1){
continue;
}
if(_1e.getAttribute("rowFunction")!=null){
if(typeof (this.myObject[_1e.getAttribute("rowFunction")])=="undefined"){
dojo.debug("Function "+_1e.getAttribute("rowFunction")+" not found");
}else{
this.myObject[_1e.getAttribute("rowFunction")](_1e);
}
}else{
if(_1e.getAttribute("rowAction")!=null){
if(_1e.getAttribute("rowAction")=="delete"){
_1e.name=dojo.string.substituteParams(this.pattern,{"index":""+(this.getRowCount()-1)});
dojo.event.connect(_1e,"onclick",this,"onDeleteRow");
}
}
}
}
}
},onAddRow:function(e){
},addRow:function(_20){
if(typeof (_20)=="undefined"){
_20=true;
}
var _21=document.createElement("span");
_21.innerHTML=this.getRow();
if(_21.childNodes.length==1){
_21=_21.childNodes[0];
}
this.domNode.appendChild(_21);
var _22=new dojo.xml.Parse();
var _23=_22.parseElement(_21,null,true);
dojo.widget.getParser().createSubComponents(_23,this);
this._reIndexRows();
if(_20){
this._initRow(_21);
}
if(this.useDnd){
_21=new dojo.dnd.HtmlDragSource(_21,this.widgetId);
dojo.event.connect(_21,"onDragEnd",this,"_changeRowPosition");
}
this.onAddRow(_21);
}});

