dojo.provide("dojo.widget.TreeSelector");
dojo.require("dojo.widget.HtmlWidget");
dojo.widget.defineWidget("dojo.widget.TreeSelector",dojo.widget.HtmlWidget,function(){
this.eventNames={};
this.listenedTrees=[];
},{widgetType:"TreeSelector",selectedNode:null,dieWithTree:false,eventNamesDefault:{select:"select",destroy:"destroy",deselect:"deselect",dblselect:"dblselect"},initialize:function(){
for(name in this.eventNamesDefault){
if(dojo.lang.isUndefined(this.eventNames[name])){
this.eventNames[name]=this.widgetId+"/"+this.eventNamesDefault[name];
}
}
},destroy:function(){
dojo.event.topic.publish(this.eventNames.destroy,{source:this});
return dojo.widget.HtmlWidget.prototype.destroy.apply(this,arguments);
},listenTree:function(_1){
dojo.event.topic.subscribe(_1.eventNames.titleClick,this,"select");
dojo.event.topic.subscribe(_1.eventNames.iconClick,this,"select");
dojo.event.topic.subscribe(_1.eventNames.collapse,this,"onCollapse");
dojo.event.topic.subscribe(_1.eventNames.moveFrom,this,"onMoveFrom");
dojo.event.topic.subscribe(_1.eventNames.removeNode,this,"onRemoveNode");
dojo.event.topic.subscribe(_1.eventNames.treeDestroy,this,"onTreeDestroy");
this.listenedTrees.push(_1);
},unlistenTree:function(_2){
dojo.event.topic.unsubscribe(_2.eventNames.titleClick,this,"select");
dojo.event.topic.unsubscribe(_2.eventNames.iconClick,this,"select");
dojo.event.topic.unsubscribe(_2.eventNames.collapse,this,"onCollapse");
dojo.event.topic.unsubscribe(_2.eventNames.moveFrom,this,"onMoveFrom");
dojo.event.topic.unsubscribe(_2.eventNames.removeNode,this,"onRemoveNode");
dojo.event.topic.unsubscribe(_2.eventNames.treeDestroy,this,"onTreeDestroy");
for(var i=0;i<this.listenedTrees.length;i++){
if(this.listenedTrees[i]===_2){
this.listenedTrees.splice(i,1);
break;
}
}
},onTreeDestroy:function(_4){
this.unlistenTree(_4.source);
if(this.dieWithTree){
this.destroy();
}
},onCollapse:function(_5){
if(!this.selectedNode){
return;
}
var _6=_5.source;
var _7=this.selectedNode.parent;
while(_7!==_6&&_7.isTreeNode){
_7=_7.parent;
}
if(_7.isTreeNode){
this.deselect();
}
},select:function(_8){
var _9=_8.source;
var e=_8.event;
if(this.selectedNode===_9){
if(e.ctrlKey||e.shiftKey||e.metaKey){
this.deselect();
return;
}
dojo.event.topic.publish(this.eventNames.dblselect,{node:_9});
return;
}
if(this.selectedNode){
this.deselect();
}
this.doSelect(_9);
dojo.event.topic.publish(this.eventNames.select,{node:_9});
},onMoveFrom:function(_b){
if(_b.child!==this.selectedNode){
return;
}
if(!dojo.lang.inArray(this.listenedTrees,_b.newTree)){
this.deselect();
}
},onRemoveNode:function(_c){
if(_c.child!==this.selectedNode){
return;
}
this.deselect();
},doSelect:function(_d){
_d.markSelected();
this.selectedNode=_d;
},deselect:function(){
var _e=this.selectedNode;
this.selectedNode=null;
_e.unMarkSelected();
dojo.event.topic.publish(this.eventNames.deselect,{node:_e});
}});

