dojo.provide("dojo.widget.TreeSelectorV3");
dojo.require("dojo.widget.HtmlWidget");
dojo.require("dojo.widget.TreeCommon");
dojo.widget.defineWidget("dojo.widget.TreeSelectorV3",[dojo.widget.HtmlWidget,dojo.widget.TreeCommon],function(){
this.eventNames={};
this.listenedTrees={};
this.selectedNodes=[];
this.lastClicked={};
},{listenTreeEvents:["afterTreeCreate","afterCollapse","afterChangeTree","afterDetach","beforeTreeDestroy"],listenNodeFilter:function(_1){
return _1 instanceof dojo.widget.Widget;
},allowedMulti:true,dblselectTimeout:300,eventNamesDefault:{select:"select",deselect:"deselect",dblselect:"dblselect"},onAfterTreeCreate:function(_2){
var _3=_2.source;
dojo.event.browser.addListener(_3.domNode,"onclick",dojo.lang.hitch(this,this.onTreeClick));
if(dojo.render.html.ie){
dojo.event.browser.addListener(_3.domNode,"ondblclick",dojo.lang.hitch(this,this.onTreeDblClick));
}
dojo.event.browser.addListener(_3.domNode,"onKey",dojo.lang.hitch(this,this.onKey));
},onKey:function(e){
if(!e.key||e.ctrkKey||e.altKey){
return;
}
switch(e.key){
case e.KEY_ENTER:
var _5=this.domElement2TreeNode(e.target);
if(_5){
this.processNode(_5,e);
}
}
},onAfterChangeTree:function(_6){
if(!_6.oldTree&&_6.node.selected){
this.select(_6.node);
}
if(!_6.newTree||!this.listenedTrees[_6.newTree.widgetId]){
if(this.selectedNode&&_6.node.children){
this.deselectIfAncestorMatch(_6.node);
}
}
},initialize:function(_7){
for(name in this.eventNamesDefault){
if(dojo.lang.isUndefined(this.eventNames[name])){
this.eventNames[name]=this.widgetId+"/"+this.eventNamesDefault[name];
}
}
},onBeforeTreeDestroy:function(_8){
this.unlistenTree(_8.source);
},onAfterCollapse:function(_9){
this.deselectIfAncestorMatch(_9.source);
},onTreeDblClick:function(_a){
this.onTreeClick(_a);
},checkSpecialEvent:function(_b){
return _b.shiftKey||_b.ctrlKey;
},onTreeClick:function(_c){
var _d=this.domElement2TreeNode(_c.target);
if(!_d){
return;
}
var _e=function(_f){
return _f===_d.labelNode;
};
if(this.checkPathCondition(_c.target,_e)){
this.processNode(_d,_c);
}
},processNode:function(_10,_11){
if(_10.actionIsDisabled(_10.actions.SELECT)){
return;
}
if(dojo.lang.inArray(this.selectedNodes,_10)){
if(this.checkSpecialEvent(_11)){
this.deselect(_10);
return;
}
var _12=this;
var i=0;
var _14;
while(this.selectedNodes.length>i){
_14=this.selectedNodes[i];
if(_14!==_10){
this.deselect(_14);
continue;
}
i++;
}
var _15=this.checkRecentClick(_10);
eventName=_15?this.eventNames.dblselect:this.eventNames.select;
if(_15){
eventName=this.eventNames.dblselect;
this.forgetLastClicked();
}else{
eventName=this.eventNames.select;
this.setLastClicked(_10);
}
dojo.event.topic.publish(eventName,{node:_10});
return;
}
this.deselectIfNoMulti(_11);
this.setLastClicked(_10);
this.select(_10);
},forgetLastClicked:function(){
this.lastClicked={};
},setLastClicked:function(_16){
this.lastClicked.date=new Date();
this.lastClicked.node=_16;
},checkRecentClick:function(_17){
var _18=new Date()-this.lastClicked.date;
if(this.lastClicked.node&&_18<this.dblselectTimeout){
return true;
}else{
return false;
}
},deselectIfNoMulti:function(_19){
if(!this.checkSpecialEvent(_19)||!this.allowedMulti){
this.deselectAll();
}
},deselectIfAncestorMatch:function(_1a){
var _1b=this;
dojo.lang.forEach(this.selectedNodes,function(_1c){
var _1d=_1c;
_1c=_1c.parent;
while(_1c&&_1c.isTreeNode){
if(_1c===_1a){
_1b.deselect(_1d);
return;
}
_1c=_1c.parent;
}
});
},onAfterDetach:function(_1e){
this.deselectIfAncestorMatch(_1e.child);
},select:function(_1f){
var _20=dojo.lang.find(this.selectedNodes,_1f,true);
if(_20>=0){
return;
}
this.selectedNodes.push(_1f);
dojo.event.topic.publish(this.eventNames.select,{node:_1f});
},deselect:function(_21){
var _22=dojo.lang.find(this.selectedNodes,_21,true);
if(_22<0){
return;
}
this.selectedNodes.splice(_22,1);
dojo.event.topic.publish(this.eventNames.deselect,{node:_21});
},deselectAll:function(){
while(this.selectedNodes.length){
this.deselect(this.selectedNodes[0]);
}
}});

